﻿#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

string minimizeNumber(string s, long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        int min_index = i;
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < s[min_index]) {
                min_index = j;
            }
        }

        long long shift_count = min_index - i;
        if (shift_count > 0 && k >= shift_count) {
            char min_char = s[min_index];
            for (int j = min_index; j > i; --j) {
                s[j] = s[j - 1];
            }
            s[i] = min_char;
            k -= shift_count;
        }
    }
    return s;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        cout << minimizeNumber(s, k) << "\n";
    }

    return 0;
}
