﻿#include <iostream>
#include <vector>

using namespace std;

bool is_wooden_matrix(int n, const vector<vector<int>>& matrix) {
    // Проверка неравенства треугольника для всех троек вершин
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (i != j && j != k && i != k) { // Только если все индексы разные
                    if (matrix[i][j] + matrix[j][k] < matrix[i][k] ||
                        matrix[i][k] + matrix[k][j] < matrix[i][j] ||
                        matrix[j][i] + matrix[i][k] < matrix[j][k]) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    if (is_wooden_matrix(n, matrix)) {
        cout << "Yes\n";
    }
    else {
        cout << "No\n";
    }

    return 0;
}
