Mod = 998244353 
 
def mod_inv(x, mod): 
    return pow(x, mod - 2, mod) 
 
def precompute_factorials_up_to(max_val, mod): 
    fact, inv_fact = [1] * (max_val + 1), [1] * (max_val + 1) 
    for i in range(2, max_val + 1): 
        fact[i] = fact[i - 1] * i % mod 
    inv_fact[max_val] = mod_inv(fact[max_val], mod) 
    for i in range(max_val - 1, 0, -1): 
        inv_fact[i] = inv_fact[i + 1] * (i + 1) % mod 
    return fact, inv_fact 
 
r, g, b = int(input()), int(input()), int(input()) 
n = r + g + b 
 
if max(r, g, b) > (n + 1) // 2: 
    print(0) 
else: 
    fact, inv_fact = precompute_factorials_up_to(n, Mod) 
     
    result = fact[n] * inv_fact[r] % Mod * inv_fact[g] % Mod * inv_fact[b] % Mod
     
    if r == g == b: 
        print(result) 
    else: 
        result = result * mod_inv(2, Mod) % Mod
        print(result)