#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool is_valid(const string& sequence) {
  for (int i = 0; i < sequence.length() - 1; ++i) {
    if (sequence[i] == sequence[i + 1]) {
      return false;
    }
  }
  return true;
}

vector<string> gen_seq(int r_left, int g_left, int b_left, string current_sequence) {
  vector<string> valid_seq;
  if (r_left == 0 && g_left == 0 && b_left == 0) {
    if (is_valid(current_sequence)) {
      valid_seq.push_back(current_sequence);
    }
    return valid_seq;
  }

  if (r_left > 0) {
    vector<string> new_seq = gen_seq(r_left - 1, g_left, b_left, current_sequence + "R");
    valid_seq.insert(valid_seq.end(), new_seq.begin(), new_seq.end());
  }
  if (g_left > 0) {
    vector<string> new_seq = gen_seq(r_left, g_left - 1, b_left, current_sequence + "G");
    valid_seq.insert(valid_seq.end(), new_seq.begin(), new_seq.end());
  }
  if (b_left > 0) {
    vector<string> new_seq = gen_seq(r_left, g_left, b_left - 1, current_sequence + "B");
    valid_seq.insert(valid_seq.end(), new_seq.begin(), new_seq.end());
  }

  return valid_seq;
}

int count_valid_seq(int r, int g, int b) {
  return gen_seq(r, g, b, "").size();
}

int main() {
  int r, g, b;
  cin >> r >> g >> b;
  cout << count_valid_seq(r, g, b) << endl;
  return 0;
}

