#include <iostream>
#include <vector>
#include <string>
#include <deque>

using namespace std;

string minimize_number(string s, int k) {
    int n = s.length();
    deque<int> dq;

    for (int i = 0; i < n; ++i) {
        while (!dq.empty() && dq.front() < i - k) {
            dq.pop_front();
        }

        while (!dq.empty() && s[dq.back()] >= s[i]) {
            dq.pop_back();
        }

        dq.push_back(i);

        if (dq.front() == i) {
            k -= (dq.front() - i);
            s.erase(i, 1);
            s.insert(i, 1, s[dq.front()]);
            dq.pop_front();
            --i;
        }
    }

    return s;
}

int main() {
    int t;
    cin >> t;
    cin.ignore();
    vector<string> results;

    for (int i = 0; i < t; ++i) {
        string line;
        getline(cin, line);
        size_t last_space = line.find_last_of(' ');
        string s = line.substr(0, last_space);
        int k = stoi(line.substr(last_space + 1));
        string result = minimize_number(s, k);
        results.push_back(result);
    }

    for (const string& res : results) {
        cout << res << endl;
    }

    return 0;
}