#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

string optimized_min_number(string s, long long k) {
    int n = s.size();

    for (int i = 0; i < n && k > 0; ++i) {
        // Находим минимальную цифру в пределах i + k
        int min_pos = i;
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < s[min_pos]) {
                min_pos = j;
            }
        }

        // Если минимальная позиция осталась прежней, пропускаем
        if (min_pos == i) continue;

        // Сдвигаем минимальную цифру на позицию i
        char min_value = s[min_pos];
        for (int j = min_pos; j > i; --j) {
            s[j] = s[j - 1]; // Перемещаем цифры влево
        }
        s[i] = min_value; // Ставим минимальную цифру на позицию i

        // Обновляем количество доступных перемещений
        k -= (min_pos - i);
    }

    return s;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        string result = optimized_min_number(s, k);
        cout << result << endl;
    }

    return 0;
}