#include <iostream>
#include <string>
#include <vector>
using namespace std;

void minimizeNumber(vector<pair<string, long long>>& test_cases) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    for (auto& test_case : test_cases) {
        string s = test_case.first;
        long long k = test_case.second;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            int min_index = i;
            for (int j = i + 1; j < n && j - i <= k; ++j) {
                if (s[j] < s[min_index]) {
                    min_index = j;
                }
            }

            if (min_index != i) {
                char min_digit = s[min_index];
                for (int j = min_index; j > i; --j) {
                    s[j] = s[j - 1];
                }
                s[i] = min_digit;
                k -= (min_index - i);
            }
        }

        cout << s << endl;
    }
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> test_cases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        test_cases[i] = {s, k};
    }

    minimizeNumber(test_cases);

    return 0;
}