#include <iostream>
#include <vector>

using namespace std;

bool isWoodenMatrix(int n, const vector<vector<int>>& matrix) {
    // Проверка на неравенство треугольника
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (matrix[i][j] > matrix[i][k] + matrix[k][j]) {
                    return false;
                }
            }
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    
    // Чтение матрицы
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    // Проверка на нули и положительные значения
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j && matrix[i][j] != 0) {
                cout << "No" << endl;
                return 0;
            }
            if (i != j && matrix[i][j] <= 0) {
                cout << "No" << endl;
                return 0;
            }
        }
    }

    // Проверка на неравенство треугольника
    if (isWoodenMatrix(n, matrix)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

    return 0;
}