#include <iostream>
#include <vector>
#include <limits>

using namespace std;

const long long INF = numeric_limits<long long>::max();

bool isWoodenMatrix_nuiza_chto(const vector<vector<long long>>& d, int n) {
    vector<vector<long long>> dist(n, vector<long long>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dist[i][j] = (i == j) ? 0 : d[i][j]; 
            if (dist[i][j] == 0 && i != j) {
                dist[i][j] = INF; 
            }
        }
    }

    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (dist[i][k] < INF && dist[k][j] < INF) {
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }
    }

   
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (dist[i][j] < INF) { 
                for (int k = 0; k < n; ++k) {
                    if (dist[i][k] < INF && dist[k][j] < INF) {
                        if (dist[i][j] > dist[i][k] + dist[k][j]) {
                            return false; 
                        }
                    }
                }
            }
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;

    if (n < 1 || n > 1000) {
        cout << "No" << endl; 
        return 0;
    }

    vector<vector<long long>> d(n, vector<long long>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];

           
            if (d[i][j] < 0 || d[i][j] > 1000000000) {
                cout << "No" << endl; 
                return 0;
            }
        }
    }

    if (isWoodenMatrix_nuiza_chto(d, n)) {
        cout << "Yes" << endl;
    }
    else {
        cout << "No" << endl;
    }

    return 0;
}

