﻿#include <iostream>
#include <vector>

using namespace std;

bool isWoodenMatrix_111(const vector<vector<long long>>& d, int n) {
    // Проверка неравенства треугольника
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (d[i][j] > d[i][k] + d[k][j]) {
                    return false; // Неравенство треугольника нарушено
                }
            }
        }
    }
    return true; // Все проверки пройдены
}

int main() {
    int n;
    cin >> n;

    // Проверка на ограничения для n
    if (n < 1 || n > 1000) {
        cout << "No" << endl; // Выводим "No", если n вне диапазона
        return 0;
    }

    vector<vector<long long>> d(n, vector<long long>(n));

    // Чтение матрицы с проверкой на ограничения
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> d[i][j];

            // Проверка на ограничения для элементов матрицы
            if (d[i][j] < 0 || d[i][j] > 1000000000) {
                cout << "No" << endl; // Выводим "No", если элемент вне диапазона
                return 0;
            }
        }
    }

    // Проверка, является ли матрица деревянной
    if (isWoodenMatrix_111(d, n)) {
        cout << "Yes" << endl;
    }
    else {
        cout << "No" << endl;
    }

    return 0;
}
