﻿#include <iostream>
#include <algorithm>

using namespace std;

const int MOD = 998244353;

long long factorial(int n) {
    long long result = 1;
    for (int i = 2; i <= n; ++i) {
        result = (result * i) % MOD;
    }
    return result;
}

long long modInverse(long long a, long long mod) {
    long long result = 1;
    long long exponent = mod - 2;
    while (exponent > 0) {
        if (exponent % 2 == 1) {
            result = (result * a) % mod;
        }
        a = (a * a) % mod;
        exponent /= 2;
    }
    return result;
}

long long countArrangements(int r, int g, int b) {
    int total = r + g + b;
    int maxCount = max({ r, g, b });
    int sumOthers = total - maxCount;

    // Проверка на возможность разместить шары
    if (maxCount > sumOthers + 1) {
        return 0;
    }

    // Вычисление количества способов
    long long totalWays = factorial(total);
    totalWays = (totalWays * modInverse(factorial(r), MOD)) % MOD;
    totalWays = (totalWays * modInverse(factorial(g), MOD)) % MOD;
    totalWays = (totalWays * modInverse(factorial(b), MOD)) % MOD;

    return totalWays;
}

int main() {
    int r, g, b;
    cin >> r >> g >> b;

    long long arrangements = countArrangements(r, g, b);
    cout << arrangements << endl;
    return 0;
}
