#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

struct Point {
    int x, y;
};

double triangleArea(const Point& p1, const Point& p2, const Point& p3) {
    return 0.5 * std::abs(p1.x * (p2.y - p3.y) + p2.x * (p3.y - p1.y) + p3.x * (p1.y - p2.y));
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> points[i].x >> points[i].y;
    }

    double maxArea = 0.0;

    for (int i = 0; i < n; ++i) {
        if (points[i].x == 0 || points[i].y == 0) {
            for (int j = i + 1; j < n; ++j) {
                if ((points[j].x == 0 && points[i].x == 0) || (points[j].y == 0 && points[i].y == 0)) {
                    for (int k = 0; k < n; ++k) {
                        if (k != i && k != j) {
                            double area = triangleArea(points[i], points[j], points[k]);
                            if (area > maxArea) {
                                maxArea = area;
                            }
                        }
                    }
                }
            }
        }
    }

    std::cout << std::fixed << std::setprecision(9) << maxArea << std::endl;

    return 0;
}