﻿#include <iostream>
#include <string>
#include <vector>
#include <queue>

using namespace std;

void minimize_string(string& s, long long k) {
    int n = s.size();
    vector<int> pos(n);
    for (int i = 0; i < n; ++i) pos[i] = i;

    for (int i = 0; i < n && k > 0; ++i) {

        char minChar = '9' + 1; 
        int minPos = -1;


        for (int j = i; j < n && j <= i + k; ++j) {
            if (s[j] < minChar) {
                minChar = s[j];
                minPos = j;
            }
        }


        if (minPos != -1 && minPos != i) {

            long long swapsNeeded = minPos - i;

            if (swapsNeeded <= k) {

                for (int j = minPos; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
                k -= swapsNeeded; 
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t; 
    cin >> t;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        minimize_string(s, k);
        cout << s << '\n'; 
    }

    return 0;
}
