#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = 1007;

int n;
int d[N][N];

int par[N], sz[N];

void build() {
  iota(par, par + n, 0);
  fill(sz, sz + n, 1);
}

int find(int i) {
  return par[i] == i ? i : par[i] = find(par[i]);
}

bool join(int i, int j) {
  i = find(i);
  j = find(j);
  if (sz[i] > sz[j]) {
    swap(i, j);
  }
  if (i != j) {
    par[i] = j;
    sz[j] += sz[i];
  }
  return i != j;
}

struct Edge {
  int v, u, w;
};

vector<Edge> g[N];

void dfs(int v, int last, int start, int w) {
  if (d[start][v] != w) {
    cout << "No\n";
    exit(0);
  }
  for (Edge e : g[v]) {
    if (e.u != last) {
      dfs(e.u, e.v, start, w + e.w);
    }
  }
}

void run_solve() {
  cin >> n;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> d[i][j];
    }
  }
  vector<Edge> edges;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < i; ++j) {
      edges.push_back({i, j, d[i][j]});
    }
  }
  sort(ALL(edges), [](Edge a, Edge b) { return a.w < b.w; });
  build();
  for (Edge e : edges) {
    if (join(e.v, e.u)) {
      g[e.v].push_back({e.v, e.u, e.w});
      g[e.u].push_back({e.u, e.v, e.w});
    }
  }
  for (int v = 0; v < n; ++v) {
    dfs(v, -1, v, 0);
  }
  cout << "Yes\n";
}