#include <iostream>
#include <vector>
#include <limits>

using namespace std;

void solve() {
  int n;
  cin >> n;
  if (n < 3) {
    cout << "Yes" << endl;
    return;
  }

  vector<vector<int>> M(n, vector<int>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      cin >> M[i][j];
    }
  }

  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      for (int k = 0; k < n; k++) {
        if (i != k && j != k && M[i][j] > M[i][k] + M[k][j]) {
          cout << "No" << endl;
          return;
        }
      }
    }
  }

  vector<bool> vis(n, false);
  vector<int> min_e(n, numeric_limits<int>::max());
  min_e[0] = 0;
  int mst_edges = 0;

  for (int i = 0; i < n; i++) {
    int u = -1;
    for (int v = 0; v < n; v++) {
      if (!vis[v] && (u == -1 || min_e[v] < min_e[u])) {
        u = v;
      }
    }

    if (min_e[u] == numeric_limits<int>::max()) {
      cout << "No" << endl;
      return;
    }

    vis[u] = true;
    mst_edges++;

    for (int v = 0; v < n; v++) {
      if (!vis[v] && M[u][v] < min_e[v]) {
        min_e[v] = M[u][v];
      }
    }
  }

  cout << (mst_edges == n ? "Yes" : "No") << endl;
}

int main() {
  solve();
  return 0;
}
