﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void minimize(string& s, long long k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        char minDigit = s[i];
        int minPos = i;

        for (int j = i + 1; j < n && j - i <= k; ++j) {
            if (s[j] < minDigit) {
                minDigit = s[j];
                minPos = j;
            }
        }
        if (minPos != i) {
            int count_of_swaps = minPos - i;
            if (count_of_swaps <= k) {
                for (int j = minPos; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
                k -= count_of_swaps;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<string> res;
    int t;
    cin >> t;
    string s;
    long long k;
    for (int i = 0; i < t; ++i) {
        cin >> s >> k;
        minimize(s, k);
        res.push_back(s);
    }
    for (auto& str : res)
        cout << str << endl;
    return 0;
}