import java.math.BigDecimal
import java.math.MathContext
import kotlin.math.abs
import kotlin.math.sqrt

fun main() {
    val n = readln().toInt()
    val v = (1..n).map {
        val (x, y) = readln().split(" ").map { it.toLong() }
        y to x
    }
    val v0 = v.filter { it.first == 0L }.sortedBy { it.first }
    if (v0.size < 2) {
        println(0)
        return
    }
    val d1 = v0.first()
    val d2 = v0.last()
    val d3 = v.filter { it.first != 0L }.maxByOrNull { abs(it.first) }
    if (d3 == null) {
        println(0)
        return
    }
    val area = area(d(d1), d(d2), d(d3))
    println(area)
}

fun d(p: Pair<Long, Long>) = Dot(p.first, p.second)

data class Dot(
    val x: Long, val y: Long
) {
    fun len2() = x * x + y * y

    infix fun scal(other: Dot) = x * other.x + y * other.y
    infix fun vec(other: Dot) = x * other.y - y * other.x

    operator fun plus(other: Dot) = Dot(x + other.x, y + other.y)
    operator fun minus(other: Dot) = Dot(x - other.x, y - other.y)
    operator fun times(other: Long) = Dot(x * other, y * other)

    //    operator fun div(other: Double) = Dot(x / other, y / other)
    operator fun unaryMinus() = Dot(-x, -y)

    override fun toString() = "$x $y"
}

val context = MathContext(50)
fun area(d1: Dot, d2: Dot, d3: Dot): BigDecimal {
    val a = (d1 - d2).len2().toBigDecimal(context).sqrt(context)
    val b = (d3 - d2).len2().toBigDecimal(context).sqrt(context)
    val c = (d1 - d3).len2().toBigDecimal(context).sqrt(context)
    val p = (a + b + c).divide(2.toBigDecimal(), context)
    val s = (p*(p-a)*(p-b)*(p-c)).sqrt(context)
    return s
}
