import kotlin.math.abs
fun binpow(a: Long, b: Long): Long {
    if (b == 0L) return 1
    if (b == 1L) return a
    val x: Long = binpow(a * a % mod, b / 2)
    if (b % 2 == 0L) return x
    return x * a % mod
}

fun rev(x: Long): Long {
    return binpow(x, mod - 2)
}
const val mod = 998244353L

val facts = run {
    val v = mutableListOf(1L, 1L)
    for (i in 2L..(1000000L))
        v.add((v.last() * i) % mod)
    v
}
val revs = facts.map { rev(it) }

fun fact(n: Long, mod: Long): Long {
    return facts[n.toInt()]
}

fun cnk(n: Long, k: Long): Long {
    return (((facts[n.toInt()] * revs[k.toInt()]) % mod) * revs[(n - k).toInt()]) % mod
}

fun ml(a: Long, b: Long, c: Long, d: Long, mod: Long, i: Int, x: Long): Long {
    val ans = (((((a * b) % mod) * c) % mod) * d) % mod
//    println("$a $b $c $d  $ans   x$x i$i")
    return ans
}

fun main() {
    val (r, g, b) = readln().split(" ").map { it.toLong() }
    val s = r+b
    val d = abs(r-b)
    var ans = 0L
    for (x in d..(g+1)) {
        if (abs(x - d) % 2 == 0L) {
            val y = g+1-x
            val a = (x-d)/2

            val d1 = binpow(2, y)
            val d2 = cnk(x, a)

            if ((s+x)/2 >= g+1) {
                ans += ml(d1, d2, cnk((s+x)/2 -1, g), cnk(g+1, x), mod, 1, x)
            }
            if (y >= 1 && g >= 1 && (s+x)/2 >= g) {
                ans += ml(d1, d2, cnk((s+x)/2 -1, g-1), cnk(g, x), mod, 2, x)
            }
            if (y >= 2 && g >= 2 && (s+x)/2 >= g-1) {
                ans += ml(binpow(2, y-2), d2, cnk((s+x)/2 -1, g-2), cnk(g-1, x), mod, 3, x)
            }
        }
    }
    println(ans % mod)
}
