// icpc-2024.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//


#include <iostream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;

using ll = long long;
using vll = vector<ll>;

using nd = struct {
    ll mn, ps;
};

nd op(nd a, nd b) {
    return a.mn > b.mn ? b : a;
}

class segtree {
public:
    vector<nd> v;
    ll n;

    segtree(const vll& src) {
        n = 1;

        while (n < src.size()) {
            n <<= 1;
        }

        v = vector<nd>(2 * n + 1, nd {1000000000, -1});

        for (int i = 0; i < src.size(); ++i)
            v[i + n - 1] = { src[i], i };

        for (int i = n - 2; i >= 0; --i)
            v[i] = op(v[2 * i + 1], v[2 * i + 2]);
    }

    nd qry(ll a, ll b) {
        return qry(a, b, 0, n, 0);
    }

    nd qry(ll l, ll r, ll lt, ll rt, ll i) {
        if (l == r)
            return { 100000000, -1 };

        if (l == lt && r == rt)
            return v[i];

        ll mt = (lt + rt) / 2;

        if (mt < l)
            return qry(l, r, mt, rt, 2 * i + 2);

        if (mt > r)
            return qry(l, r, lt, mt, 2 * i + 1);

        return op(qry(l, mt, lt, mt, 2 * i + 1), qry(mt, r, mt, rt, 2 * i + 2));
    }

    void cng(ll i, ll val) {
        i += n - 1;
        v[i] = { val, i - n + 1 };

        while (i)
            i = (i - 1) / 2,
                    v[i] = op(v[2 * i + 1], v[2 * i + 2]);
    }
};

int main()
{
    ll t;
    cin >> t;

    vll v;

    while (t--) {
        string s;
        cin >> s;

        v = vll(s.size());

        for (int i = 0; i < s.size(); ++i)
            v[i] = (s[i] - '0');

        ll k;
        ll n = v.size();
        cin >> k;

        segtree tr(v);
        ll i = 0;

        while (k > 0 && i < n) {
            auto mn = tr.qry(i, min(i + k + 1, n));
            k -= mn.ps - i;
            tr.cng(i, mn.mn);
            tr.cng(mn.ps, v[i]);
            v[mn.ps] = v[i];
            v[i] = mn.mn;
            ++i;
        }

        for (int i = 0; i < v.size(); ++i) {
            cout << v[i];
        }

        cout << "\n";
    }
}
