// icpc-2024.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//


#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <iterator>
#include <numeric>
#include <random>

using namespace std;

using ll = long long;
using vll = vector<ll>;

using val = ll;
val op(val l, val r) {
    return min(l, r);
}

val op(val l, val m, val r) {
    return op(l, op(m, r));
}

val nil = 1e10;

struct lict {
    lict* l;
    lict* r;
    ll x, y;
    val v, s;

    lict(ll y, val v) :
            l(NULL), r(NULL), x(1), y(y), v(v), s(v) {};
};

using pnd = lict*;

val s(pnd t) {
    return t ? t->s : nil;
}

ll x_(pnd t) {
    return t ? t->x : 0;
}

void rnw(pnd t) {
    if (t)
        t->s = op(s(t->l), t->v, s(t->r)),
                t->x = x_(t->l) + 1 + x_(t->r);
}


void split(pnd t, ll x, pnd& l, pnd& r, ll cum = 0) {
    if (!t)
        l = r = NULL;
    else {
        ll cur = cum + x_(t->l);
        if (cur >= x)
            split(t->l, x, l, t->l, cum), r = t;
        else
            split(t->r, x, t->r, r, cur + 1), l = t;
    }
    rnw(t);
}

void merge(pnd l, pnd r, pnd& t) {
    if (!l || !r)
        t = l ? l : r;
    else
    if (l->y < r->y)
        merge(l, r->l, r->l), t = r;
    else
        merge(l->r, r, l->r), t = l;
    rnw(t);
}

void insert(pnd& t, pnd it, ll pos) {
    pnd l, r;
    split(t, pos, l, r);
    merge(l, it, t);
    merge(t, r, t);
    rnw(t);
}

void minsplit(pnd t, pnd& l, pnd& m, pnd& r) {
    if (!t) {
        l = r = NULL;
        return;
    }

    if (s(t) == s(t->l)) {
        minsplit(t->l, l, m, t->l), r = t;
        rnw(t);
        return;
    }

    if (s(t) == t->v) {
        l = t->l, r = t->r, t->l = NULL, t->r = NULL, m = t;
        rnw(t);
        return;
    }

    minsplit(t->r, t->r, m, r), l = t;
    rnw(t);
}

void out(pnd t) {
    if (!t) return;

    out(t->l);
    cout << t->v;
    out(t->r);
}

int main()
{
    ll t;
    cin >> t;

    vll v;

    while (t--) {
        string s;
        cin >> s;

        v = vll(s.size());

        for (int i = 0; i < s.size(); ++i)
            v[i] = (s[i] - '0');

        ll k;
        ll n = v.size();
        vll ys(n);

        iota(ys.begin(), ys.end(), 0);
        std::random_device rd;
        std::mt19937 g(rd());
        std::shuffle(ys.begin(), ys.end(), g);

        cin >> k;

        ll i = 0;
        pnd t = nullptr;

        for (int i = 0; i < n; ++i)
            insert(t, new lict(ys[i], v[i]), i);

        while (k > 0 && i < n) {
            pnd l, ml, m, mr, r;
            split(t, i, l, t);
            split(t, i + k + 1, t, r);

            minsplit(t, ml, m, mr);

            k -= x_(ml);

            merge(l, m, t);
            merge(t, ml, t);
            merge(t, mr, t);
            merge(t, r, t);

            i++;
        }

        out(t);

        cout << "\n";
    }
}
