#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using lll = long long;

struct rat{
    lll p = 0, q = 1;

    rat(lll a = 0, lll b = 1){
        p = a, q = b;
        fix();
    }

    void fix(){
        lll g = gcd(abs(p), abs(q));
        if(g){
            p /= g;
            q /= g;
        }
        if(q < 0){
            p = -p;
            q = -q;
        }
    }

    rat operator+(rat other) const{
        lll g = gcd(abs(other.q), abs(q));
        other.q/=g;
        rat res = {p*other.q + (q/g)*other.p, q * other.q};
        res.fix();
        return res;
    }

    rat operator+=(rat other){
        rat res = *this + other;
        swap(res, *this);
        return *this;
    }

    rat operator-(rat other) const{
        other.p = -other.p;
        return *this + other;
    }

    rat operator-=(rat other){
        rat res = *this - other;
        swap(res, *this);
        return *this;
    }

    rat operator*(rat other) const{
        lll g1 = gcd(abs(p), other.q), g2 = gcd(abs(other.p), q);
        other.p /= g2, other.q /= g1;
        rat res = {(p/g1)*other.p, (q/g2)*other.q};
        return res;
    }

    rat operator*=(rat other){
        rat res = *this * other;
        swap(p, res.p), swap(q, res.q);
        return *this;
    }

    rat operator/=(rat other){
        swap(other.p, other.q);
        other.fix();
        *this *= other;
        return *this;
    }

    ld to_ld() const{
        return ld(p) / ld(q);
    }
};

ostream& operator<<(ostream& ostr, rat r){
    ostr<<ll(r.p)<<"/"<<ll(r.q);
    return ostr;
}

typedef rat num;

template<typename T, int n>
struct polynom{
    array<T, n> a;

    T& operator[](int i){
        return a[i];
    }

    polynom operator+=(polynom b){
        for (int i = 0; i < n; ++i) {
            a[i] += b[i];
        }
        return *this;
    }

    polynom operator+(polynom b) const{
        polynom res = *this;
        res += b;
        return res;
    }

    polynom operator-=(polynom b){
        for (int i = 0; i < n; ++i) {
            a[i] -= b[i];
        }
        return *this;
    }

    polynom operator-(polynom b) const{
        polynom res = *this;
        res -= b;
        return res;
    }

    polynom operator*(polynom b) const{
        polynom res;
        for (int i = 0; i < n; ++i) {
            for(int j = 0; j + i < n; ++j){
                res[i + j] += a[i] * b[j];
            }
        }
        return res;
    }

    polynom operator*=(polynom b){
        polynom res = *this * b;
        swap(*this, res);
        return *this;
    }

    polynom operator/=(T p){
        for (int i = 0; i < n; ++i) {
            a[i] /= p;
        }
        return *this;
    }

    polynom operator/(T p) const{
        polynom res = *this;
        res /= p;
        return res;
    }

    polynom operator*=(T p){
        for (int i = 0; i < n; ++i) {
            a[i] *= p;
        }
        return *this;
    }

    polynom operator*(T p) const{
        polynom res = *this;
        res *= p;
        return res;
    }

    polynom operator<<(int k) const{
        polynom res = *this;
        for (int i = n-1; i >= k; --i) {
            res.a[i] = res.a[i-k];
        }
        for (int i = 0; i < k; ++i) {
            res.a[i] = 0;
        }
        return res;
    }

    ld evaluate(ld x) const{
        //cout<<x<<" in "<<*this<<" =\n";
        ld res = 0;
        for (int i = n - 1; i >= 0; --i) {
            res = (res * x) + a[i].to_ld();
        }
        //cout<<res<<endl;
        return res;
    }

};

struct rng{
    ll mn = INT_MIN, mx = INT_MAX;

    void operator+=(rng b){
        mx = min(mx, b.mx);
        mn = max(mn, b.mn);
    }
};

typedef polynom<num, 64> pol;

ostream& operator<<(ostream& ostr, pol x){
    for (int i = 0; i < x.a.size(); ++i) {
        cout<<x[i]<<" ";
    }
    return ostr;
}

vector<pol> d, s, p;
vector<long double> fac;
vector<vector<ld>> t;

void precalc() {
    int n = 64;
    d.resize(n);
    s.resize(n);
    p.resize(n, {});
    fac.resize(n);
    t.resize(n);
    fac[0] = 1;
    for (int i = 1; i < n; ++i) {
        fac[i] = i * fac[i-1];
    }
    d[0] = s[0] = pol({1});
    //cout<<"s:"<<endl<<s[0]<<endl;
    for (int i = 1; i < n; ++i) {
        s[i] = s[i - 1] + (s[i - 1] << 1);
        //cout<<s[i]<<endl;
    }
    //cout<<"d:"<<endl<<d[0]<<endl;
    for (int i = 1; i < n; ++i) {
        d[i] = pol({1}) << i;
        d[i] /= i;
        pol t = s[i] / i - d[i];
        for (int j = 0; j < i - 1; ++j) {
            d[i] -= d[j + 1] * t[j];
        }
        //cout<<d[i]<<endl;
    }
    p[0] = {1};
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < 63; ++j) {
            p[i] += d[j + 1] * p[i-1][j];
        }
        p[i][0] = (i+1)%2;
        //cout<<i<<": "<<p[i]<<"\n";
    }
    for (int i = 0; i < n; ++i) {
        p[i] *= fac[i];
    }
    int pr = 1000;
    for (int i = 0; i < n; ++i) {
        t[i].resize(pr);
        t[i][0] = (i+1)%2;
    }
    for(int j = 0; j < pr; ++j){
        t[0][j] = 1;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < pr; ++j) {
            t[i][j] = t[i-1][j-1] + t[i][j-1];
        }
    }
}

void solve(){
    ll n, k;
    cin>>n>>k;
    if(n == 1){
        cout<<0<<"\n";
        return;
    }
    if(k > 31){
        int ans = 0;
        --n;
        while(n > 0){
            ++ans;
            n /= 2;
        }
        cout<<ans<<"\n";
        return;
    }
    if(k <= 4) {
        ll l = 0, r = 1ll << 31;
        while (r - l > 1) {
            ll m = (l + r) / 2;
            if (p[2 * k].evaluate(m) >= n * fac[2 * k]) {
                r = m;
            } else {
                l = m;
            }
        }
        cout << l << "\n";
        return;
    }
    ll l = 0, r = 1000;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (t[2*k][m] >= n) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << l << "\n";
}

int main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int n = 1;
    cin>>n;
    while(n--)
        solve();
}