#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
namespace r = ranges;
namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
#include "debug.h"
#define dbg(o) ({auto asldfj = o; cout << ANSI_BOLD_RED << #o << " = "; cp_debug::debug_(asldfj); asldfj;})
#else
#define debug(...) 533
#define dbg(o) (o)
#endif
#define all(o) o.begin(), o.end()

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

template<typename T> ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const auto &s : v) os << s << " ";
    return os;
}

template<typename T, typename U> ostream &operator<<(ostream &os, const pair<T, U> &v) {
    os << v.first << " " << v.second << " ";
    return os;
}

template<typename T> istream &operator>>(istream &is, vector<T> &v) {
    for (auto &s : v) is >> s;
    return is;
}

template<typename T, typename U> istream &operator>>(istream &is, pair<T, U> &s) {
    is >> s.first >> s.second;
    return is;
}

int gcd(int a, int b) {
    return __gcd(abs(a), abs(b));
}

struct SegmentTree {
    int n;
    vector<int> data;

    SegmentTree(const vector<int> &a) {
        n = 1;
        while (n < a.size()) {
            n *= 2;
        }
        data = vector(n * 2, 0);
        copy(all(a), data.begin() + n);
        for (int i = n - 1; i > 0; i--) {
            data[i] = gcd(data[i * 2], data[i * 2 + 1]);
        }
    }

    int get(int l, int r, int tl = 0, int tr = -1, int v = 1) {
        if (tr == -1) tr = n;
        if (l >= r) return 0;
        if (tl == l && r == tr) return data[v];
        int m = (tl + tr) / 2;
        int g1 = get(l, min(r, m), tl, m, v * 2);
        int g2 = get(max(l, m), r, m, tr, v * 2 + 1);
        return gcd(g1, g2);
    }
};

struct rmq_segtree {
    using T = pair<int, pair<int, pair<int, int>>>;
    int n;
    vector<T> t;

    rmq_segtree(): n(0) {
    }

    explicit rmq_segtree(const vector<T> &a) {
        n = static_cast<int>(a.size());
        t.resize(n << 1);
        build(a);
    }

    void build(const vector<T> &a) {
        for (int i = 0; i < n; i++) t[n + i] = a[i];
        for (int i = n - 1; i > 0; i--)
            t[i] = t[i << 1] < t[i << 1 | 1] ? t[i << 1] : t[i << 1 | 1];
    }

    [[nodiscard]] T query(int l, int r) const {
        r--;
        T res = make_pair(int(1e9), pair<int, pair<int, int>>{-1, {-1, -1}});
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = min(res, t[l++]);
            if (r & 1) res = min(res, t[--r]);
        }
        return res;
    }

    void set(int i, T x) {
        i += n;
        while (i > 0) {
            t[i] = min(t[i], x);
            i /= 2;
        }
    }
};

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    int n, s, f;
    cin >> n;
    vector<int> a(n);
    cin >> a >> s >> f;
    s--, f--;
    n = abs(f - s);
    vector<int> b(n);

    for (int i = 0; i < n; ++i) {
        b[i] = a[min(s, f) + i + 1] - a[min(s, f) + i];
    }
    if (s > f) {
        reverse(all(b));
    }

    // dbg(b);
    SegmentTree st(b);
    // dbg(st.data);

    vector<int> max_gcd(n);
    rmq_segtree rmq(vector<pair<int, pair<int, pair<int, int>>>>(n + 1, {(int)1e9, {-1, {-1, -1}}}));
    rmq.set(n, {0, {-1, {-1, -1}}});
    for (int i = n - 1; i >= 0; i--) {
        int l = i, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (st.get(i, m) != 1) {
                l = m;
            } else {
                r = m;
            }
        }
        // if (l == i) {
            // cout << "Impossible";
            // return;
        // }
        int gcd = st.get(i, l);
        auto [d, info] = rmq.query(i + 1, l + 1);
        auto [from_i, from] = info;
        rmq.set(i, {d + 1, {i, {from_i, gcd}}});
    }

    vector<rmq_segtree::T> result(n + 1);
    copy(rmq.t.begin() + rmq.n, rmq.t.end(), result.begin());
    // dbg(result);

    if (result[0].first >= 1e8) {
        cout << "Impossible";
        return;
    }

    int pos = 0;
    while (true) {
        auto [dist, info] = result[pos];
        auto [pos_too, from] = info;
        auto [next_pos, gcd] = from;
        assert(pos_too == pos);
        if (gcd == 0) gcd = 2;
        if (s < f) {
            cout << "Kaban-" << gcd << " " << s + pos + 1 << " " << (next_pos == -1 ? f + 1 : s + next_pos + 1) << "\n";
        } else {
            cout << "Kaban-" << gcd << " " << s - pos + 1 << " " << (next_pos == -1 ? f + 1 : s - next_pos + 1) << "\n";
        }
        if (next_pos == -1) break;
        pos = next_pos;
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../kolya.in"); // ofstream cout("kolya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (const auto i: v::iota(1) | v::take(test)) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    // cin >> test;
    for (const auto _: v::iota(0, test)) {
        solve(cin, cout);
    }
#endif
}
