#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(a) (int)a.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll rng(ll l, ll r) { return uniform_int_distribution<ll>(l, r)(rnd); }

const int INF = 1e9 + 7;

template<typename T, const T MOD>
struct modint {
    T val;
    modint(const T x = 0) {
        val = x % MOD;
        if (val < 0) val += MOD;
    }
    [[nodiscard]] modint binpow(modint x, T p) const {
        auto res = modint(1);
        while (p) {
            if (p & 1) res *= x;
            x *= x;
            p >>= 1;
        }
        return res;
    }
    [[nodiscard]] modint inv() const {
        return binpow(*this, MOD - 2);
    }
    modint operator+(const modint &x) const { return {val + x.val < MOD ? val + x.val : val + x.val - MOD}; }
    modint operator-(const modint &x) const { return {val - x.val < 0 ? val - x.val + MOD : val - x.val}; }
    modint operator*(const modint &x) const { return {(val * x.val) % MOD}; }
    modint operator/(const modint &x) const { return {(val * x.inv().val) % MOD}; }
    modint operator+=(const modint &x) { return *this = *this + x; }
    modint operator-=(const modint &x) { return *this = *this - x; }
    modint operator*=(const modint &x) { return *this = *this * x; }
    modint operator/=(const modint &x) { return *this = *this / x; }
    modint operator^(const modint &x) const { return binpow(*this, x.val); }
    bool operator==(const modint &x) const { return val == x.val; }
    bool operator!=(const modint &x) const { return val != x.val; }

    friend istream& operator>> (istream &in, modint &d) { return in >> d.val; }
    friend ostream& operator<< (ostream &out, const modint &d) { return out << d.val; }
};

typedef modint<ll, 998'244'353> mint;

constexpr int N = 2e5 + 5;
mint fact[N], invfact[N];

void precalc() {
    fact[0] = 1;
    for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i;
    invfact[N - 1] = fact[N - 1].inv();
    for (int i = N - 2; i >= 0; i--) invfact[i] = invfact[i + 1] * (i + 1);
}

mint C(const int n, const int k) {
    if (k < 0 || k > n) return 0;
    return fact[n] * invfact[k] * invfact[n - k];
}

void sol() {
    precalc();
    vector<int> x(3);
    for (auto &e : x) cin >> e;
    sort(all(x));
    mint r = x[0], g = x[1], b = x[2];
    mint res = 0;
    for (int i = 1; i < g.val + 1; ++i) {
        mint pos = C(r.val - 1, i);
        mint mul = C(g.val - 1, i - 1);
        mint dif = 2 * i;
        mint same = r + g - 1 - dif;
        mint last = C(dif.val + 2, b.val - same.val);
        res += pos * mul * last;
    }
    for (int i = 1; i < g.val + 1; ++i) {
        mint pos = C(r.val - 1, i - 1);
        mint mul = C(g.val - 1, i - 1);
        mint dif = 2 * i - 1;
        mint same = r + g - 1 - dif;
        mint last = C(dif.val + 2, b.val - same.val);
        res += mint(2) * pos * mul * last;
    }
    for (int i = 2; i < g.val + 1; ++i) {
        mint pos = C(r.val - 1, i - 2);
        mint mul = C(g.val - 1, i - 1);
        mint dif = 2 * i - 2;
        mint same = r + g - 1 - dif;
        mint last = C(dif.val + 2, b.val - same.val);
        res += pos * mul * last;
    }
    cout << res << endl;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    sol();
    return (0 - 0); // <3
}
