#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,avx,sse,sse2,sse3,ssse3,sse4,abm,mmx")
#pragma GCC march("native")

#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

pair<int, int> combine(pair<int, int> a, pair<int, int> b) {
    if (a.first <= b.first)
        return a;
    return b;
}

struct node {
    node *left, *right;
    pair<int, int> ans;

    node(int i, int x) {ans = {x, i}; left = nullptr; right = nullptr;}
    node(node* l, node* r) {left = l; right = r; update();}

    void update() {
        if (left == nullptr) return;
        ans = combine(left->ans, right->ans);
    }

    pair<int, int> get(int l, int r, int l_q, int r_q) {
        //cout << l << " " << r << " " << l_q << " " << r_q << endl;
        if (l_q >= r || r_q <= l) return {1000000000, -1};
        if (l_q <= l && r_q >= r) return ans;
        int m = (l + r) / 2;
        return combine(left->get(l, m, l_q, r_q), right->get(m, r, l_q, r_q));
    }

    void set(int l, int r, int i) {
        if (r - l == 1) {
            ans = {1000000000, l};
            return;
        }
        int m = (l + r) / 2;
        if (i < m)
            left->set(l, m, i);
        else
            right->set(m, r, i);
        update();
    }
};

node* build(string& a, int l, int r) {
    if (r - l == 1) return new node(l, a[l]);
    int m = (l + r) / 2;
    return new node(build(a, l, m), build(a, m, r));
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    int t;
    cin >> t;
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.length();
        node* root = build(s, 0, n);
        for (int i = 0; i < n; i++) {
            pair<int, int> ans = root->get(0, n, 0, min(n, k + 1));
            //cout << ans << endl;
            cout << (char) ans.first;
            root->set(0, n, ans.second);
            k = k + 1 - (ans.second - i);
        }
        cout << endl;
    }
}