const int INF = 1e9;

#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

typedef vector<vector<int> > vvi;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename F, typename S>
istream& operator>>(istream& in, pair<F, S>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a)
    {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

template <typename F, typename S>
ostream& operator<<(ostream& out, const pair<F, S>& p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
struct MaxF
{
    virtual inline T f(const T& x, const T& y)
    {
        if (x > y) return x;
        return y;
    }
};

template <typename T>
struct MaxAddCompF
{
    virtual inline void f(T& x, const T& y, const int& k)
    {
        x += y;
    }
};

template <typename T, typename MergeF, typename LazyF>
struct LazySegTree : protected MergeF, protected LazyF
{
    T* t;
    T def, nouse;
    int sz;
    T* push;

    LazySegTree(int _sz, T _def, T _nouse)
    {
        def = _def;
        nouse = _nouse;
        sz = _sz;
        t = new T[4 * sz];
        push = new T[4 * sz];
        for (int i = 0; i < 4 * sz; i++) t[i] = def, push[i] = nouse;
    }

    LazySegTree(T _def, T _nouse, vector<T>& elems)
    {
        def = _def;
        nouse = _nouse;
        sz = elems.size();
        t = new T[4 * sz];
        push = new T[4 * sz];
        for (int i = 0; i < 4 * sz; i++) t[i] = def;
        Build(0, sz, 0, elems);
        for (int i = 0; i < 4 * sz; i++) push[i] = nouse;
    }

    ~LazySegTree()
    {
        delete[] t;
        delete[] push;
    }

    inline void Push(int V, int L, int M, int R)
    {
        if (push[V] != nouse)
        {
            LazyF::f(t[2 * V + 1], push[V], M - L);
            LazyF::f(t[2 * V + 2], push[V], R - M);
            if (push[2 * V + 1] != nouse) LazyF::f(push[2 * V + 1], push[V], 1);
            else push[2 * V + 1] = push[V];
            if (push[2 * V + 2] != nouse) LazyF::f(push[2 * V + 2], push[V], 1);
            else push[2 * V + 2] = push[V];
            push[V] = nouse;
        }
    }

    inline void Build(int L, int R, int V, vector<T>& elems)
    {
        if (L + 1 == R)
        {
            t[V] = elems[L];
            return;
        }
        int M = (L + R) / 2;
        Build(L, M, 2 * V + 1, elems);
        Build(M, R, 2 * V + 2, elems);
        t[V] = MergeF::f(t[2 * V + 1], t[2 * V + 2]);
    }

    inline void Update(int l, int r, T val, int L, int R, int V)
    {
        if (l <= L && R <= r)
        {
            if (push[V] != nouse) LazyF::f(push[V], val, 1);
            else push[V] = val;
            LazyF::f(t[V], val, R - L);
            return;
        }
        int M = (L + R) / 2;
        Push(V, L, M, R);
        if (l <= L && M <= r)
        {
            if (push[2 * V + 1] != nouse) LazyF::f(push[2 * V + 1], val, 1);
            else push[2 * V + 1] = val;
            LazyF::f(t[2 * V + 1], val, M - L);
        }
        else if (l < M) Update(l, r, val, L, M, 2 * V + 1);
        if (l <= M && R <= r)
        {
            if (push[2 * V + 2] != nouse) LazyF::f(push[2 * V + 2], val, 1);
            else push[2 * V + 2] = val;
            LazyF::f(t[2 * V + 2], val, R - M);
        }
        else if (M < r) Update(l, r, val, M, R, 2 * V + 2);
        t[V] = MergeF::f(t[2 * V + 1], t[2 * V + 2]);
    }

    inline T Get(int l, int r, int L, int R, int V)
    {
        if (l <= L && R <= r) return t[V];
        int M = (L + R) / 2;
        if (L + 1 != R) Push(V, L, M, R);
        if (r <= M) return Get(l, r, L, M, 2 * V + 1);
        if (M <= l) return Get(l, r, M, R, 2 * V + 2);
        return MergeF::f(Get(l, r, L, M, 2 * V + 1), Get(l, r, M, R, 2 * V + 2));
    }

    inline pair<int, T> DepleteToRight(int l, T accum, T target, int L, int R, int V)
    {
        if (R <= l) return {sz, def};
        if (l <= L)
        {
            T x = MergeF::f(accum, t[V]);
            if ((x < target) == (accum < target))
                return {sz, x};
            if (L + 1 == R)
                return {L, x};
        }
        int M = (L + R) / 2;
        Push(V, L, M, R);
        pair<int, T> A = DepleteToRight(l, accum, target, L, M, 2 * V + 1);
        if (A.first != sz) return A;
        return DepleteToRight(l, A.second, target, M, R, 2 * V + 2);
    }

    inline pair<int, T> DepleteToLeft(int r, T accum, T target, int L, int R, int V)
    {
        if (r <= L) return {-1, def};
        if (R <= r)
        {
            T x = MergeF::f(t[V], accum);
            if ((x < target) == (accum < target))
                return {-1, x};
            if (L + 1 == R)
                return {L, x};
        }
        int M = (L + R) / 2;
        Push(V, L, M, R);
        pair<int, T> A = DepleteToLeft(r, accum, target, M, R, 2 * V + 2);
        if (A.first != -1) return A;
        return DepleteToLeft(r, A.second, target, L, M, 2 * V + 1);
    }

    inline void Update(int l, int r, T val)
    {
        Update(l, r + 1, val, 0, sz, 0);
    }

    inline void Update(int pos, T val)
    {
        Update(pos, pos + 1, val, 0, sz, 0);
    }

    inline T Get(int l, int r)
    {
        return Get(l, r + 1, 0, sz, 0);
    }

    inline T Get(int pos)
    {
        return Get(pos, pos + 1, 0, sz, 0);
    }

    inline int DepleteToRight(int l, T target)
    {
        pair<int, T> comp = DepleteToRight(l, def, target, 0, sz, 0);
        return comp.first;
    }

    inline int DepleteToLeft(int r, T target)
    {
        pair<int, T> comp = DepleteToLeft(r + 1, def, target, 0, sz, 0);
        return comp.first;
    }
};

template <typename T, template<typename> typename MergeF, template<typename> typename LazyF>
using lazysegtree = LazySegTree<T, MergeF<T>, LazyF<T> >;

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)

void solve()
{
    #define tests

    string s;
    long long k;
    cin >> s >> k;

    int n = s.size();

    vvi pos(9);
    forn(i, n) {
        pos[s[i] - '1'].push_back(i);
    }
    forn(i, 9) {
        pos[i].push_back(n);
    }

    lazysegtree<int, MaxF, MaxAddCompF> tree0(-INF, -INF-1, pos[0]);
    lazysegtree<int, MaxF, MaxAddCompF> tree1(-INF, -INF-1, pos[1]);
    lazysegtree<int, MaxF, MaxAddCompF> tree2(-INF, -INF-1, pos[2]);
    lazysegtree<int, MaxF, MaxAddCompF> tree3(-INF, -INF-1, pos[3]);
    lazysegtree<int, MaxF, MaxAddCompF> tree4(-INF, -INF-1, pos[4]);
    lazysegtree<int, MaxF, MaxAddCompF> tree5(-INF, -INF-1, pos[5]);
    lazysegtree<int, MaxF, MaxAddCompF> tree6(-INF, -INF-1, pos[6]);
    lazysegtree<int, MaxF, MaxAddCompF> tree7(-INF, -INF-1, pos[7]);
    lazysegtree<int, MaxF, MaxAddCompF> tree8(-INF, -INF-1, pos[8]);
    vector<lazysegtree<int, MaxF, MaxAddCompF>*> trees = {&tree0, &tree1, &tree2, &tree3, &tree4, &tree5, &tree6, &tree7, &tree8};

    vector<int> ans;
    for (int i = 0; i < n; i++) {
        int use = -1, usew = -1;
        for (int j = 0; j < 9; j++) {
            int w = trees[j]->DepleteToRight(0, i);
            int posw = trees[j]->Get(w);
            if (posw == n) {
                continue;
            }
            
            if (posw - i <= k && use == -1) {
                use = j;
                usew = posw;
                break;
            }
        }
        k -= usew - i;
        ans.push_back(use);
        for (int j = 0; j < 9; j++) {
            if (j == use) {
                int w = trees[j]->DepleteToRight(0, i);
                trees[j]->Update(w, -INF);
            } else {
                int w = trees[j]->DepleteToRight(0, usew);
                if (w) trees[j]->Update(0, w - 1, 1);
            }
        }
    }
    for (auto e : ans) cout << e + 1;
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
