//#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
#include <cstdint>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <functional>
#include <queue>
#include <fstream>
#include <random>
//#include <numbers>
#include <optional>
#include <deque>
#include <sstream>
#include <list>
#include <chrono>
#include <thread>

using namespace std;
using i64 = int64_t;
using ui64 = uint64_t;

#define YN(b) if (b) cout << "Yes\n"; else cout << "No\n";

template<typename T>
istream& operator>>(istream& is, vector<T>& v) { for (auto &e: v) { is >> e; } return is; }

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) { for (auto &e: v) { os << e << " "; } return os; }

template<typename T, typename V>
istream& operator>>(istream& is, pair<T, V>& v) { return is >> v.first >> v.second; }

template<typename T, typename V>
ostream& operator<<(ostream& os, pair<T, V>& v) { return os << v.first << " " << v.second; }

const int64_t md = 1e9+7;

int64_t binpow(int64_t a, int64_t b, int64_t mod = md) {
    int64_t r = 1;
    while (b) {
        if (b & 1) r = ((__int128_t)r * a) % mod;
        a = ((__int128_t)a * a) % mod;
        b >>= 1;
    }
    return r;
}

int dx[4] = {-1, 0, 1, 0};

inline int64_t sqr(int64_t x) {
    return x * x;
}

inline int popcount(int64_t x) {
    int c = 0;
    while (x) c += x & 1, x >>= 1;
    return c;
}

optional<int> dp[65][65][65][65][2];

vector<pair<char, char>> kor = {{-1, -1}, {-1, 0}, {-1, 1}, {0, 1}, {0, -1}, {1, 1}, {1, 0}, {1, -1}};
vector<pair<char, char>> wiz = {{0, -1}, {-1, 0}, {1, 0}, {0, 1}};
vector<pair<char, char>> cam = {{-1, -3}, {1, -3}, {-3, -1}, {3, -1}, {-3, 1}, {3, 1}, {-1, 3}, {1, 3}};
pair<char, char> get(char x) {
    return {x >> 3, x & 7};
}

int to(char x, char y) {
    return (x << 3) + y;
}
string pr(int x) {
    if (x == 64) {
        return "#";
    }
    stringstream ss;
    ss << (char)('a' + x / 8);
    ss << 1 + (x % 8);
    return ss.str();
}

vector<vector<pair<char, char>>> hod = {kor, wiz, cam};
char avail[8][8];

void fill(char pos, int type) {
    if (pos == 64) return;
    auto p = get(pos);
    //avail[p.first][p.second] = 1;
    for (auto &e: hod[type]) {
        int ni = p.first + e.first;
        int nj = p.second + e.second;
        if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
        avail[ni][nj] = 1;
    }
}

int pos(const string& s) {
    return (s[0] - 'a') * 8 + (s[1] - '1');
}

struct st {
    char b_kor;
    char w_kor;
    char w_wiz;
    char w_cam;
    char turn;
    optional<int>& get() {
        return dp[b_kor][w_kor][w_wiz][w_cam][turn];
    }
    void print() const {
        cout << pr(b_kor) << " " << pr(w_kor) << " " << pr(w_wiz) << " " << pr(w_cam) << " " << +turn << "\n";
    }
};

optional<st> from[65][65][65][65][2];
optional<st>& gfr(const st& s) {
    return from[s.b_kor][s.w_kor][s.w_wiz][s.w_cam][s.turn];
}

void mark(int c) {
    if (c == 64) return;
    avail[c >> 3][c & 7] = 1;
}

signed main() {
    /*ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/
    queue<st> q;
    for (char b_kor = 0; b_kor < 64; ++b_kor) {
        auto p = get(b_kor);
        for (char w_kor = 0; w_kor < 64; ++w_kor) {
            if (b_kor == w_kor) continue;
            for (char w_wiz = 0; w_wiz < 65; ++w_wiz) {
                if (b_kor == w_wiz || w_kor == w_wiz) continue;
                for (char w_cam = 0; w_cam < 65; ++w_cam) {
                    if (w_cam != 64 && (b_kor == w_cam || w_kor == w_cam || w_wiz == w_cam)) continue;
                    for (int i = 0; i < 8; ++i) {
                        for (int j = 0; j < 8; ++j) {
                            avail[i][j] = 0;
                        }
                    }
                    fill(w_kor, 0);
                    fill(w_wiz, 1);
                    fill(w_cam, 2);
                    
                    int a = 0;
                    for (auto &e: hod[0]) {
                        int ni = p.first + e.first;
                        int nj = p.second + e.second;
                        if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
                        if (to(ni, nj) == w_kor) a = 10;
                        if (avail[ni][nj]) continue;
                        ++a;
                    }
                    if (!a && avail[p.first][p.second]) {
                        q.emplace(st{b_kor, w_kor, w_wiz, w_cam, 1});
                        q.back().get() = 0;
                    }
                }
            }
        }
    }
    while (q.size()) {
        auto z = q.front();
        q.pop();
        /*if (z.b_kor != to(5, 0) || z.w_kor != to(5, 2) || z.w_wiz != to(5, 1) || z.w_cam != to(5, 3)) {
            continue;
        }*/
        auto val = z.get();
        for (int i = 0; i < 8; ++i) {
            for (int j = 0; j < 8; ++j) {
                avail[i][j] = 0;
            }
        }
        if (z.turn == 1) {
            mark(z.w_kor);
            mark(z.w_wiz);
            mark(z.w_cam);
            mark(z.b_kor);
            for (auto [pos, t]: vector<pair<char, char>>{{z.w_wiz, 1}, {z.w_cam, 2}, {z.w_kor, 0}}) {
                if (t == 0) {
                    fill(z.b_kor, 0);
                }
                if (pos == 64) continue;
                auto p = get(pos);
                for (auto &h: hod[t]) {
                    char ni = p.first + h.first;
                    char nj = p.second + h.second;
                    if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
                    if (avail[ni][nj]) continue;
                    st ss;
                    char ps = to(ni, nj);
                    if (t == 0) {
                        ss = st{z.b_kor, ps, z.w_wiz, z.w_cam, 0};
                    } else if (t == 1) {
                        ss = st{z.b_kor, z.w_kor, ps, z.w_cam, 0};
                    } else {
                        ss = st{z.b_kor, z.w_kor, z.w_wiz, ps, 0};
                    }
                    auto& v = ss.get();
                    if (!v) {
                        gfr(ss) = z;
                        v = 1 + *val;
                        q.emplace(ss);
                    }
                }
            }
        } else {
            fill(z.w_kor, 0);
            fill(z.w_wiz, 1);
            fill(z.w_cam, 2);
            auto p = get(z.b_kor);
            for (auto &h: hod[0]) {
                char ni = p.first + h.first;
                char nj = p.second + h.second;
                if (ni < 0 || nj < 0 || ni > 7 || nj > 7) continue;
                if (avail[ni][nj]) continue;
                char ps = to(ni, nj);
                st ss = st{ps, z.w_kor, ps == z.w_wiz ? (char)64 : z.w_wiz, ps == z.w_cam ? (char)64 : z.w_cam, 1};
                auto& v = ss.get();
                if (!v) {
                    gfr(ss) = z;
                    v = 1 + *val;
                    q.emplace(ss);
                }
            }
        }
    }
    int t;
    cin >> t;
    while (t--) {
        string w_kors, b_kors, w_cams, w_wizs, turns;
        cin >> w_kors >> b_kors >> w_cams >> w_wizs >> turns;
        char w_kor = pos(w_kors);
        char w_cam = pos(w_cams);
        char w_wiz = pos(w_wizs);
        char b_kor = pos(b_kors);
        char turn = turns == "b";
        auto s = st {b_kor, w_kor, w_wiz, w_cam, turn};
        if (s.get()) {
            auto v = gfr(s);
            while (v) {
                v->print();
                v = gfr(*v);
            }
            cout << "#" << *s.get() << "\n";
        } else {
            cout << "0\n";
        }
    }
}
