#include <bits/stdc++.h>
using namespace std;
using ll = long long;

/* Sparse Table {{{ */ 
struct SparseTable {
    vector<vector<int>> spt;

    SparseTable (vector<int>& arr) {
        int n = arr.size();
        int maxpow = __lg(n) + 1;
        spt.assign(maxpow, vector<int>(n, 0));
        spt[0] = arr;
        for (int k = 0; k + 1 < maxpow; k++) {
            for (int ind = 0; ind + (1 << k) < n; ind++) {
                spt[k + 1][ind] = gcd(spt[k][ind], spt[k][ind + (1 << k)]);
            }
        }
    }

    int get(int l, int r) { /* [l, r) */
        int power = __lg(r - l);
        return gcd(spt[power][l], spt[power][r - (1 << power)]);
    }
};
/* }}} */

int main() {
    /*ios::sync_with_stdio(false);*/
    /*cin.tie(NULL);*/

    int n;
    cin >> n;
    vector<int> c(n);
    for (int& i : c) cin >> i;
    int s, f;
    bool sw = s > f;
    cin >> s >> f;
    if (s > f) swap(s, f);
    f--;
    s--;
    int m = f - s + 1;
    cout << m << "\n";
    vector<int> a(m), b(m - 1);
    for (int i = s; i <= f; i++) {
        a[i - s] = c[i];
    }
    for (int i = 0; i < m - 1; i++) {
        b[i] = abs(a[i] - a[i + 1]);
        if (b[i] == 1) {
            cout << "Impossible\n";
            return 0;
        }
    }
    SparseTable spt(b);
    int pos = 0;
    int q;
    while (pos < m) {
        int l = pos;
        int r = m;
        while (r - l > 1) {
            int k = (l + r) / 2;
            int g = spt.get(pos, m + 1);
            if (g > 1) {
                l = k;
            } else {
                r = k;
            }
        }
        pos = l;
        q++;
    }
    cout << q << "\n";
}
