

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


unordered_map<bitset<7>, int> map1;
unordered_map<int, bitset<7>> map2;

bitset<7> empty_di;

void init()
{
    for (int x = 0; x < 10; x++) {
    bitset<7> res;
    switch (x)
    {
    case 0:
        res[2] = res[0] = res[6] = res[1] = res[5] = res[7] = 1;
        break;
    case 1:
        res[2] = res[5] = 1;
        break;
    case 2:
        res[0] = res[2] = res[3] = res[4] = res[6] = 1;

        break;
    case 3:
        res[0] =res[2] = res[3] = res[5] = res[6] = 1;

        break;
    case 4:
        res[1] = res[2] = res[3] =res[5] = 1;

        break;
    case 5:
        res[0] = res[1] = res[3] = res[5] = res[6] = 1;

        break;
    case 6:
        res[0] = res[1] = res[3] = res[4] = res[5] = res[6] = 1;
        break;
    case 7:
        res[0] =  res[2] =  res[5] = 1;

        break;
    case 8:
        res[0] = res[1] = res[2] = res[3] = res[4] = res[5] = res[6] = 1;
        break;
    case 9:
        res[0] = res[1] = res[2] = res[3] = res[5] = res[6] = 1;
        break;
    }
    map1[res] = x;
    map2[x]  = res;
    }
}



pair<bitset<7>, bitset<7>> display(int x)
{
    if (x < 10)
    {
        return make_pair(empty_di, map2[x]);
    }
    else {
        return make_pair(map2[x / 10], map2[x % 10]);
    }
}

bool correct_undisplay(pair<bitset<7>, bitset<7>> x)
{
    if (x.first == empty_di)
    {
        return map1.find(x.second) != map1.end();
    }
    else {
        return map1.find(x.first) != map1.end() && 
            map1.find(x.second) != map1.end();
    }
}

int undisplay(pair<bitset<7>, bitset<7>> x)
{
    if (x.first == empty_di)
    {
        return map1[x.second];
    }
    else {
        return map1[x.first] * 10 + map1[x.second];
    }
}

int whatshows(int x, bitset<7> mask1, bitset<7> mask2)
{
    auto t = display(x);
    if (!correct_undisplay(make_pair(t.first & mask1, t.second & mask2)))
    {
        return 10000;
    }
    return undisplay(make_pair(t.first & mask1, t.second & mask2));
}

void solve() {
    string a;
    string b;
    cin >> a >> b;
    bitset<7> mask1;
    bitset<7> mask2;
    rep(i, 7) if (a[i] == '1') mask1[i] = true;
    rep(i, 7) if (b[i] == '1') mask2[i] = true;

    init();
    int ans = 0;

    // cout << whatshows(37, mask1, mask2) << endl;

    for (int y = 99; y >= 2; y--)
    {
        int prev_x = whatshows(y, mask1, mask2);
        for (int k = 1; k + 1 <= y; k++)
        {
            int cur_x = whatshows(y - k, mask1, mask2);
            if (cur_x != prev_x + 1)
            {
                break;
            }
            else {
                ans = max(ans, k);
            }
        }
    }
    cout << ans;
}
