

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


template<typename C>
class fenwick {
  vector<C> t;
  int n;
public:
  fenwick(int _n = 0) : n(_n) {
    t.resize(n);
  }
  fenwick(const vector<C>& a) : n(a.size()) {
    t.resize(n);
    for (int i = 0; i < n; ++i) {
      upd(i, a[i]);
    }
  }

  C get(int k) {
    C res = 0;
    for (k; k >= 0; k = (k & (k + 1)) - 1) {
      res += t[k];
    }
    return res;
  }

  void upd(int k, C x) {
    for (k; k < n; k |= k + 1) {
      t[k] += x;
    }
  }

  C get(int l, int r) {
    return get(r) - get(l - 1);
  }
};

void solve() {
  int t;
  cin >> t;
  while (t--) {
    string s;
    long long k;
    cin >> s >> k;
    int n = s.size();
    vector<vector<int>> pos(10);
    for (int i = 0; i < n; ++i) {
        pos[s[i] - '0'].push_back(i);
    }
    for (int i = 1; i < 10; ++i) {
        reverse(begin(pos[i]), end(pos[i]));
    }
    string ans;
    vector<int> shift;
    fenwick<int> tr(n);
    for (int i = 0; i < n; ++i) {
        for (int d = 1; d < 10; ++d) {
            if (empty(pos[d])) continue;
            int ind = pos[d].back();
            int moves = ind - i + tr.get(ind + 1, n - 1);
            if (moves <= k) {
                k -= moves;
                ans += d + '0';
                tr.upd(ind, 1);
                pos[d].pop_back();
                break;
            }
        }
    }
    cout << ans << '\n';
  }
}
