

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H


#ifndef MODULO_H
#define MODULO_H

#include <iostream>
#include <vector>
#include <cmath>
#include <cstddef>
#include <stdexcept>
#include <memory>

namespace modulo {

using std::vector;

template<long long M>
class Mod;

template<long long M>
Mod<M> operator+(Mod<M> a, Mod<M> b);
template<long long M>
Mod<M> operator-(Mod<M> a, Mod<M> b);
template<long long M>
Mod<M> operator*(Mod<M> a, Mod<M> b);
template<long long M>
Mod<M> operator/(Mod<M> a, Mod<M> b);


template<long long M>
class Mod {
public:
    static Mod fact(size_t n) {
        static vector<Mod> _fact;
        if (_fact.empty())
            _fact = {1};
        while (_fact.size() <= n) {
            _fact.push_back(_fact.back() * _fact.size());
        }
        return _fact[n];
    }

    static Mod<M> inv_fact(size_t n) {
        static vector<Mod> _inv_fact;
        if (_inv_fact.empty())
            _inv_fact = {1};
        while (_inv_fact.size() <= n) {
            _inv_fact.push_back(_inv_fact.back() / Mod<M>(_inv_fact.size()));
        }
        return _inv_fact[n];
    }

    Mod(long long x) {
        if (x < 0) {
            x %= M;
            x += M;
        }
        val = x % M;
    }

    Mod() : val(0) {}

    operator long long() { return val; }

    Mod operator+=(Mod<M> other) { return *this = *this + other; }
    Mod operator-=(Mod<M> other) { return *this = *this - other; }
    Mod operator*=(Mod<M> other) { return *this = *this * other; }
    Mod operator/=(Mod<M> other) { return *this = *this / other; }

    long long val;
};

template<long long M>
bool operator==(Mod<M> a, Mod<M> b) {
    return a.val == b.val;
}

template<long long M>
Mod<M> operator+(Mod<M> a, Mod<M> b) {
    return (a.val + b.val) % M;
}

template<long long M>
Mod<M> operator-(Mod<M> a) {
    return (M - a.val) % M;
}

template<long long M>
Mod<M> operator-(Mod<M> a, Mod<M> b) {
    return (a.val - b.val + M) % M;
}

template<long long M>
Mod<M> operator*(Mod<M> a, Mod<M> b) {
    return (1ll * a.val * b.val) % M;
}

template<long long M>
Mod<M> pow(Mod<M> a, long long pwr) {
    if (pwr == 0) return 1;
    return pow(a * a, pwr >> 1) * (pwr & 1ll ? a : Mod<M>(1));
}

template<long long M>
Mod<M> inv(Mod<M> a) {
    return pow(a, M - 2);
}

template<long long M>
Mod<M> operator/(Mod<M> a, Mod<M> b) {
    return a * inv(b);
}

template<long long M>
Mod<M> C(int n, int k) {
    Mod<M> res = Mod<M>::fact(n) * Mod<M>::inv_fact(k) * Mod<M>::inv_fact(n - k);
    return res;
}

template<long long M>
Mod<M> Crep(int n, int k) {
    return C<M>(n + k - 1, k);
}

} // namespace modulo

#endif // MODULO_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


using namespace modulo;
constexpr ll MOD = 998'244'353;
using M = Mod<MOD>;

M part(int n, int k) {
    return Crep<MOD>(n + 1, k - 1);
}

M get(int g, int b, int k) {
    if (k == 0) {
        return M(0);
    }
    int dlt = g - b;
    M ans = 0;
    for (int e = (g + b + k) % 2; e <= k; e += 2) {
        int o = k - e;
        int from_g = (o + dlt) / 2;
        if (from_g < 0 || from_g > o || o < 0 || 2 * e + o > g + b) continue;
        M partitions = C<MOD>(k, o) * part((g + b - o) / 2 - e, k);
        M ways = pow(M(2), e) * C<MOD>(o, from_g);
        ans = ans + partitions * ways;
    }
    return ans;
}

void solve() {
    int r, g, b;
    cin >> r >> g >> b;
    M ans = get(g, b, r - 1) + 2 * get(g, b, r) + get(g, b, r + 1);
    cout << ans << endl;
}
