#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <bits/stdc++.h>

#define int long long

using namespace std;

const int maxn = 1005;
vector <int> p(maxn, 0), h(maxn, 1);
vector <pair <int, int> > g[maxn];
vector <bool> used(maxn, false);

int get(int v){
    if(v == p[v])
        return v;
    p[v] = get(p[v]);
    return p[v];
}

void uni(int u, int v){
    u = get(u);
    v = get(v);
    if(u == v)
        return;
    if(h[u] < h[v])
        swap(u, v);
    if(h[u] == h[v])
        h[u]++;
    p[v] = u;
}

vector <int> find_d(int st){
    int inf = 1000000000000000;
    vector <int> d(maxn, inf);
    d[st] = 0;
    priority_queue <pair <int, int> > q;
    q.push({0, st});
    while(q.size() > 0){
        auto cu = q.top();
        q.pop();
        int cd = -cu.first, u = cu.second;
        if(cd != d[u])
            continue;
        for(auto e: g[u]){
            int v = e.first, c = e.second;
            if(cd + c < d[v]){
                d[v] = cd + c;
                q.push({-d[v], v});
            }
        }
    }
    return d;
}

signed main() {
    int n;
    cin >> n;
    int ans = 0;
    vector <pair<int, pair <int, int> >> edges;
    vector <vector <int> > mat(n, vector <int> (n, 0));
    for(int i = 0; i < n; ++i){
        p[i] = i;
        for(int j = 0; j < n; ++j){
            int x;
            cin >> x;
            mat[i][j] = x;
            if(x > 0 && i < j) {
                edges.push_back({x, {i, j}});
            }
        }
    }
    sort(edges.begin(), edges.end());
    for(auto e:edges){
        int c = e.first, u = e.second.first, v = e.second.second;
        if(get(u) != get(v)){
            uni(u, v);
            g[u].push_back({v, c});
            g[v].push_back({u, c});
        }
    }
    bool chk = true;
    for(int i = 0; i < n; ++i){
        auto d = find_d(i);
        for(int j = 0; j < n; ++j){
            chk &= (d[j] == mat[i][j]);
        }
    }
    if(chk)
        cout << "Yes\n";
    else
        cout << "No\n";
    return 0;
}
//
