indicators = {
    "1110111": 0, "0010010": 1, "1011101": 2, "1011011": 3, "0111010": 4,
    "1101011": 5, "1101111": 6, "1010010": 7, "1111111": 8, "1111011": 9
}
def get_display_digit(segment, mask):
    for pattern, digit in indicators.items():
        if (int(pattern, 2) & mask) == segment:
            return digit
    return -1


def main():
    broken_first = input().strip()
    broken_second = input().strip()

    mask_first = int(broken_first, 2)
    mask_second = int(broken_second, 2)

    max_k = 0

    for y in range(99, 0, -1):
        k = 0
        valid = True

        while valid and (y - k > 0):
            left_real = (y - k) // 10
            right_real = (y - k) % 10

            left_displayed = get_display_digit(int(list(indicators.keys())[left_real], 2), mask_first)
            right_displayed = get_display_digit(int(list(indicators.keys())[right_real], 2), mask_second)

            if left_displayed == -1 or right_displayed == -1:
                valid = False
            elif (left_displayed, right_displayed) != (y // 10, y % 10):
                valid = False
            else:
                k += 1

        max_k = max(max_k, k)

    print(max_k)


main()
