digit_segments = {
    0: 0b1110111, 1: 0b0010010, 2: 0b1011101, 3: 0b1011011,
    4: 0b0111010, 5: 0b1101011, 6: 0b1101111, 7: 0b1010010,
    8: 0b1111111, 9: 0b1111011
}

state_first_digit = int(input().strip(), 2)
state_second_digit = int(input().strip(), 2)

def get_possible_digits(segment_state, digit_segments):
    return {digit for digit, segments in digit_segments.items() if (segments & segment_state) == segments}


possible_first_digit = get_possible_digits(state_first_digit, digit_segments)
possible_second_digit = get_possible_digits(state_second_digit, digit_segments)

def get_display_digit(number):
    tens, units = divmod(number, 10)
    if tens in possible_first_digit and units in possible_second_digit:
        return 10 * tens + units
    return None

max_illusion_length = 0

for start_number in range(99, 0, -1):
    illusion_length = 0
    current_number = start_number
    while current_number > 0:
        displayed = get_display_digit(current_number)
        if displayed is None or displayed != get_display_digit(current_number + illusion_length):
            break

        illusion_length += 1
        current_number -= 1

    max_illusion_length = max(max_illusion_length, illusion_length)

print(max_illusion_length)
