#include <bits/stdc++.h>
#include <cmath>

const int MOD = 998244353;

#define ll long long

ll mod_pow(ll base, ll exp, int mod) {
    ll result = 1;
    while (exp > 0) {
        if (exp % 2 == 1) {
            result = (result * base) % mod;
        }
        base = (base * base) % mod;
        exp /= 2;
    }
    return result;
}

ll f(int n) {
    ll res = 1;
    for (int i = 2; i <= n; ++i) {
        res = (res * i) % MOD;
    }
    return res;
}

ll bin(int n, int k) {
    if (k < 0 || k > n) return 0;

    ll num = f(n);
    ll denom = (f(k) * f(n - k)) % MOD;
    
    ll inverse = mod_pow(denom, MOD - 2, MOD);

    return (num * inverse) % MOD;
}

ll res(int R, int B, int G) {
    int t = R + B + G;
    ll result = 0;

    for (int k = 0; k <= t; ++k) {
        ll inner_sum = 0;

        for (int k_R = 0; k_R <= k; ++k_R) {
            for (int k_B = 0; k_B <= k - k_R; ++k_B) {
                int k_G = k - k_R - k_B;
                if (k_G < 0 || k_R > R - 1 || k_B > B - 1 || k_G > G - 1) continue;

                ll term = (bin(R - 1, k_R) * bin(B - 1, k_B) % MOD * bin(G - 1, k_G) % MOD *
                                  f(t - k) % MOD *
                                  mod_pow(f(R - k_R) * f(B - k_B) % MOD * f(G - k_G) % MOD, MOD - 2, MOD)) % MOD;

                inner_sum = (inner_sum + term) % MOD;
            }
        }

        result = (result + (k % 2 == 0 ? inner_sum : MOD - inner_sum)) % MOD;
    }

    return result;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    int R, B, G;
    std::cin >> R >> B >> G;
    std::cout << res(R, B, G) << std::endl;
    return 0;
}
