
#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <bitset>
#include <cassert>
#include <chrono>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <initializer_list>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <stdexcept>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int inf = (int)2e9;
const ll linf = (ll)2e18;

const ll mod = (ll)1e9 + 7ll;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll gcd(ll a, ll b) {
	while (b != 0) {
		swap(a %= b, b);
	}
	return a;
}

ll C(ll n, ll k) {
	if (k > n) {
		return 0ll;
	}

	ll ans = 1ll;

	int m = n - k + 1;
	for (int i = 1; i <= k; ++i, ++m) {
		int j = i / gcd(ans, i);
		ans /= gcd(ans, i);
		ll l = m / j;

		if (ans >= (linf) / l) {
			return linf;
		}
		else {
			ans *= l;
			if (ans >= linf) {
				return linf;
			}
		}
	}

	return ans;
}

int get_amount_of_less(vector<int>& a, int x) {
	int l = -1;
	int r = a.size();
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (a[m] < x) l = m;
		else r = m;
	}
	return l + 1;
}

void solve() {
	/*unordered_map<int, vector<int>> d;
	unordered_map<int, int> first_indexes;
	for (int i = 1; i <= 9; ++i) {
		d[i] = {};
		first_indexes[i] = 0;
	}
	string s; cin >> s;
	int k; cin >> k;

	for (int i = 0; i < s.size(); ++i) {
		d[(int)s[i] - (int)('0')].push_back(i);
	}

	set<int> v = {};

	string new_s = "";

	for (int cur = 0; cur < s.size(); ++cur) {
		for (int num_to_move = 1; num_to_move <= 9; ++num_to_move) {
			if (first_indexes[num_to_move] < d[num_to_move].size()) {
				int pos = d[num_to_move][first_indexes[num_to_move]];
				int t = pos - get_amount_of_less(v, pos);
				if (t <= k) {
					k -= t;
					v.insert(pos);
					new_s += char('0' + num_to_move);
					first_indexes[num_to_move]++;
					break;
				}
				cout << "ne ok " << num_to_move << ' ' << t << '\n';
				for (auto kek : v) cout << kek << ' ';
				cout << "\n---\n";
			}
		}
		cout << cur << ' ' << new_s << ' ' << k << '\n';
	}


	*/

	ll n, k;

	cin >> n >> k;

	int log_n = 0;

	while ((1ll << (log_n)) < n) {
		++log_n;
	}

	if (k >= log_n + 1) {
		cout << log_n << "\n";
	}
	else {
		ll l = 0;
		ll r = n + 1;

		while (r - l > 1) {
			ll m = l + r >> 1;

			ll ans = 0ll;

			for (int i = 0; i <= 2 * k; i += 2) {
				ll t = C(m + 1, i);

				if (t == linf || ans + t >= linf) {
					ans = linf;
				}
				else {
					ans += t;
				}
			}

			if (ans >= n) {
				r = m;
			}
			else {
				l = m;
			}
		}
		cout << r << "\n";
	}
}


signed main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	//freopen("test.in", "r", stdin);
	//freopen("test.in", "w", stdout);
	//cout << fixed << setprecision(7);

	//clock_t start = clock();

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; ++test) {
		solve();
	}

	//clock_t end = clock();
	//ld seconds = (ld)(end - start) / CLOCKS_PER_SEC;
	//cout << seconds << "\n";
}