#include <iostream>
#include <vector>
#include <algorithm>

const int MOD = 998244353;

std::vector<long long> factorial(int n) {
    std::vector<long long> f(n + 1, 1);
    for (int i = 2; i <= n; ++i) {
        f[i] = (f[i - 1] * i) % MOD;
    }
    return f;
}

long long mod_inverse(long long x) {
    long long result = 1;
    long long power = MOD - 2;
    while (power) {
        if (power & 1) {
            result = (result * x) % MOD;
        }
        x = (x * x) % MOD;
        power >>= 1;
    }
    return result;
}

long long solve(int r, int g, int b) {
    int n = r + g + b;
    
    if (std::max({r, g, b}) > (n + 1) / 2) {
        return 0; 
    }

    std::vector<long long> f = factorial(n);
    long long arrangements = f[n] * mod_inverse(f[r]) % MOD;
    arrangements = arrangements * mod_inverse(f[g]) % MOD;
    arrangements = arrangements * mod_inverse(f[b]) % MOD;

    return arrangements;
}

int main() {
    int r, g, b;
    std::cin >> r >> g >> b;
    std::cout << solve(r, g, b) << std::endl;
    return 0;
}
