MOD = 998244353
def factorial(n):
    f = [1] * (n + 1)
    for i in range(2, n + 1):
        f[i] = (f[i - 1] * i) % MOD
    return f

def mod_inverse(x):
    return pow(x, MOD - 2, MOD)

def solve(r, g, b):
    n = r + g + b
    if max(r, g, b) > (n + 1) // 2:
        return 0
    
    f = factorial(n)
    arrangements = (f[n] * mod_inverse(f[r]) % MOD * mod_inverse(f[g]) % MOD * mod_inverse(f[b]) % MOD)
    return arrangements % MOD

r = int(input())
g = int(input())
b = int(input())

print(solve(r, g, b))