#include <algorithm>
#include <cassert>
#include <iostream>
#include <queue>
#include <vector>
#include <set>

using namespace std;
#define int long long
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> dist(n, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> dist[i][j];
        }
    }
    vector<vector<pair<int, int>>> new_g(n);
    multiset<pair<int, pair<int, int>>> xd;
    vector<bool> used(n, false);
    used[0] = true;
    for (int i = 1; i < n;i++) xd.insert({dist[0][i], {0, i}});
    bool fl = true;
    while (!xd.empty()) {
        auto it = *xd.begin();
        xd.erase(xd.find(it));
        int v = (it).second.first;
        int u = (it).second.second;
        int w = (it).first;
        if (used[u])
            continue;
        new_g[v].push_back({u,w});
        new_g[u].push_back({v,w});
        if (w == 0) fl = false;
        //cout << u << " " << v << " " << w << "\n";
        used[u] = true;
        for (int i = 0; i < n;i++) {
            if (!used[i]) {
                xd.insert({dist[u][i], {u, i}});
            }
        }
    }
    for (int i = 0; i < n; i++) {
        vector<int> dst(n, 0);
        vector<bool> used(n, false);
        used[i] = true;
        queue<int> q;
        q.push(i);
        while (!q.empty()) {
            auto f = q.front();
            q.pop();
            for (auto &d: new_g[f]) {
                if (!used[d.first]) {
                    used[d.first] = true;
                    dst[d.first] = dst[f] + d.second;
                    q.push(d.first);
                }
            }
        }
        for (int j = 0; j < n; j++) {
            if (dst[j] != dist[i][j]) fl = false;
        }
    }
    cout << (fl ? "Yes\n" : "No\n");
}
