#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}
#define int long long
const int MOD = 998244353;

struct mi {
    int v;
    explicit operator int() const { return v; }
    mi() { v = 0; }
    mi(long long _v) : v(_v % MOD) { v += (v < 0) * MOD; }
};
mi &operator+=(mi &a, mi b) {
    if ((a.v += b.v) >= MOD) a.v -= MOD;
    return a;
}
mi &operator-=(mi &a, mi b) {
    if ((a.v -= b.v) < 0) a.v += MOD;
    return a;
}
mi operator+(mi a, mi b) { return a += b; }
mi operator-(mi a, mi b) { return a -= b; }
mi operator*(mi a, mi b) { return mi((long long)a.v * b.v); }
mi &operator*=(mi &a, mi b) { return a = a * b; }
mi pow(mi a, long long p) {
    assert(p >= 0);
    return p == 0 ? 1 : pow(a * a, p / 2) * (p & 1 ? a : 1);
}
mi inv(mi a) {
    assert(a.v != 0);
    return pow(a, MOD - 2);
}
mi operator/(mi a, mi b) { return a * inv(b); }


const int N = 200200;
vector<mi> fact(N + 1, mi(1)), ifact(N + 1, mi(1));

mi C(int n, int k) {
    if (k < 0 || n < 0 || k > n) return mi(0);
    return fact[n] * ifact[n - k] * ifact[k];
}

mi start_pos(int n, int s) {
    if (n == 0 ) return mi(1);
    if (n == 1) return s >= 1;
    return C(s - 1, n - 1);
}

mi start_not_neg(int n, int s) {
    return start_pos(n, s + n);
}

mi solve_nonempty(int cnt, int a, int b) {
    mi result = 0;
    if (cnt <= 0) return 0;
    for (int x = 0; x <= a; x++) {
        if (x > cnt) continue;
        int diff = b - a + x;
        if (diff < 0) continue;

        int y = diff;
        int ost = cnt - x - y;
        int total = (a + b - x - y);
        if (total < 0 || total % 2 != 0) continue;
        total /= 2;
      //  cout << x << " " << y << " " << ost << " " << total <<  " ";
        if (ost < 0) continue;
        if (x > cnt || y > cnt) continue;
        mi answer = C(cnt, x) * C(cnt - x, y);
        answer *= pow(mi(2), ost);
       // cout << answer.v << "! ";

        answer *= start_pos(ost, total);
      //  cout << ost << " " << total << "\n";
      //  cout << answer.v << "\n";
        result += answer;
    }
    return result;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i;
    for (int i = 1; i < N; i++) ifact[i] = pow(fact[i], MOD - 2);
    int a, b, c;
    cin >> a >> b >> c;
  // cout <<
    //cout << solve_nonempty(c, a, b).v << "\n";
    //cout <<  (solve_nonempty(c + 1, a, b)).v;
    //cout << X.v;
   // auto p = solve_nonempty(c, a, b);
    auto X = solve_nonempty(c + 1, a, b) +  (mi(2) * solve_nonempty(c, a, b)) + solve_nonempty(c - 1, a, b);
    cout << X.v << "\n";
}
