#include <iostream>
#include <vector>
#include <string>

using namespace std;

vector<int> digitMasks = {
        0b1111110,
        0b0110000,
        0b1101101,
        0b1111001,
        0b0110011,
        0b1011011,
        0b1011111,
        0b1110000,
        0b1111111,
        0b1111011
};

int to_m(const string& s) {
    int mask = 0;
    for (int i = 0; i < 7; ++i)
        if (s[i] == '1') mask |= (1 << (6 - i));
    return mask;
}

bool ab(int numberMask, int indicatorMask) {
    return (numberMask & indicatorMask) == numberMask;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    string f, s;
    cin >> f >> s;
    int f_m = to_m(f);
    int s_m = to_m(s);
    int mm = 0;
    for (int start = 1; start <= 99; ++start) {
        int cur = 0;
        for (int k = start; k <= 99; ++k) {
            int tens = k / 10;
            int units = k % 10;
            if (ab(digitMasks[tens], f_m) && ab(digitMasks[units], s_m)) cur++;
            else break;
        }
        mm = max(mm, cur);
    }
    cout << mm << '\n';
    return 0;
}


/*
1111111
1101111

1011011
1101111

1101111
0010010

0000000
0000000
 */