#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
const vector<int> valid = {
        0b1110111,
        0b0100100,
        0b1011101,
        0b1101101,
        0b0101110,
        0b1101011,
        0b1111011,
        0b0100101,
        0b1111111,
        0b1101111
};

bool canRepresent(int brokenSegment, int number) {
    return (brokenSegment & valid[number]) == brokenSegment;
}

int findMaxSequence(const vector<int>& brokenSegments) {
    int maxK = 0;

    if (brokenSegments[0] == 0 && brokenSegments[1] == 0) {
        return 0;
    }

    for (int x = 0; x <= 99; ++x) {
        bool validSequence = true;

        for (int i = 0; i <= maxK; ++i) {
            int tens = (x + i) / 10;
            int units = (x + i) % 10;

            if (!canRepresent(brokenSegments[0], tens) || !canRepresent(brokenSegments[1], units)) {
                validSequence = false;
                break;
            }
        }

        if (validSequence) {
            int currentK = maxK;
            while (true) {
                int tens = (x + currentK + 1) / 10;
                int units = (x + currentK + 1) % 10;

                if (canRepresent(brokenSegments[0], tens) && canRepresent(brokenSegments[1], units)) {
                    currentK++;
                } else {
                    break;
                }
            }
            maxK = max(maxK, currentK);
        }
    }

    return maxK > 0 ? maxK : 0;
}

int main() {
    string firstSegment, secondSegment;
    cin >> firstSegment >> secondSegment;

    int brokenFirst = stoi(firstSegment, nullptr, 2);
    int brokenSecond = stoi(secondSegment, nullptr, 2);

    vector<int> brokenSegments = {brokenFirst, brokenSecond};

    int result = findMaxSequence(brokenSegments);
    cout << result << endl;

    return 0;
}