// #include <iostream>
// #include <string>
// #include <algorithm>
 
// using namespace std;
 
// void solve(long long test_cases) {
//     while (test_cases--) {
//         string s;
//         long long k;
//         cin >> s >> k;
//         long long n = s.length();
 
//         for (long long i = 0; i < n; ++i) {
//             if (k <= 0) {
//                 break;
//             }
//             if (s[i] == '1') {
//                 continue;
//             }
//             long long max_j = min(i + k, n - 1);
//             int min_digit_index = i;
 
//             for (int j = i + 1; j <= max_j; ++j) {
//                 if (s[j] < s[min_digit_index]) {
//                     min_digit_index = j;
//                 }
//             }
//             int swaps_needed = min_digit_index - i;
//             if (swaps_needed > 0) {
//                 int digit_to_move = s[min_digit_index];
//                 for (int j = min_digit_index; j > i; j--) {
//                     s[j] = s[j - 1];
//                 }
//                 s[i] = digit_to_move;
//                 k -= swaps_needed;
//             }
//         }
//         cout << s << "\n";
//     }
// }
 
// int main() {
//     ios_base::sync_with_stdio(0);
//     cin.tie(0);
//     cout.tie(0);
//     long long test_cases;
//     cin >> test_cases;
//     solve(test_cases);
//     return 0;
// }

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

void solve(long long test_cases) {
    while (test_cases--) {
        string s;
        long long k;
        cin >> s >> k;
        long long n = s.length();

        for (long long i = 0; i < n; ++i) {
            if (k <= 0) {
                break;
            }

            priority_queue<pair<char, long long>, vector<pair<char, long long>>, greater<pair<char, long long>>> min_heap;

            for (long long j = i; j < min(n, i + k + 1); ++j) {
                min_heap.push({s[j], j});
            }
            while (!min_heap.empty()) {
                auto [digit, index] = min_heap.top();
                min_heap.pop();
                long long swaps_needed = index - i;
                if (swaps_needed <= k) {
                    for (long long m = index; m > i; --m) {
                        s[m] = s[m - 1];
                    }
                    s[i] = digit;
                    k -= swaps_needed;
                    break;
                }
            }
        }

        cout << s << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long test_cases;
    cin >> test_cases;
    solve(test_cases);
    return 0;
}
