#include <iostream>
#include <vector>
#include <iomanip>

int main() {
    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> points(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> points[i].first >> points[i].second;
    }

    int minX = 1001, maxX = -1001;
    double maxHeight = 0.0;

    for (int i = 0; i < n; ++i) {
        int x = points[i].first;
        int y = points[i].second;

        if (y == 0) {
            if (x < minX) minX = x;
            if (x > maxX) maxX = x;
        }
        else {
            double height = std::abs(y);
            if (height > maxHeight) {
                maxHeight = height;
            }
        }
    }

    double maxBase = maxX - minX;
    double maxArea = 0.5 * maxBase * maxHeight;

    if (maxBase > 0.0 && maxHeight > 0.0) {
        std::cout << std::setprecision(std::numeric_limits<double>::digits10 + 1);
        std::cout << maxArea << std::endl;
    }
    else {
        std::cout << 0.0 << std::endl;
    }

	return 0;
}