#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5, inf = 1e9;

vector<int> dijkstra(int s, vector<vector<int>> &g, int n) {
    vector<int> d(n, inf), a(n, 0);
    d[s] = 0;
    priority_queue<pair<int, int>, vector<pair<int, int>>> q;
    q.push({0, s});
    while (!q.empty()) {
        //     d[v]  ݣ  
        int v = q.top().second;
        int d_v = q.top().first;
        q.pop();

        if (d_v != d[v])
            continue;

        a[v] = true;
        for (int j = 0; j < n; ++j) {
            if (g[v][j] == 0 || a[j])
                continue;
            if (d[v] + g[v][j] < d[j]) {
                d[j] = min(d[j], d[v] + g[v][j]);
                q.push({d[j], j});
            }
        }
    }
    return d;
}

int main() {
    int n;
    cin >> n;
    int need_to_delete = n * (n - 1) / 2 - (n - 1);
    int now_deleted = 0;

    vector<vector<int>> g(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> g[i][j];
        }
    }


    for (int i = 0; i < n; ++i) {
        int s = i;
        for (int j = i + 1; j < n; ++j) {
            int t = j;
            int temp = g[s][t];
            g[s][t] = INT32_MAX;
            g[t][s] = INT32_MAX;
            vector<int> d = dijkstra(s, g, n);
            if (temp == d[t]){
                now_deleted++;

            }   else {
                g[s][t] = temp;
                g[t][s] = temp;
            }

        }
    }

    if (now_deleted == need_to_delete) {
        cout << "YES";
        return 0;
    }
    cout << "NO";
    return 0;
}