﻿

#include <iostream>
#include <vector>
#include <string>

int main() {
    int n;
    std::cin >> n;

    // Массив для проверки наличия программ по начальным буквам
    std::vector<bool> programs_present(26, false);

    // Чтение названий программ
    for (int i = 0; i < n; ++i) {
        std::string program_name;
        std::cin >> program_name;
        char first_letter = program_name[0];
        programs_present[first_letter - 'a'] = true; // Отмечаем наличие программы с данной буквой
    }

    // Создание таблицы 5 строк и 6 столбцов
    std::vector<std::vector<char>> table(5, std::vector<char>(6, '.'));

    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 6; ++j) {
            int index = i * 6 + j;
            if (index < 26) { // Проверяем только первые 26 символов
                table[i][j] = programs_present[index] ? 'a' + index : '.';
            }
            // Последние 4 клетки остаются по умолчанию с '.'
        }
    }

    // Вывод таблицы
    for (const auto& row : table) {
        for (char cell : row) {
            std::cout << cell << ' ';
        }
        std::cout << std::endl;
    }

    return 0;
}