#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;

    int min_x = 1001, max_x = -1001;
    vector<pair<int, int>> points_outside;

    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        if (y == 0) {
            min_x = min(min_x, x);
            max_x = max(max_x, x);
        } else {
            points_outside.emplace_back(x, y);
        }
    }

    if (min_x >= max_x) {
        cout << 0 << endl;
        return 0;
    }

    double max_area = 0.0;
    double base_length = max_x - min_x;

    for (const auto& point : points_outside) {
        max_area = max(max_area, 0.5 * base_length * abs(point.second));
    }

    cout << fixed << setprecision(1) << max_area << endl;

    return 0;
}