#include <iostream>
#include <map>
#include <tuple>
#include <algorithm>
using namespace std;

bool isPossibleToArrange(int red, int green, int blue) {
    int total = red + green + blue;
    return max({red, green, blue}) <= (total + 1) / 2;
}

map<tuple<int, int, int, char>, int> memo;

int countArrangements(int red, int green, int blue, char last) {
    if (red == 0 && green == 0 && blue == 0) return 1;

    auto key = make_tuple(red, green, blue, last);
    if (memo.count(key)) return memo[key];

    int count = 0;
    if (red > 0 && last != 'R') count += countArrangements(red - 1, green, blue, 'R');
    if (green > 0 && last != 'G') count += countArrangements(red, green - 1, blue, 'G');
    if (blue > 0 && last != 'B') count += countArrangements(red, green, blue - 1, 'B');

    return memo[key] = count;
}

int main() {
    int red, green, blue;
    cin >> red >> green >> blue;

    cout << (isPossibleToArrange(red, green, blue) ? countArrangements(red, green, blue, ' ') : 0) << endl;
    return 0;
}