#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ios>

#define INVALID 1000
std::vector<std::int32_t> digits(256, -1);

const std::vector<std::int32_t> masks = {
	0b1110111,
	0b0010010,
	0b1011101,
	0b1011011,
	0b0111010,
	0b1101011,
	0b1101111,
	0b1010010,
	0b1111111,
	0b1111011
};


int to_bin(const std::string &num)
{
        int bin = 0;

	for (int i = 0; i < 7; ++i)
	{
		bin <<= 1;
		bin |= num[i] - '0';
	}

	return bin & 0x7f;
}

int fixed(int num, int mask1, int mask2)
{
	std::int32_t ret = INVALID;

	if (num < 10)
	{
		std::int32_t dl = digits[masks[num] & mask2];

		if (dl != -1)
		{
			ret = dl;
		}

		return ret;
	}

	std::int32_t dh = digits[masks[num / 10] & mask1];
	std::int32_t dl = digits[masks[num % 10] & mask2];

	if (dh == -1 || dl == -1)
	{
		return ret;
	}

	ret = dh * 10 + dl;
	return ret;
}

int main()
{
	for (std::size_t i = 0; i < masks.size(); ++i)
	{
		digits[masks[i]] = i;
	}

	std::ios_base::sync_with_stdio(false);
	std::string a, b;
	std::cin >> a >> b;

	std::int32_t mask1 = to_bin(a);
	std::int32_t mask2 = to_bin(b);
	std::int32_t last = INVALID;
	std::int32_t answer = 0;

	for (std::int32_t k = 0, r = 99; r > 0; --r)
	{
		std::int32_t num = fixed(r, mask1, mask2);

		if (num == last + 1)
		{
			++k;
			answer = std::max(answer, k);
		}
		else
		{
			k = 0;
		}

		last = num;
	}

	std::cout << answer;
	return 0;
}
