#define GLIBCXX_DEBUG
 
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
 
using namespace __gnu_pbds;
using namespace std;
using ll = long long;
template <class T>
T gcd(T a, T b) {
    while (b) a = a % b, swap(a, b);
    return a;
}
 
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
 
const ll mod = 998244353;
 
int64_t poww(int64_t val, int64_t d, int64_t modd = mod) {
    int64_t ans = 1, mn = val;
    while (d) {
        if (d & 1) ans = mn * ans % modd;
        mn = mn * mn % modd, d >>= 1;
    }
    return ans;
}
 
const ll maxn=ll(1e5)+5;
ll fact[maxn];
ll inv[maxn];
 
ll C(ll n, ll k) {
    if (k < 0 || n < 0) return 0;
    if (k == 0) return 1;
    if (k > n) return 0;
    return fact[n] * inv[k] % mod * inv[n-k] % mod;
}

ll ans = 0;
vector<int> F;

void f(int x, int ost_a, int ost_b, int ost_c) {
    if (x == F.size()) {
        bool ok = true;
        for (int i = 0; i < F.size() - 1; i++) {
            if (F[i] == F[i + 1]) {
                ok = false;
            }
        }
        if (ok && ost_a == 0 && ost_b == 0 && ost_c == 0) {
            ans++;
        }
    } else {
        if (ost_a > 0) {
            F[x] = 0;
            f(x + 1, ost_a - 1, ost_b, ost_c);
        }
        if (ost_b > 0) {
            F[x] = 1;
            f(x + 1, ost_a, ost_b - 1, ost_c);
        }
        if (ost_c > 0) {
            F[x] = 2;
            f(x + 1, ost_a, ost_b, ost_c - 1);
        }
    }
}

ll dump(ll a, ll b, ll c) {
    F.resize(a + b + c);
    ans = 0;
    f(0, a, b, c);
    return ans;
}
 
ll solve(ll a, ll b, ll c) {
    if (a > b) swap(a,b);
    if (b > c) swap(b,c);
    if (a > b) swap(a,b);
    vector<ll> res(4,1);
    res[0] = C(c-1, b);
    res[1] = C(c-1, b-1);
    res[2] = C(c-1, b-1);
    res[3] = C(c-1, b-2);
    res[0] = res[0] * C(b+c+1, a-(c-1-b)) % mod;
    res[1] = res[1] * C(b+c+1, a-(c-b)) % mod;
    res[2] = res[2] * C(b+c+1, a-(c-b)) % mod;
    res[3] = res[3] * C(b+c+1, a-(c+1-b)) % mod;
    ll ans = (res[0] + res[1] + res[2] + res[3]) % mod;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    fact[0]=1;
    inv[0]=1;
    for (int i=1;i<maxn;++i) {
        fact[i] = fact[i-1]*i%mod;
        inv[i] = poww(fact[i], mod-2);
    }
    
    for (int a = 1; a < 8; a++) {
        for (int b = 1; b < 8; b++) {
            for (int c = 1; c < 8; c++) {
                if (dump(a, b, c) != solve(a, b, c)) {
                    cout << a << " " << b << " " << c << " " << dump(a, b, c) << " " << solve(a, b, c) << endl;
                }
            }
        }
    }
}
