#include "bits/stdc++.h"
using namespace std;

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...)
#endif

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;

#define eb emplace_back

bitset<7> A, B;

const int INF = 1e5;

bitset<7> encode_int(int x) {
    assert(0 <= x && x < 10);
    switch (x) {
        case 0:
            return static_cast<bitset<7>>(0b1110111);
        case 1:
            return static_cast<bitset<7>>(0b0100100);
        case 2:
            return static_cast<bitset<7>>(0b1011101);
        case 3:
            return static_cast<bitset<7>>(0b1101101);
        case 4:
            return static_cast<bitset<7>>(0b0101110);
        case 5:
            return static_cast<bitset<7>>(0b1101011);
        case 6:
            return static_cast<bitset<7>>(0b1111011);
        case 7:
            return static_cast<bitset<7>>(0b0100101);
        case 8:
            return static_cast<bitset<7>>(0b1111111);
        case 9:
            return static_cast<bitset<7>>(0b1101111);
        default:
            return static_cast<bitset<7>>(0b0000000);
    }
    return static_cast<bitset<7>>(0b0000000);
}

int decode_bitset(bitset<7> x) {
    switch (x.to_ullong()) {
        case 0b1110111:
            return 0;
        case 0b0100100:
            return 1;
        case 0b0010010:
            return 1;
        case 0b1011101:
            return 2;
        case 0b1101101:
            return 3;
        case 0b0101110:
            return 4;
        case 0b1101011:
            return 5;
        case 0b1111011:
            return 6;
        case 0b0100101:
            return 7;
        case 0b1111111:
            return 8;
        case 0b1101111:
            return 9;
        default:
            return INF;
    }
    return INF;
}

int execute(int x) {
    if (x < 10) {
        bitset<7> encoded_b = encode_int(x % 10);
        encoded_b &= B;
        return decode_bitset(encoded_b);
    } else {
        bitset<7> encoded_a = encode_int(x / 10), encoded_b = encode_int(x % 10);
        encoded_a &= A;
        encoded_b &= B;
        int a = decode_bitset(encoded_a), b = decode_bitset(encoded_b);
        return 10 * a + b;
    }
}

bool check(int k) {
    for (int y = k + 1; y < 100; ++y) {
        int x = execute(y);
        bool flag = (x < 100);
        for (int i = 1; flag && i <= k; ++i) {
            if (execute(y - i) != x + i) {
                flag = false;
            }
        }
        if (flag) {
            return true;
        }
    }
    return false;
}

void solve() {
    string tmp_a, tmp_b;
    cin >> tmp_a >> tmp_b;
    reverse(tmp_a.begin(), tmp_a.end());
    reverse(tmp_b.begin(), tmp_b.end());
    A = bitset<7>(tmp_a);
    B = bitset<7>(tmp_b);
    for (int k = 99; k; --k) {
        if (check(k)) {
            cout << k << '\n';
            return;
        }
    }
    cout << "0\n";
    // int l = 0, r = 100;
    // while (r - l > 1) {
    //     int m = (l + r) / 2;
    //     if (check(m)) {
    //         l = m;
    //     } else {
    //         r = m;
    //     }
    // }
    // cout << l;
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    // cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}
