#include <iostream>
#include <vector>

using namespace std;

int gcd(int a, int b) {
    if (a == 0) {
        return b;
    }
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int h[200001], t[800040];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = h[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = gcd(t[v * 2], t[v * 2 + 1]);
}

void update(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[pos] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        update(v * 2, tl, tm, pos, val);
    } else {
        update(v * 2 + 1, tm + 1, tr, pos, val);
    }
    t[v] = gcd(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return 0;
    }
    if (l == tl && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return gcd(get(v * 2, tl, tm, l, min(r, tm)), get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int g[200001];
vector<pair<int, pair<int, int> > > otv;

signed main() {
    int n, s, f;
    cin >> n;
    for (int x = 1; x <= n; x++) {
        cin >> g[x];
        h[x - 1] = abs(g[x] - g[x - 1]);
    }
    build(1, 1, n);
    cin >> s >> f;
    bool swapped = false;
    bool reached = true;
    if (s > f) {
        swap(s, f);
        swapped = true;
    }
    int now = s;
    while (true) {
        int l = now, r = f + 1;
        while (r - l > 1) {
            int sr = (l + r) / 2;
            int res = get(1, 1, n, now, sr - 1);
            if (res == 1) {
                r = sr;
            } else {
                l = sr;
            }
        }
        if (now == l) {
            reached = false;
            break;
        }
        int res = get(1, 1, n, now, l - 1);
        int mod = res;
        if (mod == 0) {
            mod = 2;
        }
        otv.push_back(make_pair(mod, make_pair(now, l)));
        now = l;
        if (now == f) {
            break;
        }
    }
    if (!reached) {
        cout << "Impossible\n";
        return 0;
    }
    if (!swapped) {
        for (pair<int, pair<int, int> > v: otv) {
            cout << "Kaban-" << v.first << " " << v.second.first << " " << v.second.second << '\n';
        }
        return 0;
    }
    for (int i = otv.size() - 1; i >= 0; i--) {
        cout << "Kaban-" << otv[i].first << " " << otv[i].second.second << " " << otv[i].second.first << '\n';
    }
}