#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

bitset<7> m1, m2;

string digits[10] = {
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011",
};

int get_digit(bitset<7> x)
{
    string s = x.to_string();
    for (int i = 0; i < 10; i++)
    {
        if (s == digits[i]) return i;
    }
    return -1;
}

int view(int x)
{
    if (x < 10)
    {
        return get_digit(bitset<7>(digits[x]) & m2);
    }
    string s = to_string(x);
    int a = s[0]-'0', b = s[1]-'0';
    bitset<7> q = bitset<7>(digits[a]) & m1;
    bitset<7> w = bitset<7>(digits[b]) & m2;

    int f = q.to_ulong() == 0 ? 0 : get_digit(q);
    int f2 = get_digit(w);
    if (f < 0 || f2 < 0) return -1;
    return f * 10 + f2;
}

int max_k(int real)
{
    int res = 0;
    int fake = view(real);
    if (fake < 0) return 0;
    real--;
    fake++;
    while(real > 0 && view(real) == fake)
    {
        res++;
        real--;
        fake++;
    }
    return res;
}

vector<bool> sieve(int n) {
    vector<bool> is_prime(n+1, true);
    for (int i = 2; i <= n; i++)
        if (is_prime[i])
            for (int j = 2*i; j <= n; j += i)
                is_prime[j] = false;
    return is_prime;
}

struct path
{
    int from, to;
    long long mod;
};

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n;
    cin >> n;
    vector<int> cities(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> cities[i];
    }
    int f, s;
    cin >> f >> s;
    --f, --s;
    if (f > s) swap(f, s);

    const int MAX = 4 * 1e4;

    vector<int> primes;
    auto primes_bool = sieve(MAX);
    for (int i = 2; i < MAX + 1; ++i)
    {
        if (primes_bool[i]) primes.push_back(i);
    }

    bool possible = true;
    vector<path> answer;

    vector<int> primes_m = primes;
    while (f != s && possible)
    {
        int cur = f + 1;
        while (possible)
        {
            vector<int> primes_n;
            int tmp = abs(cities[cur] - cities[f]);
            for (int i : primes_m)
            {
                if (tmp % i == 0)
                {
                    primes_n.push_back(i);
                }
            }
            if (primes_n.empty())
            {
                if (cur == f + 1) possible = false;
                else break;
            } else
            {
                cur++;
                if (cur == s + 1) break;
                swap(primes_n, primes_m);
            }
        }
        if (possible)
        {
            answer.push_back({f, cur - 1, primes_m[0]});
            primes_m = primes;
            f = cur - 1;
        }
    }

    if (possible)
    {
        for (auto i : answer)
        {
            cout << "Kaban-" << i.mod << " " << i.from + 1 << " " << i.to + 1 << endl;
        }
    } else
    {
        cout << "Impossible" << endl;
    }

}