#include <bits/stdc++.h>

using namespace std;

template <typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

template <typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> p)
{
    out << p.first << " " << p.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& i : a) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, vector<T> a)
{
    for (auto i : a)
        out << i << (std::is_same_v<T, vector<int>> ? "\n" : " ");
    return out;
}

#pragma GCC optimize("Ofast,unroll-loops")

// #define int long long
#define pii pair<int, int>
#define ss second
#define ff first
#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define deb(x) cerr << (#x) << " is " << (x) << endl;

bitset<7> m1, m2;

string digits[10] = {
    "1110111",
    "0010010",
    "1011101",
    "1011011",
    "0111010",
    "1101011",
    "1101111",
    "1010010",
    "1111111",
    "1111011",
};

int get_digit(bitset<7> x)
{
    string s = x.to_string();
    for (int i = 0; i < 10; i++)
    {
        if (s == digits[i]) return i;
    }
    return -1;
}

int view(int x)
{
    if (x < 10)
    {
        return get_digit(bitset<7>(digits[x]) & m2);
    }
    string s = to_string(x);
    int a = s[0]-'0', b = s[1]-'0';
    bitset<7> q = bitset<7>(digits[a]) & m1;
    bitset<7> w = bitset<7>(digits[b]) & m2;

    int f = q.to_ulong() == 0 ? 0 : get_digit(q);
    int f2 = get_digit(w);
    if (f < 0 || f2 < 0) return -1;
    return f * 10 + f2;
}

int max_k(int real)
{
    int res = 0;
    int fake = view(real);
    if (fake < 0) return 0;
    real--;
    fake++;
    while(real > 0 && view(real) == fake)
    {
        res++;
        real--;
        fake++;
    }
    return res;
}

vector<bool> sieve(int n) {
    vector<bool> is_prime(n+1, true);
    for (int i = 2; i <= n; i++)
        if (is_prime[i])
            for (int j = 2*i; j <= n; j += i)
                is_prime[j] = false;
    return is_prime;
}

struct path
{
    int from, to;
    long long mod;
};

struct edge
{
    int u, v;
    int w;
};

vector<int> p, h;

int leader(int v)
{
    return p[v] == v ? v : p[v] = leader(p[v]);
}

void unite(int a, int b)
{
    a = leader(a);
    b = leader(b);
    if (h[a] > h[b]) swap(a, b);
    h[b] = max(h[b], h[a] + 1);
    p[a] = b;
}

vector<vector<pair<int, long long>>> g;
vector<vector<int>> up;
vector<int> tin, tout, dist;
int c = 0;
int timer = 0;

void dfs(int v = 0, int p = 0, long long d = 0)
{
    tin[v] = timer++;
    up[v][0] = p;
    dist[v] = d;
    for (int i = 1; i < c; ++i)
    {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto [to, weight] : g[v])
    {
        if (to != p) dfs(to, v, d + weight);
    }
    tout[v] = timer++;
}

bool ancestor(int v, int u)
{
    return tin[v] <= tin[u] && tin[u] <= tout[v];
}

int lca(int v, int u)
{
    if (ancestor(v, u)) return v;
    if (ancestor(u, v)) return u;
    for (int i = c - 1;i > -1; --i)
    {
        if (!ancestor(up[v][i], u))
        {
            v = up[v][i];
        }
    }
    return up[v][0];
}

signed main()
{
#ifndef LOCAL_STDOUT
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    int n;
    cin >> n;

    int q = 1;

    while (q <= n)
    {
        q *= 2;
        c++;
    }

    up.resize(n, vector<int>(c, 0));
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    dist.resize(n, 0);
    p.resize(n);
    h.resize(n, 0);
    for (int i = 0; i < n; ++i) p[i] = i;
    const int MAX_SIZE = 1000;
    int distance[MAX_SIZE][MAX_SIZE];
    vector<edge> edges;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            cin >> distance[i][j];
            if (i < j)
            {
                edges.push_back({i, j, distance[i][j]});
            }
        }
    }

    sort(edges.begin(), edges.end(), [](edge e1, edge e2) {return e1.w < e2.w;});

    for (edge e : edges)
    {
        int u = leader(e.u);
        int v = leader(e.v);
        if (u != v)
        {
            g[e.u].push_back({e.v, e.w});
            g[e.v].push_back({e.u, e.w});
            unite(u, v);
        }
    }

    dfs();


    bool ans = true;

    for (int i = 0; i < n && ans; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            if (ancestor(i, j))
            {
                if (dist[j] - dist[i] != distance[i][j])
                {
                    ans = false;
                    break;
                }
            } else if (ancestor(j, i))
            {
                if (dist[i] - dist[j] != distance[i][j])
                {
                    ans = false;
                    break;
                }
            } else if (dist[i] + dist[j] - dist[lca(i, j)] != distance[i][j])
            {
                ans = false;
                break;
            }
        }
    }

    if (ans)
    {
        cout << "Yes" << endl;
    } else
    {
        cout << "No" << endl;
    }




}