#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

void solve() {
    int n;cin >> n;
    vector <point> a(n);
    ll mn = 1e18, mx = -1e18, kol = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
        if (a[i].y == 0) {
            kol++;
            mx = max(mx, a[i].x);
            mn = min(mn, a[i].x);
        }
    }
    if (kol < 2) {
        cout << 0;
        return;
    }
    point a1 = {mx - mn, 0 };
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        if (a[i].y != 0) {
            point a2 = get({mn, 0}, a[i]);
            ans = max(ans, abs(a1 * a2));
        }
    }
    cout << setprecision(20) << fixed << ld(ans) / 2;
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) solve();
}


// a - 1 b - 2 c - 3