#include <algorithm>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

struct st {
    int m, l, r;
};

ll lg(ll n) {
    ll l = -1, r = 62;
    while (l < r - 1) {
        ll m = (l + r) / 2;
        if ((1ll << m) >= n) r = m;
        else l = m;
    }
    return r;
}

void solve() {
    ll n, k; cin >> n >> k;
    ll mxk = (1ll << (2 * k + 1)) - 1;
    if (n <= mxk || k > 30) {
        cout << lg(n) << '\n';
        return;
    }
    cout << (n - 1) / mxk + lg(mxk) << '\n';
}

int main() {
    int t = 1;
    cin >> t;
    while (t--) solve();
}
