#include <algorithm>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll mod =  998244353;


ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a % mod;
    ll b = bin_pow(a, n / 2);
    return b * b % mod;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

struct st {
    int m, l, r;
};

ll lg(ll n) {
    ll l = -1, r = 62;
    while (l < r - 1) {
        ll m = (l + r) / 2;
        if ((1ll << m) >= n) r = m;
        else l = m;
    }
    return r;
}


vector <ll> fact(5e5 + 1);

ll C(ll n, ll k) {
    if (k > n) return 0;
    return (fact[n] * bin_pow(fact[k], mod - 2)) % mod * bin_pow(fact[n - k], mod - 2) % mod;
}

void solve() {
    fact[0] = fact[1] = 1;
    for (ll i = 2; i < fact.size(); i++) {
        fact[i] = fact[i - 1] * i % mod;
    }
    ll a, b, c, cnt, ans = 0; cin >> a >> b >> c;
    vector <ll> x = {a, b, c};
    sort(x.begin(), x.end());
    a = x[0], b = x[1], c = x[2];
    if (b >= a - 1) cnt = 0;
    else cnt = a - 1 - b;
    if (cnt > c) {

    }
    else {
        c = c - cnt;
        ans += C(a + b - cnt + 1, c) * C(b + cnt, cnt) % mod;
    }
    cnt = a - b;
    if (c >= cnt) {
        c = c - cnt;
        ans += C(a + b - cnt + 1, c) * C(b - 1 + cnt, cnt) % mod;
        ans %= mod;
    }
    cout << ans;
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
