#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;


#define pb push_back
#define ff first
#define ss second
#define pp pair
#define ll long long
#define dl long double

template<typename T>
ostream &operator<<(ostream &out, const pair<T, T> &a) {
    out << a.ff << ' ' << a.ss;
    return out;
}

template<typename T>
istream &operator>>(istream &in, pair<T, T> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto i: a) cout << i << '\n';
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a) in >> i;
    return in;
}

const int maxn = 1e5 + 100, inf = 1e9;

struct SegTree {
    vector<int> tree;
    int n;
    int neutral = 0;

    SegTree(const vector<int> &data) {
        n = (int) data.size();
        tree.resize(4 * n);
        build(1, 0, n, data);
    }

    int recalc(int left, int right) {
        return gcd(left, right);
    }

    void build(int v, int l, int r, const vector<int> &data) {
        if (l + 1 == r) {
            tree[v] = data[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m, data);
        build(v * 2 + 1, m, r, data);
        tree[v] = recalc(tree[v * 2], tree[v * 2 + 1]);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (lq >= r || l >= rq) return neutral;
        if (lq <= l && r <= rq) return tree[v];
        int m = (l + r) / 2;
        return recalc(get(v * 2, l, m, lq, rq), get(v * 2 + 1, m, r, lq, rq));
    }

    void update(int v, int l, int r, int ind, int val) {
        if (l + 1 == r) {
            tree[v] = val;
            return;
        }
        int m = (l + r) / 2;
        if (ind < m) update(v * 2, l, m, ind, val);
        else update(v * 2 + 1, m, r, ind, val);
        tree[v] = recalc(tree[v * 2], tree[v * 2 + 1]);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void upd(int ind, int val) {
        update(1, 0, n, ind, val);
    }
};


void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;

    vector<int> b(n);
    for (int i = 1; i < n; i++) b[i] = a[i] - a[i - 1];
    SegTree t(b);

    int s, f;
    cin >> s >> f;
    s--, f--;

    bool swp = false;
    if (s > f) {
        swap(s, f);
        swp = true;
    }

    int cur = s;
    bool ok = true;
    vector<vector<int>> ans;
    while (cur < f) {
        int l = cur + 1, r = f + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (t.get(cur + 1, m + 1) != 1) {
                l = m;
            } else {
                r = m;
            }
        }
        int res = t.get(cur + 1, l + 1);
        if (res == 1) {
            ok = false;
            break;
        } else if (res == 0) {
            res = 1488;
        }
        ans.push_back({cur, l, res});
        cur = l;
    }
    if (!ok) {
        cout << "Impossible";
        return;
    }

    if (!swp) {
        for (auto i: ans) {
            cout << "kaban-" << i[2] << ' ' << i[0] + 1 << ' ' << i[1] + 1 << '\n';
        }
    } else {
        reverse(ans.begin(), ans.end());
        for (auto i: ans) {
            cout << "kaban-" << i[2] << ' ' << i[1] + 1 << ' ' << i[0] + 1 << '\n';
        }
    }
}

signed main() {
#ifdef pskobx
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
#ifndef pskobx
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
//    cout << fixed << setprecision(15);
//    cin >> tests;
    while (tests--) solve();
#ifdef pskobx
    //    cout << "\nruntime = " << clock() / 1000.0 << '\n';
#endif
}
