#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2,popcnt,tune=native")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;

using ll = unsigned long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(459);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

std::unordered_map<__int128_t, ll> save;

const __int128_t maxn = static_cast<ll>(1e18) + 1;

ll power(ll a, ll n) {
    if (n == 0) {
        return a;
    }
    if (n % 2 == 0) {
        ll b = power(a, n / 2);
        return b * b;
    }
    return a * power(a, n - 1);
}

ll sqr_n(ll n, ll k) {
    ll s = std::pow(static_cast<ld>(n), 1 / static_cast<ld>(k));
    while (power(s + 1, k) < n) {
        ++s;
    }
    return s;
}

ll cacl_m(ll n, ll k, ll m);

ll calc(ll n, ll k) {
    __int128_t hash = n * maxn + k;
    auto it = save.find(hash);
    if (it != save.end()) {
        return it->second;
    }
    if (k == 1) {
        return n - 1;
    }
    if (n == 1) {
        return 0;
    }
    ll sqrn = sqr_n(n, k);
    ll ans = cacl_m(n, k, sqrn);
    mini(ans, cacl_m(n, k, sqrn + 1));
    save[hash] = ans;
    return ans;
}

ll cacl_m(ll n, ll k, ll m) {
    if (m == 1) {
        return n - 1;
    }
    return std::max(calc(n / m, k - 1), calc((n + m - 1) / m, k)) + m - 1;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    cout << calc(n, std::min(65ull, k * 2));
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

#define DUDE
    int test = 1;
#ifdef DUDE
    cin >> test;
#endif
    while (test--) {
        solve();
        cout << '\n';
    }
    return 0;
};
