#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;


#define pb push_back
#define ff first
#define ss second
#define pp pair
#define ll long long
#define dl long double
#define int long long

template<typename T>
ostream &operator<<(ostream &out, const pair<T, T> &a) {
    out << a.ff << ' ' << a.ss;
    return out;
}

template<typename T>
istream &operator>>(istream &in, pair<T, T> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto i: a) cout << i << '\n';
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a) in >> i;
    return in;
}

const int maxn = 1e3 + 10, inf = 2e9 + 100;

int pred[maxn];
int rankk[maxn];

void init() {
    for (int i = 0; i < maxn; i++) pred[i] = i, rankk[i] = 0;
}

int get(int u) {
    if (u == pred[u]) return u;
    return pred[u] = get(pred[u]);
}

void unite(int u, int v) {
    u = get(u);
    v = get(v);
    if (u != v) {
        if (rankk[u] > rankk[v]) {
            swap(u, v);
        }
        pred[u] = v;
        if (rankk[u] == rankk[v]) {
            rankk[v]++;
        }
    }
}

vector<pair<int, int>> g[maxn];

int dists[maxn][maxn];

void dfs(int v, int par, int dist, int root) {
    dists[root][v] = dists[v][root] = dist;

    for (auto [to, c]: g[v]) {
        if (to == par) continue;
        dfs(to, v, dist + c, root);
    }
}

void solve() {
    int n;
    cin >> n;
    int d[n][n];
    vector<std::array<int, 3>> vert;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
            if (i != j) {
                vert.push_back({d[i][j], i, j});
            }
        }
    init();
    sort(vert.begin(), vert.end());
    for (auto [c, u, v]: vert) {
        if (get(u) != get(v)) {
            unite(u, v);
            g[u].emplace_back(v, c);
            g[v].emplace_back(u, c);
        }
    }
    for (int i = 0; i < n; i++) {
        dfs(i, -1, 0, i);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (d[i][j] != dists[i][j]) {
                cout << "No";
                return;
            }
        }
    }
    cout << "Yes";
}

signed main() {
#ifdef pskobx
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
#ifndef pskobx
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
//    cout << fixed << setprecision(15);
//    cin >> tests;
    while (tests--) solve();
#ifdef pskobx
    //    cout << "\nruntime = " << clock() / 1000.0 << '\n';
#endif
}
