#include <iostream>
#include <vector>

using ll = long long;
constexpr ll MOD = 998'244'353;

ll pow(ll a, int n) {
	if (n == 0) {
		return 1LL;
	}
	ll pw = pow(a, n/2);
	pw = (pw*pw)%MOD;
	if (n%2) {
		pw = (pw*a)%MOD;
	}
	return pw;
}

constexpr int max_n = 300'000;
ll fct[max_n];
ll ifct[max_n];

void count_fct() {
	fct[0] = 1LL;
	ifct[0] = 1LL;
	for (ll i = 1; i < max_n; ++i) {
		fct[i] = (i*fct[i - 1])%MOD;
		ifct[i] = pow(fct[i], MOD - 2);
	}
}

ll C(int n, int k) {
	return (fct[n]*((ifct[k]*ifct[n - k])%MOD))%MOD;
}

ll f(int r, int g, int b) {
	ll ret = 0;
	for (int i = 0; ; ++i) {
		int odd = std::abs(r - b) + 2*i;
		int even = (r + b - odd)/2;
		if (odd > g + 1) {
			break;
		}
		if (odd + even < g + 1) {
			continue;
		}
		ll s = 1LL;
		s = (s*C(g + 1, odd))%MOD;
		s = (s*C(odd, i))%MOD;
		s = (s*pow(2LL, g + 1 - odd))%MOD;
		s = (s*C(even - (g + 1 - odd) + g, g))%MOD;
		ret = (ret + s)%MOD;
	}
	return ret;
}


int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	count_fct();

	int r, g, b;
	std::cin >> r >> g >> b;
	ll ans = f(r, g, b);
	if (g >= 1) {
		ans += 2LL*f(r, g - 1, b);
	}
	if (g >= 2) {
		ans += f(r, g - 2, b);
	}
	ans %= MOD;
	std::cout << ans << '\n';
	
	return 0;
}
