import java.util.ArrayList;
import java.util.Map;
import java.util.Scanner;

public class FTrafic {
    private static final Map<Integer, Integer> encoder = Map.of(
            0, 119,
            1, 18,
            2, 93,
            3, 91,
            4, 58,
            5, 107,
            6, 111,
            7, 82,
            8, 127,
            9,  123
    );
    private static final Map<Integer, Integer> decoder = Map.of(
            119, 0,
            18, 1,
            93, 2,
            91, 3,
            58, 4,
            107, 5,
            111, 6,
            82, 7,
            127, 8,
            123, 9
    );

    private static Integer trafic(int n, int d1, int d2) {
        Integer ans = null;
        int a = n / 10, b = n % 10;
        int first = encoder.get(a), second = encoder.get(b);
        if (a == 0) {
            first = 0;
        }

        first &= d1;
        second &= d2;

        if (decoder.containsKey(first) && decoder.containsKey(second)) {
            first = decoder.get(first);
            second = decoder.get(second);
            ans = first * 10 + second;
        } else if (first == 0 && decoder.containsKey(second)) {
            ans = decoder.get(second);
        }
        return ans;
    }

    public static void main(String[] args) {
        int n = 10;
        int max = 0;
        Scanner sc = new Scanner(System.in);
        int d1 = Integer.parseInt(sc.next(), 2), d2 = Integer.parseInt(sc.next(), 2);

        int k = 0;
        int last = -1;
        for (int i = n; i > 0; --i) {
            Integer newN = trafic(i, d1, d2);
            if (newN != null) {
                if (newN == last + 1) {
                    k++;
                    if (k > max) {
                        max = k;
                    }
                }
                last = newN;
            } else {
                last = -1;
                k = 0;
            }

        }
        System.out.println(max);
    }
}
