#ifdef LOCAL  // -DLOCAL

#include "debug.h"
#include "headers.h"

// #define debug(...) 42

std::ifstream in("test.in");
auto _ = std::cin.rdbuf(in.rdbuf());

#else

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define debug(...) 42
#define assert(...) 42

#endif

using std::array;
using std::bitset;
using std::cin;
using std::cout;
using std::deque, std::priority_queue;
using std::endl;
using std::fstream, std::ifstream, std::ofstream;
using std::get;
using std::ios;
using std::iterator;
using std::list, std::forward_list;
using std::lower_bound, std::upper_bound;
using std::map, std::multimap, std::unordered_map;
using std::pair, std::make_pair;
using std::queue;
using std::set, std::multiset, std::unordered_set;
using std::sort;
using std::stack;
using std::string;
using std::swap;
using std::tie;
using std::tuple, std::make_tuple;
using std::vector;

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;
using vi = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vb = vector<bool>;
using vpi = vector<pi>;
using vpll = vector<pll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using vvb = vector<vb>;
using vvpi = vector<vpi>;
using vvpll = vector<vpll>;

#define all(obj) obj.begin(), obj.end()

void precalc() {
  
}

struct FenwickTree {
  std::vector<int> s;

  static int f(int i) { return i & (i + 1); }

  static int g(int i) { return i | (i + 1); }

  explicit FenwickTree(int n) { s.resize(n, 0); }

  FenwickTree(const std::vector<int> &arr) {
    std::vector<int> pref(arr.size() + 1);
    pref[0] = 0;
    for (int i = 0; i < arr.size(); ++i) {
      pref[i + 1] = pref[i] + arr[i];
    }

    s.resize(arr.size());
    for (int i = 0; i < s.size(); ++i) {
      s[i] = pref[i + 1] - pref[f(i)];
    }
  }

  int getPrefSum(int pos) const {
    int ans = 0;
    for (int i = pos; 0 <= i; i = f(i) - 1) {
      ans += s[i];
    }
    return ans;
  }

  int getSum(int l, int r) const { return getPrefSum(r) - getPrefSum(l - 1); }

  void update(int pos, int value) {
    for (int i = pos; i < s.size(); i = g(i)) {
      s[i] += value;
    }
  }
};

void solve() {
  string s;
  cin >> s;
  ll k;
  cin >> k;

  FenwickTree ft(s.size());

  vvi pos(10);

  for(int i = s.size() - 1; 0 <= i; --i) {
    pos[s[i] - '0'].push_back(i);
  }

  vi ans;
  while(ans.size() != s.size()) {
    for(int d = 0; d < 10; ++d) {
      if (pos[d].empty()) continue; //цифр не осталось
      int dist = pos[d].back() - ft.getPrefSum(pos[d].back());
      if (dist <= k) {
        k -= dist;
        ft.update(pos[d].back(), 1);
        pos[d].pop_back();
        ans.push_back(d);
        break;
      }
    }
  }


  for (auto d: ans) {
    cout << d;
  }
  cout << '\n';
}

int main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  std::cout.precision(15);

  precalc();
  int t = 1;
  std::cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}