#include <algorithm>
#ifdef LOCAL // -DLOCAL

#include "debug.h"
#include "headers.h"

// #define debug(...) 42

std::ifstream in("test.in");
auto _ = std::cin.rdbuf(in.rdbuf());

#else

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#define debug(...) 42
#define assert(...) 42

#endif

using std::array;
using std::bitset;
using std::cin;
using std::cout;
using std::deque, std::priority_queue;
using std::endl;
using std::fstream, std::ifstream, std::ofstream;
using std::get;
using std::ios;
using std::iterator;
using std::list, std::forward_list;
using std::lower_bound, std::upper_bound;
using std::map, std::multimap, std::unordered_map;
using std::pair, std::make_pair;
using std::queue;
using std::set, std::multiset, std::unordered_set;
using std::sort;
using std::stack;
using std::string;
using std::swap;
using std::tie;
using std::tuple, std::make_tuple;
using std::vector;

using ll = long long;
using ld = long double;
using ul = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;
using vi = vector<int>;
using vll = vector<ll>;
using vld = vector<ld>;
using vb = vector<bool>;
using vpi = vector<pi>;
using vpll = vector<pll>;
using vvi = vector<vi>;
using vvll = vector<vll>;
using vvb = vector<vb>;
using vvpi = vector<vpi>;
using vvpll = vector<vpll>;

#define all(obj) obj.begin(), obj.end()

void precalc() {}

struct DSU {
  vi p, r;

  DSU(int n) : p(n, -1), r(n, 1) {}

  int get(int v) {
    return (p[v] == -1 ? v : p[v] = get(p[v]));
  }

  bool merge(int f, int t) {
    t = get(t);
    f = get(f);
    if (t == f) return false;
    if (r[t] < r[f]) {
      swap(f, t);
    }
    p[f] = t;
    r[t] += r[f];
    return true;
  }
};

vector<vector<int>> table;
vector<vector<pi>> adj_l;
vector<vector<int>> check;

void dfs(int p, int v, int start, int s = 0) {
  for (auto [u, d]: adj_l[v]) {
    if (u == p) continue;
    if (table[start][u] == s + d) {
      check[start][u] = true;
    }
    dfs(v, u, start, s + d);
  }
}

void solve() {
  int n;
  cin >> n;
  table.resize(n);
  std::fill(all(table), vi(n));

  for (auto &row : table) {
    for (auto &el : row) {
      cin >> el;
    }
  }

  vector<tuple<int, int, int>> queue;
  for(int v = 0; v < n; ++v) {
    for(int u = v + 1; u < n; ++u) {
      queue.push_back({table[v][u], v, u});
    }
  }

  std::sort(all(queue));

  debug(queue);

  DSU d(n);
  adj_l.resize(n);
  for(auto [dist, v, u] : queue) {
    if(d.merge(v, u)) {
      adj_l[v].emplace_back(u, dist);
      adj_l[u].emplace_back(v, dist);
    }
  }

  for(int v = 0; v < n; ++v) {
    debug(v, adj_l[v]);
  }


  check.resize(n);
  std::fill(all(check), vi(n, false));
  for(int v = 0; v < n; ++v) {
    check[v][v] = true;
    dfs(-1, v, v);
  }

  for(int v = 0; v < n; ++v) {
    for(int u = v + 1; u < n; ++u) {
      if(!check[v][u]) {
        cout << "No" << endl;
        return;
      }
    }
  }
  cout << "Yes" << endl;
}

int main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  std::cout.precision(15);

  precalc();
  int t = 1;
  // std::cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}