#include <bits/stdc++.h>

using namespace std;

struct FenTree {
  int sz;
  long long *t;
  explicit FenTree(int n) : sz(n), t(new long long[n]) {
    fill(t, t + n, 0);
  }
  void add(int i, int delta) {
    for (; i <= sz; i += i & -i) {
      t[i] += delta;
    }
  }
  void assign(int i, int x) { add(i, x - sum(i, i)); }
  long long sum(int r) {
    long long res = 0;
    for (; r > 0; r -= r & -r) {
      res += t[r];
    }
    return res;
  }
  long long sum(int l, int r) { // [l; r]
    return sum(r) - sum(l - 1);
  }
  ~FenTree() { delete[] t; }
};

bitset<100000> skip;

void solve() {
  string s;
  int64_t k;
  cin >> s >> k;
  array<vector<int>, 10> pos{};
  for (int i = 0; i < s.size(); ++i) {
    pos[s[i] - '0'].emplace_back(i);
  }
  array<int, 10> ptr{};
  skip.reset();
  FenTree used(s.size());
  for (int i = 0; i < s.size();) {
    if (skip[i]) {
      ++i;
      continue;
    }
    for (int d = (i == 0); d <= s[i] - '0'; ++d) {
      if (ptr[d] >= pos[d].size()) continue;
      int dpos = pos[d][ptr[d]];
      int need_swaps = dpos - used.sum(dpos);
      if (k >= need_swaps) {
        k -= need_swaps;
        cout << (char)(d + '0');
        skip.set(dpos);
        used.add(i + 1, 1);
        if (i != dpos) used.add(dpos + 1, 1);
        ++ptr[d];
        break;
      }
    }
  }
  cout << '\n';
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }

  return 0;
}
