// #include <bits/stdc++.h>

// using namespace std;

// int INF = INT32_MAX;

// struct Edge {
//     int f = -1;
//     int s = -1;
//     int len = -1;
//     Edge() = default;
// };

// bool operator<(Edge a, Edge b) {
//     return a.len < b.len;
// }

// int distance(int s, int f, vector<vector<pair<int, int>>> &g) {
//     vector<int> dist (g.size(), INF);
//     queue<pair<int, int>> q;
//     dist[s] = 0;
//     q.push({s, 0});
//     while (!q.empty()) {
//         int v, deep;
//         tie (v, deep) = q.front();
//         q.pop();
//         for (auto [u, w] : g[v]) {
//             if (deep + w > dist[u]) continue;
//             dist[u] = deep + w;
//             q.push({u, deep + w});
//         }
//     }
//     return dist[f];
// }

// int main() {
//     ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
//     int n;
//     cin >> n;
//     vector<vector<int>> matr(n, vector<int> (n));
//     vector<vector<pair<int, int>>> graph(n);
//     vector <int> used(n);
//     vector<Edge> edges;
//     for (int i = 0; i < n; i++) {
//         for (int j = 0; j < n; j++) {
//             cin >> matr[i][j];
//             if(j > i){ 
//                 graph[i].push_back({j, matr[i][j]});
//                 graph[j].push_back({i, matr[i][j]});
//                 edges.push_back({i, j,  matr[i][j]});
//             }
//         }
//     }
//     sort(edges.begin(),  edges.end());

//     int it = 1;
//     for (auto i : edges) {
//         int dist = distance(i.f, i.s, graph);
//         dist = min (dist, distance(i.s, i.f, graph));
//         if (dist < i.len) {
//             //cout << dist << " " << i.len << "\n";
//             cout << "No";
//             return 0;
//         }
//         it++;
//     }
//     cout << "Yes";
// }

#include <bits/stdc++.h>
 
using namespace std;
 
int INF = INT32_MAX;
 
struct Edge {
    int f = -1;
    int s = -1;
    int len = -1;
    Edge() = default;
};
 
bool operator<(Edge a, Edge b) {
    return a.len < b.len;
}
 
int distance(int s, int f, vector<vector<pair<int, int>>> &g) {
    vector<int> dists (g.size(), INF);
    vector<int> distf (g.size(), INF);
    queue<tuple<int, int, int>> q;
    dists[s] = 0;
    distf[f] = 0;
    q.push({s, s, 0});
    q.push({f, f, 0});
    while (!q.empty()) {
        int p, v, deep;
        tie (p, v, deep) = q.front();
        q.pop();
        if (p == s){
            for (auto [u, w] : g[v]) {
                if (dists[u] != INF) continue;
                dists[u] = deep + w;
                if (distf[u] != INF) {
                     
                    return dists[u] + distf[u];
                }
                 
                q.push({p, u, deep + w});
            }
        }
        if (p == f){
            for (auto [u, w] : g[v]) {
                if (distf[u] != INF) continue;
                distf[u] = deep + w;
                if (dists[u] != INF) {
                    //cout << s << " " << u << " " << f <<  " " << dists[u] << " " << distf[u] << "\n";
                    return dists[u] + distf[u];
                }
                q.push({p, u, deep + w});
            }
        }
    }
    return INF;
}
 
int main() {
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int> (n));
    vector<vector<pair<int, int>>> graph(n);
    vector <int> used(n);
    vector<Edge> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            if(j > i) edges.push_back({i, j, matr[i][j]});
        }
    }
    sort(edges.begin(),  edges.end());
 
    int it = 1;
    for (auto i :  edges) {
        int dist = distance(i.f, i.s, graph);
        if (dist != i.len && dist != INF) {
            //cout << dist << " " << i.len << "\n";
            cout << "No";
            return 0;
        }
        else if (dist == INF){
            //cout << i.f << " " << i.s << " " << i.len << "\n";
            graph[i.f].push_back({i.s, i.len});
            graph[i.s].push_back({i.f, i.len});
        }

        it++;
    }
    cout << "Yes";
}