#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()


struct dsu {
    vector<int> parent;
    vector<int> sz;
    int numofsets = 0;

    dsu(int n) {
        parent.resize(n);
        sz.resize(n);
        for (int i = 0; i < n; i++) {
            parent[i] = i;
            sz[i] = 1;
        }
        numofsets = n;
    }

    int get(int a) {
        if (parent[a] != a) parent[a] = get(parent[a]);
        return parent[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b)
            return false;
        if (sz[a] < sz[b]) swap(a, b);
        parent[b] = a;
        sz[a] += sz[b];
        sz[b] = 0;
        numofsets--;
        return true;
    }
};

struct edge {
    int a, b;
    ll w;

    bool operator<(const edge &other) {
        return w < other.w ||
               w == other.w && (pi) {a, b} < (pi) {other.a, other.b};
    }
};

vector<vector<pll>> g;
vector<vector<int>> up;
vector<ll> sm, tin, tout;
vector<bool> used;
int timer = 0;
int lg = 15;

void dfs(int start) {
    for (int i = 1; i < lg; i++) up[start][i] = up[up[start][i - 1]][i - 1];
    used[start] = true;
    tin[start] = timer++;
    for (auto[to, w] : g[start]) {
        if (used[to]) continue;
        sm[to] = sm[start] + w;
        up[to][0] = start;
        dfs(to);
    }
    tout[start] = timer++;
}

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v)) return u;
    if (anc(v, u)) return v;
    for (int i = lg - 1; i > -1; i--) {
        if (!anc(up[u][i], v)) u = up[u][i];
    }
    return up[u][0];
}

ll dist(int a, int b) {
    return sm[a] + sm[b] - 2 * sm[lca(a, b)];
}


void solve() {
    int n;
    cin >> n;
    vector<vector<ll>> start(n, vector<ll>(n));
    vector<edge> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> start[i][j];
            if (i == j) continue;
            if (i < j) {
                edges.pb({i, j, start[i][j]});
            }
        }
    }

    g.resize(n);
    up.resize(n);
    for (auto& row : up) row.resize(lg);
    sm.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n);


    sort(all(edges));
    dsu dsu(n);
    for (auto [a, b, w]: edges) {
        if (dsu.unite(a, b)) {
            g[a].pb({b, w});
            g[b].pb({a, w});
        }
    }

    dfs(0);

    bool ok = true;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ok &= dist(i, j) == start[i][j];
        }
    }

    cout << (ok ? "Yes\n" : "No\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}
