#include <iostream>
#include <vector>
#include <map>
#include <cstdint>
#include <cassert>
#include <algorithm>

using namespace std;

int f(const vector<int>& a) {
    int mask = 0;
    for (int x : a) {
        mask |= 1 << (x - 1);
    }
    return mask;
}

int mask[10]{
    f({1, 2, 3, 5, 6, 7}),
    f({3, 6}),
    f({1, 3, 4, 5, 7}),
    f({1, 3, 4, 6, 7}),
    f({2, 4, 3, 6}),
    f({1, 2, 4, 6, 7}),
    f({1, 2, 4, 6, 5, 7}),
    f({1, 3, 6}),
    f({1, 2, 3, 4, 5, 6, 7}),
    f({1, 2, 3, 4, 6, 7}),
};

map<int, int> mask_to_digit;

void solve() {
    for (int d = 0; d < 10; ++d)
        mask_to_digit[mask[d]] = d;
    string s1, s2; cin >> s1 >> s2;
    int mask1 = 0, mask2 = 0;
    for (int i = 0; i < 7; ++i) {
        if (s1[i] == '1')
            mask1 |= 1 << i;
    }
    for (int i = 0; i < 7; ++i) {
        if (s2[i] == '1')
            mask2 |= 1 << i;
    }

    auto calc = [&](int y) {
        vector<int> seq;
        for (int w = y; w >= 1; --w) {
            int d1 = w / 10;
            int d2 = w % 10;
            int x = 0;
            int msk1 = 0;
            if (d1 > 0) {
                msk1 = mask[d1] & mask1;
                if (msk1 > 0) {
                    if (mask_to_digit.count(msk1) && mask_to_digit[msk1] > 0)
                        x += 10 * mask_to_digit[msk1];
                    else
                        break;
                }
            }
            int msk2 = mask[d2] & mask2;
            if (mask_to_digit.count(msk2)) {
                if (mask_to_digit[msk2] == 0 && msk1 == 0)
                    break;
                x += mask_to_digit[msk2];
            }
            else
                break;
            seq.push_back(x);
        }
        if (seq.empty())
            return 0;
        for (int i = 1; i <= seq.size(); ++i) {
            if (i == seq.size() || seq[i] != seq[i - 1] + 1)
                return i - 1;
        }
        assert(0);
    };

    int k = 0;
    for (int y = 1; y <= 99; ++y) {
        int cur = calc(y);
        k = max(k, cur);
    }
    cout << k << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.precision(20);

    solve();
}