#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;
using pll = pair<ll, ll>;
using vii = vector<pii>;
using vll = vector<pll>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    while (t --> 0) {
        solve();
        cout << '\n';
    }

    return 0;
}

const int MAXN = 1010;
const int INF = 2e9;

vll g[MAXN];
int was[MAXN];

void build(int op, int v, int n, vvi& d){
    was[v] = 1;
    set<pll> st;
    for(int i = 0; i < n; i++){
        if(i == op || i == v || was[i]) continue;
        if(d[op][i] == d[v][i] + d[op][v]){
            st.insert({d[v][i], i});
        }
    }

    for(auto [dist, u] : st){
        if(was[u]) continue;
        g[v].pb({u, dist});
        g[u].pb({v, dist});

        build(op, u, n, d);
    }
}

int used[MAXN];
int fl = 0;
void dfs(int v, int p=-1){
    used[v] = 1;
    for(auto [to, w] : g[v]){
        if(to == p) continue;
        if(used[to]){
            fl = 1;
            return;
        }
        dfs(to, v);
    }
}

using vl = vector<ll>;

void calc(int v, vl& dist, int p=-1){
    for(auto [to, w] : g[v]){
        if(to == p) continue;
        dist[to] = dist[v] = w;
        calc(to, dist, v);
    }
}

void solve(){
    int n; cin >> n;
    vvi a(n, vi(n));

    int mn = INF; pii e;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){ cin >> a[i][j];
            if(a[i][j] == 0) continue;
            if(a[i][j] < mn){
                mn = a[i][j];
                e = {i, j};
            }
        }
    }

    g[e.fi].pb({e.se, mn});
    g[e.se].pb({e.fi, mn});

    build(e.fi, e.se, n, a);
    build(e.se, e.fi, n, a);

    for(int i = 0; i < n; i++){
        if(!was[i]){
            cout << "No\n";
            return;
        }
    }

    dfs(e.fi);
    for(int i = 0; i < n; i++){
        if(!used[i]) fl = 1;
    }

    if(fl){
        cout << "No\n";
        return;
    }

/*
    vector dist(n, vl(n, 0));
    for(int i = 0; i < n; i++){
        calc(i, dist[i]);
    }
    */

    cout << "Yes\n";
}