//  ____________
// < Shizerland >
//  ------------
//         \   ^__^
//          \  (oo)\_______
//             (__)\       )\/\
//                 ||----w |
//                 ||     ||

#include <algorithm>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

const long long nmax = 1e6 + 10;
const long long mat = 1e3 + 5;

vector<pair<long long, long long>> g[nmax];

long long table[mat][mat];
long long timer = 1;
long long used[mat];

void dfs(long long v, long long s, long long dist = 0) {
    table[s][v] = dist;
    used[v] = timer;
    for (auto [u, w] : g[v]) {
        if (used[u] != timer) {
            dfs(u, s, dist + w);
        }
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(false);
    long long n;
    cin >> n;
    vector<vector<long long>> vec(n, vector<long long>(n, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> vec[i][j];
        }
    }
    vector<pair<long long, long long>> need;
    for (int i = 0; i < n; ++i) {
        long long mn = 1e10;
        for (int j = i + 1; j < n; ++j) {
            mn = min(vec[i][j], mn);
        }
        for (int j = i + 1; j < n; ++j) {
            if (mn == vec[i][j]) {
                g[i].push_back({j, vec[i][j]});
                g[j].push_back({i, vec[i][j]});
            } else {
                need.push_back({i, j});
            }
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        dfs(i, i);
        timer++;
    }
    for (auto [s, t] : need) {
        if (table[s][t] != vec[s][t]) {
            cout << "NO\n";
            return 0;
        }
    }
    cout << "YES\n";
    return 0;
}
