#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

using namespace std;

int get(vector<int> &snm, int ver) {
    if (snm[ver] == ver) {
        return ver;
    }
    return snm[ver] = get(snm, snm[ver]);
}

long long dist = 0;

bool key = false;

void dfs(vector<vector<pair<int, int>>> &a, int ver, int finish, long long w = 0, int pr = -1) {
    if (ver == finish) {
        dist = w;
        key = true;
        return;
    }
    for (auto &[j, i] : a[ver]) {
        if (i == pr) {
            continue;
        }
        dfs(a, i, finish, w + j, ver);
        if (key) {
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, pair<int, int>>> a;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int val;
            cin >> val;
            if (i < j) {
                a.emplace_back(val, make_pair(i, j));
            }
        }
    }
    vector<int> snm(n);
    vector<int> sz(n, 1);
    for (int i = 0; i < n; ++i) {
        snm[i] = i;
    }
    sort(a.begin(), a.end());
    vector<vector<pair<int, int>>> tree(n);
    for (int i = 0; i < a.size(); ++i) {
        int u = a[i].second.first;
        int v = a[i].second.second;
        int g1 = get(snm, u), g2 = get(snm, v);
        if (g1 != g2) {
            if (sz[g1] < sz[g2]) {
                snm[g1] = g2;
                sz[g2] += sz[g1];
            } else {
                snm[g2] = g1;
                sz[g1] += sz[g2];
            }
            tree[u].emplace_back(make_pair(a[i].first, v));
            tree[v].emplace_back(make_pair(a[i].first, u));
        } else {
            dist = 0;
            key = false;
            dfs(tree, u, v);
            if (dist != a[i].first) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes";
    return 0;
}
