#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<algorithm>
#include<cmath>
#include<cctype>
#include<fstream>
#include<ios>
#include<bitset>
#include<numbers>
#include <random>
#include <set>
#include <array>

using namespace std;
#define sort(a) sort(a.begin(), a.end())
#define reverse(a) reverse(a.begin(), a.end())
#define all(a) a.begin(), a.end()
#define pb push_back
mt19937 rnd(time(nullptr));

typedef long long ll;

struct Node {

};

struct segment_tree {
    vector<int> a;
    vector<int> t, c;
    vector<bool> isset;
    void init(vector<int> cura) {
        a = cura;
        int n = a.size();
        t.resize(4 * n);
        c.resize(4 * n);
        isset.resize(4 * n);
        build(0, 0, n);
    }

    void build(int v, int l, int r) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    int ask(int v, int l, int r, int askl, int askr) {
        if (l >= askr || r <= askl) return 0;
        if (l >= askl && r <= askr) return (isset[v] ? (r - l) * c[v] : t[v]);
        int m = (l + r) / 2;
        push(v, l, r);
        return ask(2 * v + 1, l, m, askl, askr) + ask(2 * v + 2, m, r, askl, askr);
    }

    void push(int v, int l, int r) {
        if (isset[v]) {
            isset[2 * v + 1] = true;
            isset[2 * v + 2] = true;
            c[2 * v + 1] = c[v];
            c[2 * v + 2] = c[v];
            isset[v] = false;
            t[v] = (r - l) * c[v];
        }
    }

    void change(int v, int l, int r, int askl, int askr, int val) {
        if (l >= askr || r <= askl) return;
        if (l >= askl && r <= askr) {
            isset[v] = true;
            c[v] = val;
            return;
        }
        int m = (l + r) / 2;
        push(v, l, r);
        change(2 * v + 1, l, m, askl, askr, val);
        change(2 * v + 2, m, r, askl, askr, val);
        t[v] = (isset[2 * v + 1] ? (m - l) * c[2 * v + 1] : t[2 * v + 1]) + (isset[2 * v + 2] ? (r - m) * c[2 * v + 2] : t[2 * v + 2]);
    }
};


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int test;
    cin >> test;
    while(test--) {
        string s;
        ll k;
        cin >> s >> k;
        int n = s.size();
        string ans = "";
        vector<vector<int>> poses(10, vector<int>());
        for (int i = n - 1; i >= 0; --i) {
            int val = s[i] - '0';
            poses[val].push_back(i);
        }
        segment_tree t;
        vector<bool> used(n, false);
        t.init(vector<int>(n, 1));
        for (int it = 0; it < n; ++it) {
            int pos = -1;
            for (int lev = 1; lev <= 9; ++lev) {
                if (poses[lev].size() != 0) {
                    int curpos = poses[lev].back();
                    int dist = t.ask(0, 0, n, 0, curpos);
                    if (curpos == 0) dist = 0;
                    if (dist <= k) {
                        k -= dist;
                        used[curpos] = true;
                        t.change(0, 0, n, curpos, curpos + 1, 0);
                        ans += s[curpos];
                        poses[lev].pop_back();
                        pos = 1;
                        break;
                    }
                }
            }
            if (pos == -1) break;
        }
        for (int i = 0; i < n; ++i) {
            if (!used[i]) ans += s[i];
        }
        cout << ans << '\n';
    }
}




