#include <algorithm>
#include <array>
#include <cmath>
#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

using ll = long long;

ll log2(ll n) {
    int result = 0;
    while (n > 1) {
        n = (n + 1) >> 1;
        ++result;
    }
    return result;
}

unordered_map<ll, unordered_map<ll, __int128>> cache;

__int128 f(ll k, ll ans) {
    if (cache.count(k) && cache[k].count(ans)) {
        return cache[k][ans];
    } else if (k == 2) {
        cache[k][ans] = (__int128)ans * (ans + 1) / 2 + 1;
        return cache[k][ans];
    } else if (ans == 0) {
        cache[k][ans] = 1;
        return cache[k][ans];
    }
    cache[k][ans] = f(k, ans - 1) + f(k - 1, ans - 1);
    return cache[k][ans];
}

// int hello1();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    // hello1();
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        ll n, k;
        cin >> n >> k;
        if (k > log2(n) * 2) {
            cout << log2(n) << "\n";
        } else {
            ll l = -1, r = 2000'000'000ll;
            if (k > 1) {
                r = 1000'000;
            }
            while (r - l > 1) {
                ll m = (l + r + 1) / 2;
                if (f(k * 2, m) >= n) {
                    r = m;
                } else {
                    l = m;
                }
            }
        }
        cout << flush;
    }
    return 0;
}
