#include <algorithm>
#include <array>
#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

#define MODULO 998'244'353

vector<ll> fact(1000000);

ll pow(ll a, ll b) {
    if (b == 0) {
        return 1;
    } else if (b % 2) {
        return pow(a, b - 1) * a % MODULO;
    }
    ll p = pow(a, b / 2);
    return p * p % MODULO;
}

ll inv(ll a) { return pow(a, MODULO - 2); }

ll C(ll n, ll k) {
    if (n < k)
        return 0;
    return fact[n] * inv(fact[k]) % MODULO * inv(fact[n - k]) % MODULO;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    fact[0] = 1;
    for (int i = 1; i < fact.size(); ++i) {
        fact[i] = fact[i - 1] * i % MODULO;
    }
    ll r, g, b;
    cin >> r >> g >> b;
    ll result = 0;
    for (ll rseg = 1; rseg <= r; ++rseg) {
        for (ll grseg : {-1, 0, 0, 1}) {
            ll gseg = rseg + grseg;
            if (gseg == 0 || gseg > g)
                continue;
            ll bb = b - (r - rseg) - (g - gseg);
            if (bb < 0)
                continue;
            result = (result + C(r - 1, rseg - 1) * C(g - 1, gseg - 1) % MODULO *
                               C(rseg + gseg + 1, bb) % MODULO) %
                     MODULO;
        }
    }
    cout << result << endl;
    return 0;
}
