#include <algorithm>
#include <bits/stdc++.h>
#include <tuple>
#include <vector>

using namespace std;
using i64 = int64_t;
using ll = int64_t;

#define all(x) x.begin(), x.end()

void solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; 
    cin >> t;
    while(t --> 0) {
        solve();
    }
    return 0;
}

const int inf = 2e9;
vector<ll> a;

struct node {
    // left and right children
    node* lc = 0, * rc = 0;
    // segment left and right border [l;r)
    int l, r;
    ll infs = 0, mins = -1;
 
    node(int _l, int _r) {
        l = _l, r = _r;
        if (l == r - 1) {
            infs = a[l] == inf;
            mins = l;
            return;
        }
        else {
            int c = (l + r) / 2;
            lc = new node(l, c);
            rc = new node(c, r);
            
            infs = lc->infs + rc->infs;
            mins = (a[lc->mins] <= a[rc->mins]) ? lc->mins : rc->mins;
        }
    }
    ll get_sum(int _l, int _r) {
        if (l >= _l && r <= _r) {
            return infs;
        }
        if (l >= _r || r <= _l) {
            return 0;
        }
        return lc->get_sum(_l, _r) + rc->get_sum(_l, _r);
    }
    ll get_min(int _l, int _r) {
        if (l >= _l && r <= _r) {
            return mins;
        }
        if (l >= _r || r <= _l) {
            return -1;
        }
        int lq = lc->get_min(_l, _r);
        int rq = rc->get_min(_l, _r);
        if (lq == -1) return rq;
        if (rq == -1) return lq;
        return (a[lq] <= a[rq]) ? lq : rq;
    }
    // edit single element to inf
    void edit(int _ind) {
        if (l == _ind && r == _ind + 1) {
            infs = a[l] == inf;
            mins = 0;
            return;
        }
        if (lc->r > _ind) 
            lc->edit(_ind);
        else 
            rc->edit(_ind);
        infs = lc->infs + rc->infs;
        int lq = lc->mins;
        int rq = rc->mins;
        if (lq == -1) infs = rq;
        else if (rq == -1) infs = lq;
        else mins = (a[lq] <= a[rq]) ? lq : rq;
    }
    
};
 
 
 
void solve() {
    string s;
    cin >> s;
    ll k;
    cin >> k;
    int n = s.size();
    for (int i = 0; i < n; ++i) {
        a[i] = s[i];
    }
 
    node root(0, n);
    string ans(n, '\0');
    for (int i = 0; i < n; ++i) {
        i64 r = k + i; 
        r = min<i64>(n - 1, r);
        int ind = root.get_min(0, r + 1);
        k -= max(0, ind - i);
        ans[i] = s[ind];
        root.edit(ind);
    }
    cout << ans << '\n';

}
