#include <iostream>
#include <algorithm>
#include <vector>
#define ll long long

using namespace std;

constexpr ll MOD = 998'244'353;

struct dsu {
  vector<int> dd;
  
  void init(int n) {
    dd.resize(n);
    for (int i = 0; i < n; i++) {
      dd[i] = i;
    }
  }

  int find(int h) {
    return (dd[h] == h ? h : dd[h] = find(dd[h]));
  }

  bool unite(int x, int y){
    x = find(x);
    y = find(y);
    if (x != y) {
      dd[x] = y;
      return true;
    }
    return false;
  }
};

ll in[10005], out[10005], ds[10005];
vector<vector<int>> dst;
vector<int> cc[1005];
ll tm = 0;
ll bn[10005][15];

bool is_ancestor(int x, int y) {
  return in[x] <= in[y] && out[x] >= out[y];
}

int get_ancestor(int x, int y) {
  if (is_ancestor(x, y)) {
    return x;
  }
  if (is_ancestor(y, x)) {
    return y;
  }
  for (int i = 10; i > -1; i--) {
    if (!is_ancestor(bn[x][i], y)) {
      x = bn[x][i];
    }
  }
  return bn[x][0];
}

int get_dist(int x, int y) {
  int p = get_ancestor(x, y);
  return ds[x] + ds[y] - 2 * ds[p]; 
}

void dfs(int h, int p = 0) {
  in[h] = tm++;
  bn[h][0] = p;
  ds[h] = ds[p] + dst[h][p];
  for (int i = 1; i < 11; i++) {
    bn[h][i] = bn[bn[h][i - 1]][i - 1];
  }
  for (auto to : cc[h]) {
    if (to != p) {
      dfs(to, h);
    }
  }
  out[h] = tm++;
}

void solve() {
  ll n;
  cin >> n;
  dst.resize(n, vector<int>(n));
  vector<pair<int, pair<int, int>>> edges;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      int x;
      cin >> x;
      dst[i][j] = x;
      edges.push_back({x, {i, j}});
    }
  }
  dsu snm;
  snm.init(n);
  sort(edges.begin(), edges.end());
  for (auto [h, p] : edges) {
    int x = p.first, y = p.second;
    if (snm.unite(x, y)) {
      cc[x].push_back(y);
      cc[y].push_back(x);
    }
  }
  dfs(0);
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      if (get_dist(i, j) != dst[i][j]) {
        cout << "No" << endl;
        return;
      }
    }
  }
  cout << "Yes" << endl;
}

int main() {
  ll t = 1;
  while (t--) {
    solve();
  }
}

/*
6 1 3
1 5 8
5 3 2
6 5 9
2 1 4
2 4 6
1 2
12 3
15 6
4 3
10 2
*/