#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

struct edge {
    long long d;
    int u, v;
};

void solve()
{
    int n;
    cin >> n;
    vector<vector<long long>> d(n, vector<long long>(n));
    vector<vector<long long>> curr(n, vector<long long>(n, -1));
    for (int i = 0; i < n; ++i) {
        curr[i][i] = 0;
    }
    vector<edge> e;
    vector<bool> node(n, false);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
            if (i < j) {
                e.push_back({d[i][j], i, j});
            }
        }
    }
    sort(all(e), [](const edge& x, const edge& y){
        return x.d < y.d;
    });
    for (auto [dist, u, v] : e) {
        if (curr[u][v] == dist) {
            continue;
        }
        if (curr[u][v] == -1) {
            node[u] = true;
            node[v] = true;
            curr[u][v] = curr[v][u] = dist;
            for (int i = 0; i < n; i++) {
                if (node[i] && i != u && i != v) {
                    if (curr[v][i] != -1) {
                        curr[u][i] = curr[i][u] = curr[u][v] + curr[v][i];
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                if (node[i] && i != u && i != v) {
                    if (curr[u][i] != -1) {
                        curr[v][i] = curr[i][v] = curr[v][u] + curr[u][i];
                    }
                }
            }
        } else {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}

int32_t main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int tt = 1;
    while (tt--)
    {
        solve();
    }
}