﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

struct Point {
    int x, y;
};

double calculateArea(Point a, Point b, Point c) {
    return 0.5 * abs(a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y));
}

int main() {
    int n;
    cin >> n;

    vector<Point> points(n);
    vector<Point> onXAxis; 
    vector<Point> aboveXAxis; 

    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
        if (points[i].y == 0) {
            onXAxis.push_back(points[i]);
        }
        else if (points[i].y > 0) {
            aboveXAxis.push_back(points[i]);
        }
    }

    double maxArea = 0.0;

    for (size_t i = 0; i < onXAxis.size(); ++i) {
        for (size_t j = i + 1; j < onXAxis.size(); ++j) {
            Point a = onXAxis[i];
            Point b = onXAxis[j];

            for (const auto& c : aboveXAxis) {
                double area = calculateArea(a, b, c);
                maxArea = max(maxArea, area);
            }
        }
    }

    cout << fixed << setprecision(9) << maxArea << endl;

    return 0;
}
