// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt")
// #pragma GCC target("avx,avx2")

#include <algorithm>
#include <unordered_map>
#pragma GCC optimize("Ofast,unroll-loops")

// #define FAST_ALLOCATOR_MEMORY 2.5e8

// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define forn(i, n) for (ll i = 0; i < (ll)(n); i++)

std::random_device dev;
std::mt19937 rng(dev());
ll mod = 1e9 + 7;
std::uniform_int_distribution<std::int64_t> uid(1, 1e9);

struct custom_hash {
  static uint64_t splitmix64(uint64_t x) {
    x += 0x9e3779b97f4a7c15;
    x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
    x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
    return x ^ (x >> 31);
  }

  size_t operator()(uint64_t x) const {
    static const uint64_t FIXED_RANDOM =
        std::chrono::steady_clock::now().time_since_epoch().count();
    return splitmix64(x + FIXED_RANDOM);
  }
};

struct pair_hash {
  template <class T1, class T2>
  std::size_t operator()(const std::pair<T1, T2> &p) const {
    auto h1 = std::hash<T1>{}(p.first);
    auto h2 = std::hash<T2>{}(p.second);
    return h1 ^ h2;
  }
};

static const int NON_PRESENT = 1e9;

struct Treap {
  struct Node {
    int init;
    vector<int> pos = vector<int>(10, NON_PRESENT);

    int size;
    Node *l, *r, *p;

  private:
    friend class Treap;
    Node(int size, Node *l, Node *r, Node *p) : size(size), l(l), r(r), p(p) {}
  };

  Node *const pnull;

  Treap() : pnull(new Node{0, nullptr, nullptr, nullptr}) {
    pnull->l = pnull->r = pnull->p = pnull;
  }

  void update(Node *node) const {
    node->pos.assign(10, NON_PRESENT);
    auto add = node->l->size + 1;

    node->pos[node->init] = add;

    if (node->l != pnull) {
      forn(i, 10) { node->pos[i] = min(node->pos[i], node->l->pos[i]); }
    }
    if (node->r != pnull) {
      forn(i, 10) { node->pos[i] = min(node->pos[i], add + node->r->pos[i]); }
    }
  }

  void split(Node *v, Node *&l, Node *&r, int by_idx) const {
    if (v == pnull) {
      l = pnull;
      r = pnull;
      return;
    }
    if (v->l->size < by_idx) {
      split(v->r, v->r, r, by_idx - v->l->size - 1), l = v;
    } else {
      split(v->l, l, v->l, by_idx), r = v;
    }

    if (l != pnull) {
      l->size = l->l->size + l->r->size + 1;
      l->l->p = l->r->p = l;
      update(l);
    }
    if (r != pnull) {
      r->size = r->l->size + r->r->size + 1;
      r->l->p = r->r->p = r;
      update(r);
    }
  }

  void merge(Node *&v, Node *l, Node *r) const {
    if (l == pnull || r == pnull) {
      v = (l != pnull ? l : r);
      return;
    }
    if (uid(rng) % (l->size + r->size + 1) <= l->size) {
      merge(l->r, l->r, r), v = l;
    } else {
      merge(r->l, l, r->l), v = r;
    }
    if (v != pnull) {
      v->size = v->l->size + v->r->size + 1;
      v->l->p = v->r->p = v;
    }
    update(v);
  }

  Node *alloc_node() {
    allocated.push_back(new Node{1, pnull, pnull, pnull});
    return allocated.back();
  }

  ~Treap() {
    for (auto node : allocated) {
      delete node;
    }
    delete pnull;
  }

  void print(Node *node) {
    if (node->l != pnull) {
      print(node->l);
    }
    cout << node->init;
    // cout << "(";
    // for (int i = 1; i < 10; ++i) {
    //   cout << node->pos[i] << " ";
    // }
    // cout << ") ";
    if (node->r != pnull) {
      print(node->r);
    }
  }

private:
  std::vector<Node *> allocated;
};

void solve() {
  string s;
  ll k;
  cin >> s >> k;

  Treap treap;

  int n = s.size();

  Treap::Node *root = nullptr;

  forn(i, n) {
    auto node = treap.alloc_node();
    auto val = s[i] - '0';
    node->init = val;

    treap.update(node);

    if (root == nullptr) {
      root = node;
    } else {
      treap.merge(root, root, node);
    }
  }

  // treap.print(root);
  // cout << endl;

  Treap::Node *ans = nullptr;
  while (root != treap.pnull && k > 0) {
    Treap::Node *right;
    treap.split(root, root, right, k + 1);

    auto pos = root->pos;

    treap.merge(root, root, right);

    forn(i, 10) {
      if (pos[i] == NON_PRESENT) {
        continue;
      }
      auto cost = pos[i] - 1;
      // cout << cost << endl;
      if (k < cost) {
        Treap::Node *left;
        treap.split(root, left, root, cost - k);
        if (ans == nullptr) {
          ans = left;
        } else {
          treap.merge(ans, ans, left);
        }
        cost = k;
      }

      k -= cost;

      Treap::Node *left;
      treap.split(root, left, root, root->pos[i]);

      Treap::Node *single;
      treap.split(left, left, single, left->size - 1);

      treap.merge(root, left, root);

      if (ans == nullptr) {
        ans = single;
      } else {
        treap.merge(ans, ans, single);
      }
      break;
      // treap.print(root);
      // discard left
    }
  }

  if (ans == nullptr) {
    ans = root;
  }  else {
    treap.merge(ans, ans, root);
  }
  treap.print(ans);
  cout << "\n";
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  int t = 1;
  cin >> t;
  // t = readInt();

  while (t--) {
    solve();
  }
  return 0;
}