#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define fst first
#define snd second
#define sz(X) (int)(X).size()
#define all(X) X.begin(), X.end()
#define forn(i, n) for (int i = 0; i < int(n); i++)
#define fornr(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define forab(i, a, b) for(int i = int(a); i < int(b); i++)
#define forabr(i, a, b) for(int i = int(b)-1; i >= int(a); i--)

# define M_PI        3.14159265358979323846

typedef double dbl;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 1e3;
int pr[N];

int get(int v) {
  return v == pr[v] ? v : pr[v] = get(pr[v]);
}

bool unite(int v, int u) {
  v = get(v), u = get(u);
  if (v == u) return 0;
  pr[u] = v;
  return 1;
}

void init(int n) {
  forn (i, n) pr[i] = i;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    vector<vi> a(n, vi(n));
    forn(i, n){
        forn(j, n){
            cin >> a[i][j];
        }
    }
    forn(i, n){
        forab(j, i + 1, n) {
            forn(k, n) {
                if (a[i][j]>a[i][k]+a[k][j]){
                    cout << "No\n";
                    return 0;
                }
            }
        }
    }
    vector<pair<int, pii>> edges;
    forn(i, n){
        forab(j, i + 1, n) {
            edges.push_back({a[i][j], {i, j}});
        }
    }
    sort(all(edges));

    init(n);
    int cnt = 0;
    vector<vector<pii>> g(n);
    for (auto p : edges){
        int u = p.snd.fst;
        int v = p.snd.snd;
        if (unite(u, v)){
            cnt++;
            g[u].push_back({p.fst, v});
            g[v].push_back({p.fst, u});
        }
    }
    if (cnt!=n-1){
        cout << "No\n";
        return 0;
    }
    forn(i, n){
        vi d(n, -1);
        queue<int> q;
        d[i] = 0;
        q.push(i);
        while (!q.empty())
        {
            int v = q.front();
            q.pop();
            for (auto p : g[v]){
                int u = p.snd;
                int w = p.fst;
                if (d[u]==-1){
                    q.push(u);
                    d[u] = d[v] + w;
                }
            }
        }
        if (a[i] != d){
            cout << "No\n";
            return 0;
        }
        
    }
    cout << "Yes\n";
    return 0;
}