#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <utility>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
#include <bitset>
#include <cassert>
#include <functional>
#include <numeric>

using namespace std;

#define ll long long
#define uint unsigned int
#define ld long double
#define X first
#define Y second
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define vii vector<pair<int, int>>
#define vvi vector<vector<int>>
#define INF INT_MAX
// #define int long long

struct Edge {
    int w, a, b;
};


bool cmp(const Edge &lhs, const Edge &rhs) {
    return lhs.w < rhs.w;
}

vector<Edge> edges;
vvi a;
vector<vector<Edge>> graph;
vector<int> used, dist;
int timer = 1;
bool flag = true;
vector<int> parent;
vector<int> rang;

void make_set (int v) {
    parent[v] = v;
    rang[v] = 0;
}

int find_set (int v) {
    if (v == parent[v])
        return v;
    return parent[v] = find_set (parent[v]);
}

void union_sets (int a, int b) {
    a = find_set (a);
    b = find_set (b);
    if (a != b) {
        if (rang[a] < rang[b])
            swap (a, b);
        parent[b] = a;
        if (rang[a] == rang[b])
            ++rang[a];
    }
}

void dfs(int v, int p, int d, int start) {
    dist[v] = d + (p != -1 ? dist[p] : 0);
    if (dist[v] != a[start][v]) {
        flag = false;
        return;
    }
    for (auto &e: graph[v]) {
        int u = (e.a == v ? e.b : e.a);
        if (u != p)
            dfs(u, v, e.w, start);
        if (!flag)
            return;
    }
}

void solve(int n) {
    parent.resize(n);
    rang.resize(n);
    dist.resize(n);
    for (int i = 0; i < n; ++i)
        make_set(i);

    int m = edges.size();
    for (int i = 0; i < m; ++i) {
        auto &e = edges[i];
        int sa = find_set(e.a);
        int sb = find_set(e.b);
        if (sa == sb)
            continue;
        union_sets(e.a, e.b);
        graph[e.a].push_back(e);
        graph[e.b].push_back(e);
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, -1, 0, i);
        if (!flag)
            return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    a.resize(n, vector<int> (n));
    graph.resize(n);
    used.resize(n);
    edges.resize(n * n - n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            edges.push_back({a[i][j], i, j});
        }
    sort(all(edges), cmp);
    solve(n);
    cout << (flag ? "Yes" : "No");
    return 0;
}
