import java.util.SortedSet
import kotlin.random.Random

private fun readln() = readLine()!!
private fun readlnLong() = readln().toLong()

private fun readlnStrings() = readln().split(' ')
private fun readlnInts() = readlnStrings().map { it.toInt() }
private fun readlnLongs() = readlnStrings().map { it.toLong() }

private fun isWhiteSpace(c: Char) = c in " \r\n\t"
private fun readString() = generateSequence { System.`in`.read().toChar() }
    .dropWhile { isWhiteSpace(it) }.takeWhile { !isWhiteSpace(it) }.joinToString("")

private fun readInt() = readString().toInt()
private fun readLong() = readString().toLong()
private fun readFloat() = readString().toFloat()
private fun readDouble() = readString().toDouble()
private fun readBigInt(radix: Int = 10) = readString().toBigInteger(radix)
private fun readBigDecimal() = readString().toBigDecimal()
private fun readInts(n: Int) = generateSequence { readInt() }.take(n)
private fun readLongs(n: Int) = generateSequence { readLong() }.take(n)
private fun readFloats(n: Int) = generateSequence { readFloat() }.take(n)
private fun readDoubles(n: Int) = generateSequence { readDouble() }.take(n)

fun solve() {
    val s = readString()

    var balance = -1
    var ans = 0
    for (i in s) {
        if (i== '{') {
            balance++
        } else if (i == '}') {
            balance--
            if (balance == 0) {
                ans++
            }
        }
    }

    println(ans)
}

fun main() {
    var n = 1
//    n = readInt()
    repeat(n) {
        solve()
    }
}