#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define all(a) a.begin(), a.end()

using namespace std;
using ll = int64_t;

const int INF = 1e18;

mt19937 rnd(1000 - 7);

void print(auto &v) {
    for (auto &x : v) {
        cout << x << " ";
    }
    cout << endl;
}

int n;
vector<vector<int>> w;
vector<vector<int>> g;

vector<vector<int>> d;

void dfs(int root, int v, int p = -1, int sz = 0) {
    d[v][v] = 0;
    if (g[v].size() == 1 && p != -1) {
        d[root][v] = d[v][root] = sz;
        return;
    }

    for (auto& u : g[v]) {
        if (u != p) {
            d[root][v] = d[v][root] = sz;
            dfs(root, u, v, sz + w[u][v]);
        }
    }
}

ll head(vector<int> &dsu, int u) {
    if (dsu[u] == u) return u;
    return dsu[u] = head(dsu, dsu[u]);
}

void merge(vector<int> &dsu, int u, int v) {
    u = head(dsu, u);
    v = head(dsu, v);
    if (u == v) return;
    if (rnd() % 2) {
        dsu[u] = v;
    } else {
        dsu[v] = u;
    }
}

void solve() {
    cin >> n;

    w.resize(n, vector<int>(n, 0));

    set<vector<int>> edges;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;

            w[i][j] = x;

            edges.insert({ x, i, j });
        }
    }
    vector<vector<ll>> graph(n);
    vector<ll> dsu(n);
    for (int i = 0; i < n; i++) {
        dsu[i] = i;
    }
    for (auto v : edges) {
        if (head(dsu, v[1]) != head(dsu, v[2])) {
            merge(dsu, v[1], v[2]);
            graph[v[1]].push_back(v[2]);
            graph[v[2]].push_back(v[1]);
        }
    }

    g = graph;
    d.assign(n, vector<int>(n, -1));

    for (int i = 0; i < n; ++i) {
        dfs(i, i);
    }

    if (w == d) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
}



main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    while (t--)
        solve();
}
