﻿#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <algorithm>

using namespace std;

#define int long long





class Korn
{
private:
	int C = 317;
	int l = 0;
	vector<vector<char>> m;
	vector<int> pcm;
	int getroughminpos(vector<char>& v, int r)
	{
		int res = 0;
		for (int i = 1; i < r; i++)
			if (v[i] < v[res])
				res = i;
		return res;
	}
	void erase(vector<char>& v, int ind)
	{
		for (int i = ind; i < v.size() - 1; i++)
			swap(v[i], v[i + 1]);
		v.pop_back();
	}
public:
	Korn(vector<char>& v, int c) : C(c)
	{
		m.resize(v.size() / C + 5);
		l = v.size();
		for (int i = 0; i < v.size(); i++)
			m[i / C].push_back(v[i]);
		pcm.resize(m.size());
		for (int i = 0; i < pcm.size(); i++)
		{
			pcm[i] = 0;
			for (int j = 0; j < m[i].size(); j++)
				if (m[i][j] < m[i][pcm[i]])
					pcm[i] = j;
		}
	}
	pair<char, int> getminpos(int r)
	{
		pair<char, int> res = { '9' + 1, 1e9};
		int sum = 0;
		for (int i = 0; i < m.size(); i++)
		{
			if (m[i].size() == 0)
				continue;
			if (sum + m[i].size() > r)
			{
				int ind = getroughminpos(m[i], sum + m[i].size() - r);
				res = min(res, { m[i][ind], sum + ind });
				return res;
			}
			else if (sum + m[i].size() == r)
			{
				int ind = getroughminpos(m[i], m[i].size());
				res = min(res, { m[i][ind], sum + ind });
				return res;
			}
			else
			{
				res = min(res, { m[i][pcm[i]], sum + pcm[i] });
				sum += m[i].size();
			}
		}
		return res;
	}
	void erase(int ind)
	{
		int i = 0;
		l--;
		while (ind >= m[i].size())
		{
			ind -= m[i].size();
			i++;
		}
		erase(m[i], ind);
		pcm[i] = getroughminpos(m[i], m[i].size());
	}
	int size()
	{
		return l;
	}
	void print()
	{
		for (auto& i : m)
			for (auto& j : i)
				cout << j;
	}
};

void _69$()
{
	string a;
	int k;
	cin >> a >> k;
	if (k == 0)
	{
		cout << a << '\n';
		return;
	}
	vector<char> b;
	for (auto& i : a)
		b.push_back(i);
	Korn korn(b, 369);
	while (k > 0 && korn.size())
	{
		auto c = korn.getminpos(min(k + 1, korn.size()));
		cout << c.first;
		korn.erase(c.second);
		k -= c.second;
	}
	korn.print();
	cout << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		_69$();
	return 0;
}