﻿#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <ctime>

using namespace std;

typedef long long ll;

#define mp make_pair

struct DSU {
    vector<int> p;
    vector<int> sz;
    void create(int n) {
        p.resize(n);
        sz.resize(n, 1);
        for (int i = 0; i < n; ++i) p[i] = i;
    }
    int get(int v) {
        if (p[v] == v) return v;
        else return p[v] = get(p[v]);
    }
    bool un(int v, int u) {
        int pv = get(v);
        int pu = get(u);
        if (pv == pu) return 0;
        if (sz[pv] >= sz[pu]) {
            p[pu] = pv;
            sz[pv] += sz[pu];
        }
        else {
            p[pv] = pu;
            sz[pu] += sz[pv];
        }
        return 1;
    }
};

bool OK = true;

void dfs(int v, vector<vector<int>>& a, vector<vector<int>>& m, vector<int>& ds, vector<vector<int>>& g, int d, int s) {
    ds[v] = d;
    for (int u : a[v]) {
        if (ds[u] == -1) {
            if (g[v][u] == -1) {
                int t = m[s][u] - d;
                if (t <= 0) {
                    OK = false;
                }
                g[v][u] = g[u][v] = t;
            }
            dfs(u, a, m, ds, g, d + g[v][u], s);
        }
    }

}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> m(n, vector<int>(n));
    vector<pair<int, pair<int, int>>> a;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> m[i][j];
            if (i < j) {
                a.push_back({ m[i][j], {i, j} });
            }
        }
    }
    sort(a.begin(), a.end());
    DSU dsu;
    dsu.create(n);
    vector<vector<int>> g(n);
    for (auto p : a) {
        int d = p.first;
        int v = p.second.first;
        int u = p.second.second;
        if (dsu.get(v) != dsu.get(u)) {
            dsu.un(v, u);
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }
    vector<vector<int>> rm(n, vector<int>(n, -1));
    vector<vector<int>> G(n, vector<int>(n, -1));
    for (int i = 0; i < n; i++) {
        dfs(i, g, m, rm[i], G, 0, i);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (m[i][j] != rm[i][j]) {
                OK = false;
            }
        }
    }

    /*cout << "====\n";
    for (int i = 0; i < n; i++) {
        cout << i + 1 << ": ";
        for (int u : g[i]) {
            cout << u + 1 << ' ';
        }
        cout << '\n';
    }
    cout << "====\n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << G[i][j] << ' ';
        }
        cout << '\n';
    }
    cout << "====\n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << rm[i][j] << ' ';
        }
        cout << '\n';

    }
    cout << "====\n";*/

    if (OK) {
        cout << "Yes\n";
    }
    else {
        cout << "No\n";
    }
}