#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <vector>
#include <set>
#include <iostream>
#include <cstdint>
using namespace std;

long long n;

void dfs(long long v, long long len, vector <vector <long long>>& gr, vector <long long>& ans, vector <bool>& used) {
    ans[v] = len;
    used[v] = true;
    for (long long u = 0; u < n; ++u) {
        long long d = gr[v][u];
        if (d != -1 && !used[u]) {
            dfs(u, len + d, gr, ans, used);
        }
    }
}

bool chek(long long v, long long u, long long l, vector <vector <long long>>& truelen, vector <vector<long long>>& ans) {
    if (ans[v][u] != -1) {
        return ans[v][u] == l;
    }
    vector <bool> used(n, false);
    used[v] = true;
    vector <long long> nw(n, -1);
    nw[v] = 0;
    dfs(u, l, ans, nw, used);
    for (long long i = 0; i < n; ++i) {
        if (nw[i] != -1) {
            if (nw[i] != truelen[v][i]) {
                return false;
            }
        }
    }
    return true;
}

void merge(set <pair<long long, pair<long long, long long>>>& a, set<pair <long long, pair<long long, long long>>>& b, set<long long>& con) {
    for (auto i : b) {
        if (con.find(i.second.first)==con.end())
            a.insert(i);
    }
}
int main() {
    cin >> n;
    vector <vector <long long>> trueLen(n, vector <long long>(n, 0));
    vector < set <pair<long long, pair<long long, long long>>>> sorted(n);
    set < pair<long long, pair<long long, long long>>> nw;
    vector <vector <long long>> ans(n, vector <long long>(n, -1));
    for (long long i = 0; i < n; ++i) {
        for (long long j = 0; j < n; ++j) {
            long long a;
            cin >> a;
            if (i != j) {
                trueLen[i][j] = a;
                sorted[i].insert({ trueLen[i][j], {j, i} });
            }
        }
    }
    nw = sorted[0];
    set <long long> con;
    con.insert(0);
    while (nw.size() != 0) {
        long long len, v, u;
        len = nw.begin()->first;
        v = nw.begin()->second.first;
        u = nw.begin()->second.second;
        nw.erase(nw.begin());
        if (con.find(v) == con.end()) {
            if (chek(v, u, len, trueLen, ans)) {
                ans[v][u] = len;
                ans[u][v] = len;
                merge(nw, sorted[v], con);
                sorted[v].clear();
                con.insert(v);
            } else {
                cout << "NO";
                return 0;
            }
        }
    }
    cout << "YES";
    return 0;
}
