#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
#define ll long long
#define ull unsigned long long

struct st {
    int n;
    vector<char> tree;
    st(vector<char> data) {
        n = data.size();
        tree.resize(4 * n);
        build(data, 0, 0, n - 1);
    }

    char getm(int l, int r) {
        return getm(0, 0, n - 1, l, r);
    }
    char getm(int node, int start, int end, int l, int r) {
        if (r < start || end < l) return 60;
        if (l <= start && end <= r) return tree[node];
        int mid = (start + end) / 2;
        char leftMin = getm(2 * node + 1, start, mid, l, r);
        char rightMin = getm(2 * node + 2, mid + 1, end, l, r);
        return std::min(leftMin, rightMin);
    }
    void update(int index, char value) {
        update(0, 0, n - 1, index, value);
    }


    void build(const vector<char>& data, int node, int start, int end) {
        if (start == end)  tree[node] = data[start];

        else {
            int mid = (start + end) / 2;
            build(data, 2 * node + 1, start, mid);
            build(data, 2 * node + 2, mid + 1, end);
            tree[node] = min(tree[2 * node + 1], tree[2 * node + 2]);
        }
    }


    void update(int node, int start, int end, int index, char value) {
        if (start == end)  tree[node] = value;

        else {
            int mid = (start + end) / 2;
            if (start <= index && index <= mid) {
                update(2 * node + 1, start, mid, index, value);
            }
            else {
                update(2 * node + 2, mid + 1, end, index, value);
            }
            tree[node] = min(tree[2 * node + 1], tree[2 * node + 2]);
        }
    }
};

string solve(string s, ull k) {
    ull n = s.size();
    //  st sss(vector<char>(s.begin(), s.end()));

    for (ull i = 0; i < n; ++i) {
        if (k <= 0) break;
        ull mP = i;
        for (int j = i + 1; j < n && j <= i + k; ++j)  if (s[j] < s[mP]) mP = j;

        if (mP != i) {

            ull moves = mP - i;

            for (ull j = mP; j > i; --j) std::swap(s[j], s[j - 1]);

            //sss.update(i, s[i]);

            k -= moves;
        }
    }
    return s;
}

int main() {
    std::cin.tie(0);
    std::ios_base::sync_with_stdio(false);

    ull t;
    cin >> t;
    while (t--) {
        string s;
        ull k;
        cin >> s >> k;
        cout << solve(s, k) << '\n';
    }
    return 0;
}
