#include <bits/stdc++.h>

//namespace std {
//    std::ifstream input_file("rmq.in");
//    std::ofstream out_file("rmq.out");
//
//#define cin input_file
//#define cout out_file
//}

namespace tools {

    template<typename T>
    using vec = std::vector<T>;
    template<typename T>
    using mat = std::vector<std::vector<T>>;
    using str = std::string;
    using i64 = long long int;
    using u64 = unsigned long long int;
    using f64 = long double;

    static void fastIO() {
        std::ios_base::sync_with_stdio(false);
        std::cout.tie(nullptr);
        std::cin.tie(nullptr);
        std::cout.precision(12);
        std::fixed(std::cout);
    }

    template<typename T>
    auto& operator>>(std::istream& in, std::vector<T>& a) {
        for (T& elem: a) in >> elem; return in;
    }

    template<typename T>
    auto& operator<<(std::ostream& out, std::vector<T> const& a) {
        for (T const& elem: a) out << elem << ' '; return out;
    }


    std::mt19937_64 rn(std::chrono::steady_clock::now().time_since_epoch().count());
//    std::mt19937_64 rn(4);

} // namespace tools

using namespace tools;
//using namespace std;
using std::cin, std::cout, std::endl;

#define endl '\n'

void solver();

int32_t main() {
    fastIO();

    int T = 1;
//    cin >> T;

    while (T--) {
        solver();
    }
}

class DSU {
private:
    vec<int> parent;
    vec<int> rang;
public:
    explicit DSU(int n):
            parent(n),
            rang(n, 0)
    {
        std::iota(parent.begin(), parent.end(), 0);
    }

    int get_parent(int i) {
        return parent[i] = (i == parent[i] ? i : get_parent(parent[i]));
    }

    bool same_set(int i, int j) {
        return get_parent(i) == get_parent(j);
    }

    void unite(int i, int j) {
        i = get_parent(i);
        j = get_parent(j);
        if (i == j) return;
        if (rang[i] == rang[j]) rang[i]++;
        if (rang[i] < rang[j]) std::swap(i, j);
        parent[j] = i;
    }

};

struct edge {
    i64 cost;
    int i;
    int j;

    bool operator<(const edge& other) const {
        return (cost < other.cost) || (cost == other.cost && i < other.i) || (cost == other.cost && i == other.i && j < other.j);
    }

};

void solver() {
    int n; cin >> n;
    vec<i64> G(n * n, 0);
    vec<edge> ed;
    ed.reserve(n * (n - 1) / 2);
    DSU dsu(n);

#define ind(i, j) n * i + j

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> G[ind(i, j)];
            if (i > j) {
                ed.push_back({G[ind(i, j)], i, j});
            }
        }
    }

    vec<vec<std::pair<i64, int>>> nG(n);
    std::sort(ed.begin(), ed.end());

    for (auto [cost, i, j]: ed) {
        if (!dsu.same_set(i, j)) {
            dsu.unite(i, j);
            nG[i].emplace_back(cost, j);
            nG[j].emplace_back(cost, i);
        }
    }

//    for (int i = 0; i < n; ++i) {
//        cout << i << " | ";
//        for (auto [c, j]: nG[i]) {
//            cout << c << ':' << j << ' ';
//        }
//        cout << endl;
//    }

    vec<i64> shortest(n * n, 1e9);
    int start = 0;

    std::function<void(int, i64, int)> dfs = [&](int node, i64 have, int before = -1) {
        for (auto [cost, to]: nG[node]) {
            if (to == before) continue;
            shortest[ind(start, to)] = std::min<i64>(shortest[ind(start, to)], have + cost);
            dfs(to, have + cost, node);
        }
    };

    for (; start < n; ++start) {
        dfs(start, 0, -1);
        shortest[ind(start, start)] = 0;
    }

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) {
//            cout << shortest[ind(i, j)] << ' ';
//        }
//        cout << endl;
//    }

    if (shortest == G) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }
}
