#include <iostream>
#include<vector>
#include<map>
#include<algorithm>
using namespace std;
map<int, vector<int>> paths;
vector<bool> visited(1000, false);
int distances[1000][1000];

void dfs(int vertex, int layer) {
    visited[vertex] = true;
    for (int i : paths[vertex]) {
        if (!visited[i]) {
            distances[layer][i] = distances[layer][vertex] + distances[vertex][i];
            dfs(i, layer);
        }
    }
}

void solve() {
    int n; cin >> n;
    vector<pair<int, pair<int, int>>> a;
    int original[1000][1000];

    int x;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x;
            original[i][j] = x;


            if (j < i) {
                a.push_back({ x, {i, j} });
            }
        }
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n - 1; i++) {
        distances[a[i].second.first][a[i].second.second] = a[i].first;
        distances[a[i].second.second][a[i].second.first] = a[i].first;
        paths[a[i].second.first].push_back(a[i].second.second);
        paths[a[i].second.second].push_back(a[i].second.first);
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            visited[j] = false;
        }
        visited[i] = true;
        distances[i][i] = 0;
        dfs(i, i);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (original[i][j] != distances[i][j]) {
                cout << "No";
                return;
            }
        }
    }
    cout << "Yes";
}

signed main() {
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}