#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<pair<int, int>> points;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        points.emplace_back(x, y);
    }

    int min_x = 1001, max_x = -1001;
    for (pair<int, int> point : points) {
        if (point.second == 0) {
            if (point.first < min_x) {
                min_x = point.first;
            }
            if (point.first > max_x) {
                max_x = point.first;
            }
        }
    }

    if (min_x == 1001 || max_x == -1001 || min_x == max_x) {
        cout << 0;
        return 0;
    }

    int max_height = 0;
    for (pair<int, int> point : points) {
        if (point.second != 0) {
            max_height = max(max_height, abs(point.second));
        }
    }

    if (max_height == 0) {
        cout << 0;
        return 0;
    }

    int base = abs(max_x - min_x);
    int max_area1 = base * max_height / 2;
    int max_area2 = (base * max_height * 5) % 10;

    cout << max_area1 << '.' << max_area2;
    return 0;
}
