#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <queue>
#include <random>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <array>
#include <deque>

using namespace std;

long long mod = 998244353;

// random_device rd;
// mt19937 gen(rd());

// long long binPow(long long a, long long p)
// {
//     if (p == 0 || a == 1) {return 1;}
//     a %= mod;
//     if (p % 2 == 0) {return binPow(a * a % mod, p / 2) % mod;}
//     return (a * binPow(a, p - 1)) % mod;
// }

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p);

template<class T>
istream& operator>> (istream& in, vector<T>& vec)
{
    for (T& i: vec) {in >> i;}
    return in;
}

template<class T1, class T2>
istream& operator>> (istream& in, pair<T1, T2>& p)
{
    in >> p.first >> p.second;
    return in;
}

long long factorial(int n) {
    long long result = 1;
    for (int i = 2; i <= n; ++i) {
        result = (result * i) % mod;
    }
    return result;
}

long long modInverse(long long a, long long m) {
    long long m0 = m, y = 0, x = 1;
    if (m == 1) return 0;

    while (a > 1) {
        long long q = a / m;
        long long t = m;

        m = a % m;
        a = t;
        t = y;

        y = x - q * y;
        x = t;
    }

    if (x < 0) x += m0;

    return x;
}

long long countArrangements(int r, int g, int b) {
    int counts[3] = {r, g, b};
    sort(counts, counts + 3);

    int max_count = counts[2];
    int mid_count = counts[1];
    int min_count = counts[0];

    if (max_count > mid_count + min_count + 1) {
        return 0;
    }

    int total = r + g + b;

    long long result = factorial(total);
    result = (result * modInverse(factorial(r), mod)) % mod;
    result = (result * modInverse(factorial(g), mod)) % mod;
    result = (result * modInverse(factorial(b), mod)) % mod;

    return result;
}

void solve() {
    int n;
    cin >> n;

    vector<vector<long long>> d(n, vector<long long>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
        }
    }

    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (d[i][j] > d[i][k] + d[k][j]) {
                    cout << "No" << endl;
                    return;
                }
            }
        }
    }

    cout << "Yes" << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    for (;t > 0; --t)
    {
        solve();
    }
}
