#include <iostream>
#include <cmath>
using namespace std;

struct coord {
    short x;
    short y;
};

double triangleArea(coord& A, coord& B, coord& C) {
    return fabs(A.x * (B.y - C.y) + B.x * (C.y - A.y) + C.x * (A.y - B.y)) / 2.0;
}

int main() {
    short n;
    cin >> n;

    coord* arr = new coord[n];

    for (short i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].y;
    }

    short maxX = -1001;
    short minX = 1001;
    coord* maxPoint = nullptr;
    coord* minPoint = nullptr;

    for (short i = 0; i < n; i++) {
        if (arr[i].y == 0) {
            if (arr[i].x > maxX) {
                maxX = arr[i].x;
                maxPoint = &arr[i];
            }
            if (arr[i].x < minX) {
                minX = arr[i].x;
                minPoint = &arr[i];
            }
        }
    }

    if (maxPoint == nullptr || minPoint == nullptr || maxX == minX) {
        cout << 0 << endl;
        delete[] arr;
        return 0;
    }

    double area = 0, marea = 0;

    for (short i = 0; i < n; i++) {
        if (arr[i].y != 0) {
            area = triangleArea(*maxPoint, *minPoint, arr[i]);
            if (area > marea) {
                marea = area;
            }
        }
    }

    cout << marea << endl;

    delete[] arr;

}
