#include <bits/stdc++.h>

using namespace std;

double dist(double x1, double y1, double x2, double y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

double heron(double x1, double y1, double x2, double y2, double x3, double y3) {
    double a = dist(x1, y1, x2, y2);
    double b = dist(x1, y1, x3, y3);
    double c = dist(x2, y2, x3, y3);
    double p = (a + b + c) / 2.0;
    return sqrt(p * (p - a) * (p - b) * (p - c));
}

int main() {
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> xs(n), ys(n);
    for (int i = 0; i < n; i++) {
        cin >> xs[i] >> ys[i];
    }
    int l = -1, r = -1;
    for (int i = 0; i < n; i++) {
        if (ys[i] == 0) {
            if (l == -1 || xs[i] < xs[l]) {
                l = i;
            }
            if (r == -1 || xs[i] > xs[r]) {
                r = i;
            }
        }
    }
    if (r == l) {
        cout << 0;
        return 0;
    }
    double ans = 0;
    for (int i = 0; i < n; i++) {
        if (i != l & i != r) {
            ans = max(ans, heron(xs[i], ys[i], xs[l], ys[l], xs[r], ys[r]));
        }
    }
    cout.precision(30);
    cout << ans;
    
    return 0;
}
