from functools import lru_cache
# from math import factorial as f


mod = 998244353
@lru_cache(maxsize=200000)
def dummy_solve(r, g, b, last=''):
    if max(r, g, b) == 0:
        return 1
    ans = 0
    if r > 0 and last != 'r':
        ans += dummy_solve(r - 1, g, b, 'r')
    if g > 0 and last != 'g':
        ans += dummy_solve(r, g - 1, b, 'g')
    if b > 0 and last != 'b':
        ans += dummy_solve(r, g, b - 1, 'b')
    return ans % mod


MX = 10 ** 6
PW = [1] * MX
FACT = [1] * MX
INV_FACT = [1] * MX
for i in range(1, len(FACT)):
    FACT[i] = FACT[i - 1] * i % mod

def binpow(a, n):
    result = 1
    a = a % mod

    while n > 0:
        if n % 2 == 1:
            result = (result * a) % mod
        a = (a * a) % mod
        n //= 2

    return result

INV_FACT[MX - 1] = binpow(FACT[MX-1], mod - 2)


for i in range(MX - 1, 0, -1):
    INV_FACT[i - 1] = INV_FACT[i] * i % mod

for i in range(1, len(PW)):
    PW[i] = 2 * PW[i - 1] % mod


def pow2(n):
    return 2 ** n % mod

def f(n):
    return FACT[n]

def f_(n):
    return INV_FACT[n]

def C(n, k):
    return f(n) * f_(k) % mod * f_(n - k) % mod




def choose(n, a, b):
    return C(n, a + b) * C(a + b, a) % mod

def brain_internal(num_blocks, g, b):
    if num_blocks == 0:
        if g == 0 and b == 0:
            return 1
        return 0
    ans = 0
    for cnt_g in range(0, g + 1):
        g_paired = g - cnt_g
        cnt_b = b - g_paired
        if cnt_b < 0:
            continue
        if num_blocks - (cnt_b + cnt_g) < 0:
            continue
        even_blocks = num_blocks - (cnt_b + cnt_g)
        if cnt_b + even_blocks > b:
            continue
        if cnt_g + even_blocks > g:
            continue
        cur = choose(num_blocks, cnt_b, cnt_g)
        cur *= pow2(num_blocks - (cnt_b + cnt_g))
        cur %= mod
        pairs_left = (b + g - cnt_b - cnt_g - even_blocks * 2)
        if pairs_left < 0 or pairs_left % 2 != 0:
            continue
        pairs_left //= 2
        cur *= C(pairs_left + num_blocks - 1, num_blocks - 1)
        cur %= mod
        ans += cur
        ans %= mod
    return ans


def smart_solve(r, g, b):
    return (brain_internal(r + 1, g, b) + brain_internal(r, g, b) * 2 + brain_internal(r - 1, g, b)) % mod


print(smart_solve(*map(int, input().split())))
