#include <bits/stdc++.h>


// #define __INTERACTIVE_TASK_
// #define __OPT_PRAGMAS__
#if (!defined(__LOCAL_CLANGD_CPP__)) && (!defined(__LOCAL_DEBUG__)) && defined(__OPT_PRAGMAS__)
#	pragma GCC optimize("O3")
#	pragma GCC optimize("unroll-loops")
#	pragma GCC target("avx2,avx,sse4,sse4.1,sse4.2,bmi,bmi2,lzcnt,popcnt")
#endif

#ifndef __LOCAL_ANY_CPP__
#	define __local_run_(code)
#	define __prod_run_(code) \
		do {              \
			code;     \
		} while (0);
#	define __local_stmt_(stmt)
#	define __prod_stmt_(stmt) stmt
#else
#	define __local_run_(code) \
		do {               \
			code;      \
		} while (0);
#	define __prod_run_(code)
#	define __local_stmt_(stmt) stmt
#	define __prod_stmt_(stmt)
#endif


using namespace std;

using ll = long long;
using ull = unsigned long long;
using iii = __int128_t;
using uiii = __uint128_t;
using if32 = int_fast32_t;
using uf32 = uint_fast32_t;
// #define int ll

using vll = vector<ll>;
using vull = vector<ull>;

#define citers(container) (container).begin(), (container).end()

template <typename T> static inline ostream & cvout(const T & farg) { return cout << farg; }

template <typename T, typename... Args>
static inline ostream & cvout(const T & farg, const Args &... args)
{
	cout << farg;
	return cvout(args...);
}

static inline ostream & cvoutnl [[maybe_unused]] ()
{
#if defined(__INTERACTIVE_TASK_) || defined(__LOCAL_DEBUG__)
	return cout << endl;
#else
	return cout << '\n';
#endif
}

template <typename T, typename... Args>
static inline ostream & cvoutnl(const T & farg, const Args &... args)
{
	cout << farg;
	return cvoutnl(args...);
}

template <typename T> static inline istream & cvin(T & farg) { return cin >> farg; }

template <typename T, typename... Args> static inline istream & cvin(T & farg, Args &... args)
{
	cin >> farg;
	return cvin(args...);
}

static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

static inline void _reopen_stdinout [[maybe_unused]] (const char * in, const char * out)
{
	freopen(in, "r", stdin);
	freopen(out, "w", stdout);
}


struct kaban
{
	ll modulo, s, f;
	constexpr kaban(ll modulo, ll s, ll f) : modulo(modulo), s(s), f(f) {}
	constexpr kaban() : modulo(0), s(0), f(0) {}
};

vector<kaban> solve(const vector<ll> & diff, ll s, ll f)
{
	vector<kaban> res;
	ll cur_gcd = diff[s + 1];
	ll cur_begin = s;
	ll cur = s + 2;
	for (; cur <= f; ++cur)
	{
		ll new_gcd = gcd(cur_gcd, diff[cur]);
		if (new_gcd == 1)
		{
			res.emplace_back(cur_gcd, cur_begin + 1, cur);
			cur_gcd = diff[cur];
			cur_begin = cur - 1;
		}
		else { cur_gcd = new_gcd; }
	}
	res.emplace_back((cur_gcd == 0) ? (2) : (cur_gcd), cur_begin + 1, f + 1);
	return res;
}


signed main()
{
	_io_speedup();
	// _reopen_stdinout("input.txt", "output.txt");

	ll n;
	cvin(n);
	vector<ll> a(n), diff(n);
	cvin(a[0]);
	for (ll i = 1; i < n; ++i)
	{
		cvin(a[i]);
		diff[i] = abs(a[i] - a[i - 1]);
	}
	ll s, f;
	cvin(s, f);
	--s;
	--f;
	bool is_reversed = false;
	if (s > f)
	{
		swap(s, f);
		is_reversed = true;
	}

	for (ll i = s + 1; i <= f; ++i)
	{
		if (diff[i] == 1)
		{
			cvoutnl("Impossible");
			return 0;
		}
	}

	vector<kaban> sol = solve(diff, s, f);
	vector<kaban> real_sol(sol.size());
	if (is_reversed)
	{
		ll sz = sol.size();
		for (ll i = 0; i < sz; ++i)
		{
			ll revi = sz - i - 1;
			real_sol[i] = kaban{sol[revi].modulo, sol[revi].f, sol[revi].s};
		}
	}
	else { real_sol = sol; }

	for (const kaban & i : real_sol) { cvoutnl("Kaban-", i.modulo, ' ', i.s, ' ', i.f); }

	return 0;
}