#include <cstdint>
#include <cstdio>

uint64_t solve(const uint64_t r, const uint64_t g, const uint64_t b,
               const char added_ball = 'n') {
  if (r + g + b == 0) {
    return 1;
  }

  uint64_t res = 0;

  if (added_ball != 'r' && r > 0)
    res += solve(r - 1, g, b, 'r');

  if (added_ball != 'g' && g > 0)
    res += solve(r, g - 1, b, 'g');

  if (added_ball != 'b' && b > 0)
    res += solve(r, g, b - 1, 'b');

  return res % 998'244'353;
}

bool check(uint64_t const &r, uint64_t const &g, uint64_t const &b) {
  return !(r > g + b + 1 || g > r + b + 1 || b > r + g + 1);
}

int main() {
  uint64_t r, g, b;
  scanf("%ld %ld %ld", &r, &g, &b);

  if (check(r, g, b)) {
    printf("%ld\n", solve(r, g, b));
  } else {
    printf("0\n");
  }

  fflush(stdout);
  return 0;
}
