import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Geom {
    record Pair(int x, int y) {}
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(br.readLine());
        List<Pair> onOX = new ArrayList<>();
        List<Pair> notOnOX = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            String[] line = br.readLine().split(" ");
            Pair point = new Pair(Integer.parseInt(line[0]),
                                  Integer.parseInt(line[1]));
            if (point.y() == 0)
                onOX.add(point);
            else
                notOnOX.add(point);
        }
        if (onOX.size() < 2 || notOnOX.isEmpty()) {
            System.out.println("0");
            return;
        }
        int minX = onOX.get(0).x();
        int maxX = onOX.get(0).x();
        for (Pair pair : onOX) {
            minX = Math.min(pair.x(), minX);
            maxX = Math.max(pair.x(), maxX);
        }
        double maxY = 0.;
        for (Pair pair : notOnOX) {
            double abs = Math.abs((double) pair.y());
            maxY = Math.max(abs, maxY);
        }
        if ((maxX - minX) <= 0 || maxY <= 0) {
            System.out.println(0);
            return;
        }
        System.out.printf("%.10f", ((double) (maxX - minX)) * maxY / 2.);
    }
}
