import java.util.Scanner;

public class Game {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // Количество кучек
        int[] piles = new int[n];

        for (int i = 0; i < n; i++) {
            piles[i] = scanner.nextInt(); // Размеры кучек
        }

        // Проверяем, может ли Алиса выиграть
        if (canWin(piles)) {
            System.out.println("Alice");
        } else {
            System.out.println("Dmitry");
        }
    }

    private static boolean canWin(int[] piles) {
        // Проверяем базовый случай: если все кучки пустые
        boolean allEmpty = true;
        for (int pile : piles) {
            if (pile > 0) {
                allEmpty = false;
                break;
            }
        }

        if (allEmpty) {
            return false; // Текущий игрок проигрывает
        }

        // Перебираем все возможные ходы
        for (int i = 0; i < piles.length; i++) {
            if (piles[i] > 0) {
                // Создаем новый массив для следующего состояния игры
                int[] newPiles = piles.clone();
                newPiles[i]--; // Убираем один камень из текущей кучки

                // Проверяем, может ли соперник выиграть из нового состояния
                if (!canWin(newPiles)) {
                    return true; // Если соперник не может выиграть, значит текущий игрок выигрывает
                }
            }
        }

        return false; // Если все ходы приводят к выигрышу соперника, то текущий игрок проигрывает
    }
}
