def is_tree_matrix(n, matrix):
    # Проверка треугольного неравенства
    for i in range(n):
        for j in range(n):
            for k in range(n):
                # Проверяем условие треугольного неравенства
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return "No"

    # Сбор рёбер в граф, построенный на основе матрицы
    edges = []
    for i in range(n):
        for j in range(i + 1, n):
            if matrix[i][j] > 0:  # Добавляем ребро только если расстояние положительное
                edges.append((i, j, matrix[i][j]))

    # Создаем структуру графа для DFS
    from collections import defaultdict

    graph = defaultdict(list)
    for u, v, w in edges:
        graph[u].append(v)
        graph[v].append(u)

    # DFS для проверки связности
    visited = [False] * n

    def dfs(node):
        visited[node] = True
        for neighbor in graph[node]:
            if not visited[neighbor]:
                dfs(neighbor)

    # Начинаем DFS с первой вершины
    dfs(0)

    # Проверяем, все ли вершины были посещены
    if not all(visited):
        return "No"

    return "Yes"

# Ввод данных
n = int(input().strip())  # Считываем размер матрицы
matrix = [list(map(int, input().strip().split())) for _ in range(n)]  # Считываем матрицу

result = is_tree_matrix(n, matrix)  # Проверяем, является ли матрица деревянной
print(result)  # Выводим результат