def is_tree_matrix(n, matrix):
    # Проверяем, что все элементы на главной диагонали равны нулю и что все остальные положительные
    for i in range(n):
        for j in range(n):
            if i == j:
                if matrix[i][j] != 0:
                    return "No"
            elif matrix[i][j] <= 0:
                return "No"

    # Проверка на треугольное неравенство, избегая сложного условия для всех троек
    for k in range(n):
        for i in range(n):
            for j in range(n):
                if i != j and i != k and j != k:
                    if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                        return "No"

    # Проверка связности (количество рёбер должно быть n - 1)
    edges_count = sum(1 for i in range(n) for j in range(i + 1, n) if matrix[i][j] > 0)

    if edges_count != n - 1:
        return "No"

    return "Yes"

# Ввод данных
n = int(input().strip())
matrix = [list(map(int, input().strip().split())) for _ in range(n)]

result = is_tree_matrix(n, matrix)
print(result)