MOD = 998244353 
 
def factorial_mod(n, mod):    
    if n == 0 or n == 1: 
        return 1    
    result = 1 
    for i in range(2, n + 1):      
        result = (result * i) % mod 
    return result 

def count_arrangements(r, g, b): 
    n = r + g + b 
    M = max(r, g, b) 
    if M > (n + 1) // 2: 
        return 0 
    fact_n = factorial_mod(n, MOD)    
    fact_r = factorial_mod(r, MOD) 
    fact_g = factorial_mod(g, MOD)    
    fact_b = factorial_mod(b, MOD) 
    inverse_fact_r = pow(fact_r, MOD - 2, MOD) 
    inverse_fact_g = pow(fact_g, MOD - 2, MOD)    
    inverse_fact_b = pow(fact_b, MOD - 2, MOD) 
    arrangements = fact_n * inverse_fact_r % MOD 
    arrangements = arrangements * inverse_fact_g % MOD    
    arrangements = arrangements * inverse_fact_b % MOD 
    return arrangements 

r, g, b = map(int, input().split()) 
result = count_arrangements(r, g, b)
print(result)
