#include <iostream>
#include <vector>
#include <string>
#include <algorithm> // Include this for sort and min_element functions

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    long long t;
    cin >> t;
    cin.ignore(); // To ignore the newline after reading t

    while (t--) {
        string line;
        getline(cin, line);

        // Find s and k in the input line
        size_t space_idx = line.find(' ');
        string s_str = line.substr(0, space_idx);
        long long k = stoll(line.substr(space_idx + 1));

        long long n = s_str.size();
        vector<char> result;
        long long start_idx = 0;

        // If k is large enough to sort the entire string
        if (k >= n * (n - 1) / 2) {
            sort(s_str.begin(), s_str.end());
            cout << s_str << "\n";
            continue;
        }

        // Process to find the minimum n-digit number with up to k swaps
        while (k > 0 && start_idx < n) {
            // Define the range we need to check for the minimal swap
            long long limit = min(k + 1, n - start_idx);
            auto min_it = min_element(s_str.begin() + start_idx, s_str.begin() + start_idx + limit);
            long long min_idx = distance(s_str.begin(), min_it);
            long long swaps_needed = min_idx - start_idx;

            // Update k and result, and move start index past min digit
            k -= swaps_needed;
            result.push_back(*min_it);
            s_str.erase(s_str.begin() + min_idx);
            n--; // Decrease n as we've processed one character
        }

        // Append any remaining digits to result
        result.insert(result.end(), s_str.begin() + start_idx, s_str.end());

        // Output the result for this test case
        for (char c : result) cout << c;
        cout << "\n";
    }

    return 0;
}

