#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

void find_min_number(string& s, long long k) {
    int n = s.size();
    
    for (int i = 0; i < n && k > 0; ++i) {
        // Find the minimum digit in the range [i, min(n-1, i + k)]
        int min_pos = i;
        for (int j = i + 1; j < n && j - i <= k; ++j) {
            if (s[j] < s[min_pos]) {
                min_pos = j;
            }
        }

        // If min_pos is the same as i, continue to the next iteration
        if (min_pos == i) {
            continue;
        }

        // Move the found minimum digit to the position `i`
        // Decrease `k` by the number of swaps needed (min_pos - i)
        for (int j = min_pos; j > i; --j) {
            swap(s[j], s[j - 1]);
        }
        k -= (min_pos - i);
    }
    
    cout << s << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    
    while (t--) {
        string s;
        long long k;
        cin >> s >> k;
        find_min_number(s, k);
    }
    
    return 0;
}

