#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

// Function to generate the smallest possible number by swapping with constraints
string getSmallestNumber(string s, long long k) {
    int n = s.size();
    vector<pair<char, int>> pos_val;  // Store pairs of (digit, original_position)
    
    // Fill the vector with digits and their initial positions
    for (int i = 0; i < n; i++) {
        pos_val.emplace_back(s[i], i);
    }
    
    // Sort by value (and implicitly by position because we use stable_sort)
    stable_sort(pos_val.begin(), pos_val.end());

    for (int i = 0; i < n && k > 0; i++) {
        // Find the smallest number that can be swapped within the allowed number of moves
        int j = i;
        while (j < n && pos_val[j].second < i) {
            j++;
        }
        
        // Calculate the number of swaps required to bring pos_val[j] to position i
        int swaps_needed = pos_val[j].second - i;

        if (swaps_needed <= k) {
            // Execute the swap, bring pos_val[j] to the i-th position
            k -= swaps_needed;
            for (int p = pos_val[j].second; p > i; p--) {
                swap(s[p], s[p - 1]);
            }
            // Update positions after the swap
            pos_val[j].second = i;
        }
    }

    return s;
}

int main() {
    int t;
    cin >> t;
    vector<string> results;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        // Compute the smallest possible number for each test case
        results.push_back(getSmallestNumber(s, k));
    }

    // Output all results at once
    for (const auto &res : results) {
        cout << res << '\n';
    }

    return 0;
}

